








// Nextag DHTML Calendar and Date Picker
// Date: 6/21/2004
// Version: @{#}CVS versionInfo: $Id: picker.js,v 1.17.276.6 2007/03/05 21:22:22 cc Exp $

// months as they appear in the calendar's title
var ARR_MONTHS = ["January", "February", "March", "April", "May", "June",
		"July", "August", "September", "October", "November", "December"];
// week day titles as they appear on the calendar
var ARR_WEEKDAYS = ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"];

// Localization
var ARR_MONTHS_DE = [ "Januar", "Februar", "M&#228;rz", "April", "M&#246;gen", "Juni",
		"Juli", "August", "September", "Oktober", "November", "Dezember" ];
var ARR_WEEKDAYS_DE = ["So", "Mo", "Di", "Mi", "Do", "Fr", "Sa"];

var ARR_MONTHS_FR = [ "Janvier", "F&#232;vrier", "Mars", "Avril", "Peuvent", "Juin",
		"Juillet", "Ao&#251;t", "Septembre", "Octobre", "Novembre", "D&#232;cembre" ] ;
var ARR_WEEKDAYS_FR = ["Di", "Lu", "Ma", "Me", "Je", "Ve", "Sa"];

// path to the directory where calendar images are stored. trailing slash req.
var STR_ICONPATH = '/js/calendar/img';

var FormDate = (function(){

	function constFunc(params){
	  /** private static variables **/
		var mName = params["name"];
		var mDate = new Date();
		var autoAdjustYear =params["autoAdjustYear"];
		var mElementMonth = document.getElementById(params["elemMonthId"]);
		if (mElementMonth != null)
			mElementMonth.formDate = this;
		var mElementDay = document.getElementById(params["elemDayId"]);
		if (mElementDay != null)
			mElementDay.formDate = this;
		var mElementYear = document.getElementById(params["elemYearId"]);
		if (mElementYear != null)
			mElementYear.formDate = this;
		var mElementDate = document.getElementById(params["elemDateId"]);
		if (mElementDate != null)
			mElementDate.formDate = this;

		var showOneYear = params["showOneYear"];

		/** privileged instance methods **/
		this.setDate = function(d){
			if (d instanceof Date){
				// special case where setting day to 31 will
				// increment the month (bug 22264)
				if (mDate.getDate() > 27){
					mDate.setDate(27);
				}
				mDate.setMonth(d.getMonth());
				mDate.setDate(d.getDate());
				mDate.setFullYear(d.getFullYear());
			} else {
				var arr = d.split('/');
				var isValid = arr.length == 3 && !isNaN(arr[0]) && !isNaN(arr[1]) && !isNaN(arr[2]);
				if (isValid){
					var formatDate = params["formatDate"];
					if(arr[2].length == 2)
						arr[2] = 20 + arr[2];
					if ( formatDate != 'mm/dd/yyyy' ) {
						this.setDate(new Date((arr[2]-1),arr[1],(arr[0]-1)));
					} else {
						this.setDate(new Date((arr[2]-1),(arr[0]-1),arr[1]));
					}
				}
			}
			this.updateFormElements();
		}

		this.getDate = function(){
			return mDate;
		}

		this.updateFormElements = function(){
			if (mElementMonth != null)
				mElementMonth.value = (mDate.getMonth()+1);
			if (mElementDay != null)
				mElementDay.value = mDate.getDate();
			if (mElementYear != null)
				mElementYear.value = mDate.getFullYear();
			if (mElementDate != null) {
				var formatDate = params["formatDate"];	
				if ( formatDate != 'mm/dd/yyyy' ) 
					mElementDate.value = (mDate.getDate() < 10 ? "0" : "") + mDate.getDate() + "/" + (mDate.getMonth()+1 < 10 ? "0" : "") + (mDate.getMonth()+1) + "/" + mDate.getFullYear();
				else
					mElementDate.value = (mDate.getMonth()+1 < 10 ? "0" : "") + (mDate.getMonth()+1) + "/" + (mDate.getDate() < 10 ? "0" : "") + mDate.getDate() + "/" + mDate.getFullYear(); 
					
			}
		}

		this.elementChanged = function(ev){
			var target = NextagDCalendar.getTargetElement(ev);
			if ( mElementMonth != undefined && target.id == mElementMonth.id)
				mDate.setMonth((mElementMonth.value-1));
			else if ( mElementDay != undefined && target.id == mElementDay.id)
				mDate.setDate(mElementDay.value);
			else if (mElementYear != undefined && target.id == mElementYear.id)
				mDate.setFullYear(mElementYear.value);
			else if ( mElementDate != undefined && target.id == mElementDate.id)
				target.formDate.setDate(mElementDate.value);
				
			var visMin = new Date(); visMin.setDate(visMin.getDate()-1);
			var visMax = new Date(); visMax.setDate(visMin.getDate()+(showOneYear?365:0));
			var d = null;
			if (showOneYear){	// if user wants to restrict days by a year starting from TODAY
				if(autoAdjustYear) {	// add a year if day < today i.e. autoAdjustYear
	                                if (target.formDate.getDate() < visMin){
	                                        d = new Date(target.formDate.getDate());
	                                        d.setFullYear(d.getFullYear()+1);
	                                        target.formDate.setDate(d);
	                                } else if (target.formDate.getDate() > visMax){   //subtract a year if day > a year later i.e. autoAdjustYear
	                                        d = new Date(target.formDate.getDate());
	                                        d.setFullYear(d.getFullYear()-1);
	                                        target.formDate.setDate(d);
	                                }
        	                } else {	// leave the day to visMin if day < today i.e. no autoadjust
	                                if ( target.formDate.getDate() < visMin)
	                                        target.formDate.setDate(visMin);
	                                else if ( target.formDate.getDate() > visMax) // leave the day to visMax if day > a year later i.e. noautoadjust
	                                        target.formDate.setDate(visMax);
	                        }

			} 
			target.formDate.updateFormElements();
			if (target.parentCalendar){
				NextagDCalendar.fireDateChangeEvent(target.parentCalendar);
			}
		}

	    /** constructor body **/
	    if (params["date"] != null)
	    {
			this.setDate(params["date"]);
		}
		// need to register for onChange event for all form elements
		// on change, update this
		if (mElementMonth != null)
			NextagDCalendar.addEvent(mElementMonth, "change", this.elementChanged);
		if (mElementDay != null)
			NextagDCalendar.addEvent(mElementDay, "change", this.elementChanged);
		if (mElementYear != null)
			NextagDCalendar.addEvent(mElementYear, "change", this.elementChanged);
		if (mElementDate != null)
			NextagDCalendar.addEvent(mElementDate, "change", this.elementChanged);
	}

	// constFunc.prototype = new Date();

	return constFunc;
})();


/**
 * Constructor parameter object
 * name						- required
 * date						- default today
 * leftOffset			- default 0
 * topOffset			- default 18
 * showOneYear		- default true
 * restrictView		- default true
 * autoAdjustYear	- default false
 * startWeek			- default 0 (Sunday)
 * localeCode			- default US. UK same as US. Currently supports US, UK, DE, FR
 * dateFormat       - default mm/dd/yyyy
 * elemMonthId		- default NAME_month
 * elemDayId			- default NAME_day
 * elemYearId			- default NAME_year
 * elemDateId			- default NAME_date
 * elemButtonId		- default NAME_button
 * clTable				- default #3366cc
 * clGrid					- default #ffffff
 * clTitleCell		- default #3366cc
 * clTitleText		- default #ffffff
 * clHeaderCell		- default #cccccc
 * clHeaderText		- default #3366cc
 * clWeekdayCell	- default #ffffff
 * clWeekdayText	- default #000000
 * clWeekendCell	- default #dbeaf5
 * clWeekendText	- default #000000
 * clSelectedCell	- default #99ccff
 * clSelectedText - default #000000
 * clRelText			- default #888888
 * clRelCell			- default #ffffff
 * zIndex 		- default 0           /adding this parameter to change zIndex if used on layers with higer than 0 zIndex
 * numMonths - default 1. The number of months the calendar should display
 * isHorizontal - default true. Whether or not the calendar should tile months horizontally
 */
var NextagDCalendar = (function(){
	/** private static variables **/
	var sCalendars = new Array();
	var sIndexedCalendars = new Array();
	var sCalendarCount = 0;
	var sVisibleCalendar = null;
	var sDateChangeListeners = new Array();

	/* constructor */
	function Calendar(params){
		function setParamDefaults(pname, def) { if (typeof params[pname] == "undefined") { params[pname] = def; } };

	  var mDisabled = false;
		var mName = params["name"];
		setParamDefaults("showOneYear",true);
		setParamDefaults("restrictView",true);
		setParamDefaults("autoAdjustYear",false);
		setParamDefaults("startWeek",0);
		setParamDefaults("date",new Date());
		setParamDefaults("leftOffset", 0);
		setParamDefaults("topOffset", 18);
		setParamDefaults("localeCode", "US");
		setParamDefaults("formatDate", "mm/dd/yyyy");
		setParamDefaults("elemMonthId", mName + "_month");
		setParamDefaults("elemDayId", mName + "_day");
		setParamDefaults("elemYearId", mName + "_year");
		setParamDefaults("elemDateId", mName + "_date");
		setParamDefaults("elemButtonId", mName + "_button");
		setParamDefaults("clTable","#3366CC");
		setParamDefaults("clGrid","#ffffff");
		setParamDefaults("clTitleCell","#3366cc");
		setParamDefaults("clTitleText","#ffffff");
 		setParamDefaults("clHeaderCell","#cccccc");
		setParamDefaults("clHeaderText","#3366CC");
 		setParamDefaults("clWeekdayCell","#ffffff");
 		setParamDefaults("clWeekdayText","#000000");
 		setParamDefaults("clWeekendCell","#dbeaf5");
 		setParamDefaults("clWeekendText","#000000");
 		setParamDefaults("clSelectedCell","#99ccff");
 		setParamDefaults("clSelectedText","#000000");
 		setParamDefaults("clRelText","#888888");
 		setParamDefaults("clRelCell","#ffffff");
		setParamDefaults("zIndex",0); 		
		setParamDefaults("numMonths",1);
		setParamDefaults("isHorizontal","true");
		var mParams = params;

		this.showOneYear = params["showOneYear"];
		this.restrictView = params["restrictView"];
		this.autoAdjustYear = params["autoAdjustYear"];

		this.numMonths = parseInt(params["numMonths"]);
		this.isHorizontal = (params["isHorizontal"] == "false") ? false : true;

		if(params["secondaryTriggers"] != null && params["secondaryTriggers"] != "")
		{
			var secondaryTriggers = new Array();
			for(i=0;i<params["secondaryTriggers"].length;i++)
			{
				elem = document.getElementById(params["secondaryTriggers"][i]);
				if(elem != null)
					secondaryTriggers[secondaryTriggers.length] = elem;
			}
		}

		this.currPage = 0;
		this.zIndex = params["zIndex"];

		// localize - only supports US/DE/FR -
		// everything else (including UK) will get US locale
		var mArr_Months = ARR_MONTHS;
		var mArr_Weekdays = ARR_WEEKDAYS;
		this.localeCode = params["localeCode"];
		if (this.localeCode == "DE"){
			mArr_Months = ARR_MONTHS_DE;
			mArr_Weekdays = ARR_WEEKDAYS_DE;
		} else if (this.localeCode == "FR"){
			mArr_Months = ARR_MONTHS_FR;
			mArr_Weekdays = ARR_WEEKDAYS_FR;
		} else {
			this.localeCode = "US";
		}
		var mStartWeekday = params["startWeek"];
		var mFormDate = new FormDate(params);

		var mElemButton = document.getElementById(params["elemButtonId"]);
		if (mElemButton != null)
			mElemButton.parentCalendar = this;
		var mElemMonth = document.getElementById(params["elemMonthId"]);
		if (mElemMonth != null)
			mElemMonth.parentCalendar = this;
		var mElemDay = document.getElementById(params["elemDayId"]);
		if (mElemDay != null)
			mElemDay.parentCalendar = this;
		var mElemYear = document.getElementById(params["elemYearId"]);
		if (mElemYear != null)
			mElemYear.parentCalendar = this;
		var mElemDate = document.getElementById(params["elemDateId"]);
		if (mElemDate != null)
			mElemDate.parentCalendar = this;

		var mCalPanel = null;

		/** privileged instance methods **/

		this.isDisabled = function() { return mDisabled; }
		this.setDisabled = function(d){
			mDisabled = d;
			if (!mDisabled){
				NextagDCalendar.fireDateChangeEvent(this);
			}
		}

		this.clickHandler = function(ev){
			var target = NextagDCalendar.getTargetElement(ev);
			var elem = NextagDCalendar.getElement(ev);
			
			isSecondaryTrigger = false;			
			if(secondaryTriggers != null)
			{
				for(i=0;i<secondaryTriggers.length;i++)
					if(target.id == secondaryTriggers[i].id)
						isSecondaryTrigger = true;
			}

			if ((target.id == mElemButton.id || isSecondaryTrigger) && target.parentCalendar && 
					!target.parentCalendar.isDisabled()){
				Calendar.setVisible(target.parentCalendar);
				return NextagDCalendar.stopEvent(ev);
			}
			return false;
		};

		this.getName = function(){ return mName; };

		this.getCalPanel = function(){ return mCalPanel; };

		this.setNewDate = function(longDate){
			mFormDate.setDate(new Date(longDate));
		}

		this.show = function(){
			var pos = NextagDCalendar.getElementPosition(mElemButton);

			this.drawCalendarTable();

			mCalPanel.style.top = (pos.y+mParams["topOffset"]) + "px";
			mCalPanel.style.left = (pos.x+mParams["leftOffset"]) + "px";
			mCalPanel.style.display = "block";
			mCalPanel.style.zIndex = mParams["zIndex"];
			if (NextagDCalendar.is_ie)
				this.hideShowCovered();
		}

		this.hide = function(){
			var prevElem = document.getElementById('prevMonth');
			var nextElem = document.getElementById('nextMonth');
			if (prevElem != undefined && prevElem != null)
				NextagDCalendar.removeEvent(prevElem, "click", NextagDCalendar.monthNavHandler);
			if (nextElem != undefined && nextElem != null)
				NextagDCalendar.removeEvent(nextElem, "click", NextagDCalendar.monthNavHandler);
			this.currPage = 0;
			mCalPanel.innerHTML = '';
			mCalPanel.style.zIndex = 0;
			mCalPanel.style.display = "none";
			if (NextagDCalendar.is_ie)
				this.hideShowCovered();
		}

		this.drawCalendarTable = function(){
			if (mCalPanel == null){
				mCalPanel = NextagDCalendar.createElement("div");
				mCalPanel.style.position = "absolute";
				mCalPanel.style.display = "none";
				mCalPanel.style.cursor = "default";
				mCalPanel.style.backgroundColor = "#FFFFFF";
				document.body.appendChild(mCalPanel);
			}
			
			var ct = "";
			for(i=0;i<this.numMonths;i++)
			{
				monthToDisplayDate = new Date();
				monthToDisplayDate.setDate(1);
				newYear = Math.floor((mFormDate.getDate().getMonth()+this.currPage+i)/12);
				newMonth = (mFormDate.getDate().getMonth()+this.currPage+i)%12;
				monthToDisplayDate.setMonth(newMonth);
				monthToDisplayDate.setFullYear(mFormDate.getDate().getFullYear()+newYear);
				ct += this.makeMonthTable(mFormDate.getDate(),
											monthToDisplayDate,
											(i==0) ? true : false,
											(i==this.numMonths-1) ? true : false);
			}			
			mCalPanel.innerHTML = ct;

			var prevElem = document.getElementById('prevMonth');
			var nextElem = document.getElementById('nextMonth');
			NextagDCalendar.removeEvent(prevElem, "click", NextagDCalendar.monthNavHandler);
			NextagDCalendar.removeEvent(nextElem, "click", NextagDCalendar.monthNavHandler);
			NextagDCalendar.addEvent(prevElem, "click", NextagDCalendar.monthNavHandler);
			NextagDCalendar.addEvent(nextElem, "click", NextagDCalendar.monthNavHandler);
		}
		
		this.makeMonthTable = function(selectedDate,monthToDisplayDate,showNavLeft,showNavRight)
		{
			var visMin = new Date(); visMin.setDate(visMin.getDate()-1);
			var visMax = new Date(); visMax.setDate(visMin.getDate()+ (this.showOneYear?365:0));

			monthToDisplayDate.setDate(1);
			
			var startDate = new Date(monthToDisplayDate);
			startDate.setDate( 1 - (7 + startDate.getDay() - mStartWeekday) % 7 );
			
			if(this.isHorizontal)
				style = "style='float:left'";
			else
				style = "style='float:left;clear:both;'";
	
			var ct = "<table border=0 " + style + " cellpadding=0 cellspacing=0><tr><td><table cellpadding=0 cellspacing=2 bgcolor=" + mParams["clTable"] + " border=0>";
			if(showNavLeft){
				ct += "<tr><td class=smallText style='cursor:pointer' align=left><img id='prevMonth' src='" + STR_ICONPATH + "/prev.gif'></td>";
			}else{
				ct += "<tr>";
			}
			
			ct += "<td style='color:" + mParams["clTitleText"] + "' class=smallText align=center><b>"
			ct += mArr_Months[monthToDisplayDate.getMonth()] + "&nbsp;" + monthToDisplayDate.getFullYear() + "</b></td>";
			if(showNavRight){
				ct += "<td class=smallText style='cursor:pointer' align=right><img id='nextMonth' src='" + STR_ICONPATH + "/next.gif'></td></tr>";
			}else{
				ct += "</tr>";
			}
			
			ct += "<tr><td colspan=3><table cellpadding=0 cellspacing=2 bgcolor=" + mParams["clGrid"] + " border=0><tr>";
			for (var n=0; n<7; n++){
				ct += '<td bgcolor=' + mParams["clHeaderCell"] + ' class=smallText width=20 align=center style="color:' + mParams["clHeaderText"] + '"><b>&nbsp;'+mArr_Weekdays[(mStartWeekday+n)%7]+'&nbsp;</b></td>';
			}
			ct += "</tr>";

			while (startDate.valueOf() < monthToDisplayDate.valueOf() || startDate.getMonth() == monthToDisplayDate.getMonth())
			{
				ct += "<tr>";
				for (var wkday=0; wkday<7; wkday++)
				{
					var day = startDate.getDate();
					var textColor = mParams["clWeekdayText"];
					var cellColor = mParams["clWeekdayCell"];
					var isWeekend = (startDate.getDay()==0 || startDate.getDay()==6);
					var isSelected = (day==selectedDate.getDate() && startDate.getMonth()==selectedDate.getMonth() && startDate.getFullYear()==selectedDate.getFullYear());
					var isCurrMonth = (startDate.getMonth() == monthToDisplayDate.getMonth());

					if (isWeekend) {
						cellColor = mParams["clWeekendCell"];
						textColor = mParams["clWeekendText"];
					}
					if (!isCurrMonth){
						textColor = mParams["clRelText"];
						if (!isWeekend) cellColor = mParams["clRelCell"];
					}
					if (isSelected){ // selected
						textColor = mParams["clSelectedText"];
						cellColor = mParams["clSelectedCell"];
					}

					if (this.restrictView && (startDate.valueOf() <= visMin.valueOf() || startDate.valueOf() > visMax.valueOf())){
						ct += "<td class=smallText width=20 align=center bgcolor=" +
							cellColor + " style='cursor:default;color:" + textColor + "'><s><b>&nbsp;" + day + "&nbsp;</b></s></td>";
					} else {
						ct += "<td nowrap class=smallText width=20 align=center onClick='NextagDCalendar.dateSelectHandler(" + startDate.valueOf() + ")' bgcolor=";
						ct += cellColor + " style='cursor:pointer;color:" + textColor + "'><b>";
						ct += "&nbsp;" + day + "&nbsp;";
						ct += "</b></td>";
					}
					startDate.setDate(day+1)
				}
				ct += "</tr>";
			}
			ct += "</table></td></tr></table></td></tr></table>";
			return ct;
		}

		/** privileged instance methods  **/
		this.getDate = function(){ return mFormDate.getDate(); };

		var jsS = this.clickHandler;

		/* constructor body */
		if (mElemButton != null){
			// register for click event on the main document
			NextagDCalendar.addEvent(mElemButton, "click", jsS);
			//NextagDCalendar.removeEvent(mElemButton, "click", this.clickHandler);
		}
		if(params["secondaryTriggers"] != null && params["secondaryTriggers"] != "")
		{
			for(i=0;i<params["secondaryTriggers"].length;i++)
			{
				trigger = document.getElementById(params["secondaryTriggers"][i]);
				NextagDCalendar.addEvent(trigger,"click",this.clickHandler);
			}
		}

		this.killMe = function() {
		/*	var mElementMonth = document.getElementById(params["elemMonthId"]);
			var mElementDay = document.getElementById(params["elemDayId"]);
			var mElementYear = document.getElementById(params["elemYearId"]);
			var mElementDate = document.getElementById(params["elemDateId"]);
			var mElemButton = document.getElementById(params["elemButtonId"]);

			if (mElementMonth != null) {
				NextagDCalendar.removeEvent(mElementMonth, "change", mFormDate.elementChanged);
				mElementMonth.formDate = null;
			}
			if (mElementDay != null){
				NextagDCalendar.removeEvent(mElementDay, "change", mFormDate.elementChanged);
				mElementDay.formDate = null;
			}
			if (mElementYear != null) {
				NextagDCalendar.removeEvent(mElementYear, "change", mFormDate.elementChanged);
				mElementYear.formDate = null;
			}
			if (mElementDate != null) {
				NextagDCalendar.removeEvent(mElementDate, "change", mFormDate.elementChanged);
				mElementDate.formDate = null;
			}
			if (mElemButton != null) {
				NextagDCalendar.removeEvent(mElemButton, "click", jsS);
				mElemButton.parentCalendar = null;
			}*/
		}
		
		var win = document.defaultView || document.parentWindow;
		if (win && typeof win.attachEvent != "undefined") {
			win.attachEvent("onunload", this.killMe);
		}
		if(window) {
			window.onunload = this.killMe;
		}
		win = null;
	};

	/** private static methods **/

	/** privileged static methods **/
	Calendar.getCalendarItem = function(i){ return sIndexedCalendars!=null&&i<sCalendarCount?sIndexedCalendars[i]:null; }

	Calendar.getInstance = function(params){
		var cal = sCalendars[params["name"]];
		if (sCalendarCount == 0){
			// statically register for click event on the main document
			Calendar.addEvent(document, "click", NextagDCalendar.documentClickHandler);
		}
		if (cal == undefined){
			cal = new Calendar(params);
			sCalendars[params["name"]] = cal;
			sIndexedCalendars[sCalendarCount++] = cal;
		}
		return cal;
	}
	// adding this method if adding the same calendar button is required in which case first remove the calendar and then add it again
	Calendar.removeInstance = function(params) {
		var cal = sCalendars[params["name"]];
		if (cal != undefined) {
			var lsCalendarCount = sCalendarCount ;
			for(var i=0; i<lsCalendarCount; i++) {
				if (cal == sIndexedCalendars[i]){
					sCalendars[params["name"]]=null;
					sCalendarCount--;
					for(;i<lsCalendarCount-1;i++){
						sIndexedCalendars[i] = sIndexedCalendars[i+1];
					}
				}
			}
			return true;
		}
		return false;
	}
	
	Calendar.addDateChangeListener = function (listener){
		if (listener){
			sDateChangeListeners[sDateChangeListeners.length] = listener;
		}
	}

	Calendar.fireDateChangeEvent = function (cal){
		for (var i=0; i<sDateChangeListeners.length; i++){
			var listener = sDateChangeListeners[i];
			if (listener && listener.dispatchDateChange){
				listener.dispatchDateChange(cal);
			}
		}
	}

	Calendar.getVisible = function(){ return sVisibleCalendar; }

	Calendar.setVisible = function(cal){
		if (sVisibleCalendar == null){
			// show this calendar
			if (cal != null)
				cal.show();
			sVisibleCalendar = cal;
		} else {
			var visCal = sVisibleCalendar;
			// hide the visible calendar
			sVisibleCalendar.hide();
			sVisibleCalendar = null;
			if ((cal != null) && (cal.getName() != visCal.getName())){
				// show this calendar
				cal.show();
				sVisibleCalendar = cal;
			}
		}
	}

	/** privileged instance methods **/

	return Calendar;
})();

/** public static variables **/
// detect a special case of "web browser"
NextagDCalendar.is_ie = ( /msie/i.test(navigator.userAgent) &&
		   !/opera/i.test(navigator.userAgent) );
NextagDCalendar.is_ie5 = ( NextagDCalendar.is_ie && /msie 5\.0/i.test(navigator.userAgent) );
// detect Opera browser
NextagDCalendar.is_opera = /opera/i.test(navigator.userAgent);
// detect KHTML-based browsers
NextagDCalendar.is_khtml = /Konqueror|Safari|KHTML/i.test(navigator.userAgent);


/** public static methods **/
NextagDCalendar.dateSelectHandler = function(longDate){
	if (NextagDCalendar.getVisible() == null)
		return true;

	NextagDCalendar.getVisible().setNewDate(longDate);
	NextagDCalendar.fireDateChangeEvent(NextagDCalendar.getVisible());
	return true;
};

NextagDCalendar.monthNavHandler = function(ev){
	var target = NextagDCalendar.getTargetElement(ev);
	var cal = NextagDCalendar.getVisible();
	if (cal == null)
		return true;

	if (target.id == 'prevMonth')
		cal.currPage -= cal.numMonths;
	else
		cal.currPage += cal.numMonths;
	
	cal.drawCalendarTable();
	return NextagDCalendar.stopEvent(ev);
};

NextagDCalendar.documentClickHandler = function(ev){
	var target = NextagDCalendar.getTargetElement(ev);
	if (NextagDCalendar.getVisible() != null)
		NextagDCalendar.setVisible();
	return true;
};

NextagDCalendar.addEvent = function(el, evname, func) {
	if(el != null)
	{
		if (el.attachEvent) { // IE
			el.attachEvent("on" + evname, func);
		} else if (el.addEventListener) { // Gecko / W3C
			el.addEventListener(evname, func, false);
		} else {
			el["on" + evname] = func;
		}
	}
};

NextagDCalendar.removeEvent = function(el, evname, func) {
	if (el.detachEvent) { // IE
		el.detachEvent("on" + evname, func);
	} else if (el.removeEventListener) { // Gecko / W3C
		el.removeEventListener(evname, func, true);
	} else {
		el["on" + evname] = null;
	}
};

NextagDCalendar.stopEvent = function(ev) {
	ev || (ev = window.event);
	if (NextagDCalendar.is_ie) {
		ev.cancelBubble = true;
		ev.returnValue = false;
	} else {
		ev.preventDefault();
		ev.stopPropagation();
	}
	return false;
};

NextagDCalendar.getElement = function(ev) {
	if (NextagDCalendar.is_ie) {
		return window.event.srcElement;
	} else {
		return ev.currentTarget;
	}
};

NextagDCalendar.getTargetElement = function(ev) {
	if (NextagDCalendar.is_ie) {
		return window.event.srcElement;
	} else {
		return ev.target;
	}
};

NextagDCalendar.createElement = function(type, parent) {
	var el = null;
	if (document.createElementNS) {
		// use the XHTML namespace; IE won't normally get here unless
		// _they_ "fix" the DOM2 implementation.
		el = document.createElementNS("http://www.w3.org/1999/xhtml", type);
	} else {
		el = document.createElement(type);
	}
	if (typeof parent != "undefined") {
		parent.appendChild(el);
	}
	return el;
};

NextagDCalendar.getElementPosition = function(obj){
	var curleft = 0;
	var curtop = 0;
	if (obj.offsetParent){
		while (obj.offsetParent){
			curleft += obj.offsetLeft
			curtop += obj.offsetTop
			obj = obj.offsetParent;
		}
		if (obj){
			if (obj.offsetLeft)
				curleft += obj.offsetLeft;
			if (obj.offsetTop)
				curtop += obj.offsetTop;
		}
	} else if (obj.x){
		curleft += obj.x;
		curtop += obj.y;
	}
	return { x: curleft, y: curtop };
}

NextagDCalendar.prototype.hideShowCovered = function () {
	var self = this;
	NextagDCalendar.continuation_for_khtml_browser = function() {
		function getVisib(obj){
			var value = obj.style.visibility;
			if (!value) {
				if (document.defaultView && typeof (document.defaultView.getComputedStyle) == "function") { // Gecko, W3C
					if (!NextagDCalendar.is_khtml)
						value = document.defaultView.
							getComputedStyle(obj, "").getPropertyValue("visibility");
					else
						value = '';
				} else if (obj.currentStyle) { // IE
					value = obj.currentStyle.visibility;
				} else
					value = '';
			}
			return value;
		};

		var tags = new Array("applet", "iframe", "select");
		var el = self.getCalPanel();

		var p = NextagDCalendar.getElementPosition(el);
		var EX1 = p.x;
		var EX2 = el.offsetWidth + EX1;
		var EY1 = p.y;
		var EY2 = el.offsetHeight + EY1;

		for (var k = tags.length; k > 0; ) {
			var ar = document.getElementsByTagName(tags[--k]);
			var cc = null;

			for (var i = ar.length; i > 0;) {
				cc = ar[--i];

				p = NextagDCalendar.getElementPosition(cc);
				var CX1 = p.x;
				var CX2 = cc.offsetWidth + CX1;
				var CY1 = p.y;
				var CY2 = cc.offsetHeight + CY1;

				if (self.hidden || (CX1 > EX2) || (CX2 < EX1) || (CY1 > EY2) || (CY2 < EY1)) {
					if (!cc.__msh_save_visibility) {
						cc.__msh_save_visibility = getVisib(cc);
					}
					cc.style.visibility = cc.__msh_save_visibility;
				} else {
					if (!cc.__msh_save_visibility) {
						cc.__msh_save_visibility = getVisib(cc);
					}
					cc.style.visibility = "hidden";
				}
			}
		}
	};
	if (NextagDCalendar.is_khtml)
		setTimeout("NextagDCalendar.continuation_for_khtml_browser()", 10);
	else
		NextagDCalendar.continuation_for_khtml_browser();
};

// helper - calendar pair listener
var CalendarPairChangeListener = (function(){
	function Listener(cal1, cal2, gap){
		var fromCal = cal1;
		var toCal = cal2;
		var diff = gap;

		this.dispatchDateChange = function (cal){
			if (cal==null || fromCal == null || toCal == null)
				return;
			if (cal!=fromCal && cal!=toCal)
				return;

			var c1_date = fromCal.getDate();
			var c2_date = toCal.getDate();
			if (c1_date.valueOf() >= c2_date.valueOf()){
				c2_date = new Date(c1_date);
				c2_date.setDate(c2_date.getDate()+diff);
				toCal.setNewDate(c2_date);
			}
		}
	};

	return Listener;
})();


var colourOfInactiveTab = "#bbbbbb";
var colourOfActiveTab = "#dddddd";
var colourOfInactiveLink = "#0000ff";
var colourOfActiveLink = "#ffffff";

function domTab(tab){
	if (document.getElementById){
		document.getElementById('air').style.display='none';
		document.getElementById('car').style.display='none';
		document.getElementById('hotel').style.display='none';
		document.getElementById('airTab').style.background=colourOfInactiveTab;
		document.getElementById('carTab').style.background=colourOfInactiveTab;
		document.getElementById('hotelTab').style.background=colourOfInactiveTab;
		document.getElementById('airAds').style.display='none';
		document.getElementById('carAds').style.display='none';
		document.getElementById('hotelAds').style.display='none';

		document.getElementById(tab).style.display='block';
		document.getElementById(tab+"Tab").style.background=colourOfActiveTab;
		document.getElementById(tab+"Ads").style.display='block';
	}
}

function roundTrip(r){
	if (r==true) {
		document.getElementById('returning').style.display='block';
	} else {
		document.getElementById('returning').style.display='none';
	}
}
function initializeDate(datefield, offsetdays){
	// Set the initial date
	var field = document.getElementById(datefield);
	if (field) {
		var d;
		var days;
		if (field.value=="") {
			d = new Date();
			days = d.getDate()+offsetdays;
		} else {
			d = new Date(field.value);
			days = d.getDate();
		}
		d.setDate(days);
		setFieldValue("secs",d.getTime());
		setDate1Copy(d);
	}
}
function initializeDate2(datefield, offsetdays){
	// Set the initial date
	var field = document.getElementById(datefield);
	if (field) {
		var d;
		var days;
		if (field.value=="") {
			d = new Date();
			days = d.getDate()+offsetdays;
		} else {
			d = new Date(field.value);
			days = d.getDate();
		}
		d.setDate(days);
		setDate2Copy(d);
	}
}
// Only let users select days between yesterday and a year from now
var yd=new Date();
var nyd=new Date();
yd.setDate(yd.getDate()-1);
nyd.setYear(nyd.getYear()+1);
var yt=yd.getTime();
var nyt=nyd.getTime();
function dateValid(date, y, m, d) {
	var dt=date.getTime()
	if ((dt<yt)||(dt>nyt)) {
		return true;
	} else {
		return false;
	}
}
function dateValid2(date, y, m, d) {
	var dt=date.getTime()
	if ((dt<document.getElementById("secs").value)||(dt>nyt)) {
		return true;
	} else {
		return false;
	}
}

function setFieldValue(f,v) {
	var field = document.getElementById(f);
	if (field) field.value = v;
}
function setFieldValueIfEmpty(f,v) {
	var field = document.getElementById(f);
	if (field) if (field.value=="") {
		field.value = v;
	}
}

// Set all of the from dates
function setDateText(fld,num) {
	var d = parseDate(fld.value,"%o/%e/%y");
	if (!d) {
		if (fld.value!="") alert("Unrecognized date '"+fld.value+"'");
		fld.value="";
		fld.focus();
	} else {
		eval("setDate"+num+"Copy(d);");
	}
}
function setDate1(cal) {
	var d = new Date(cal.date);
	return setDate1Copy(d);
}
function addYear(d) {
	// Normalize to 200x
	var yr=d.getYear();
	if (yr<99) yr+=2000;
	if (yr<199) yr+=1900;
	return(yr);
}
function setDate1Copy(d) {
	// Save # of seconds
	setFieldValue("secs",d.getTime());
	// Calculate year for NS and IE
	var year1=addYear(d);
	// Set all field1s
	setFieldValue("airDate1",d.print("%o/%e/%y"));
	setFieldValue("departingDay",d.getDate());
	setFieldValue("departingMonth",1+d.getMonth());
	setFieldValue("departingYear",year1);
	setFieldValue("hotelDate1",d.print("%o/%e/%y"));
	setFieldValue("checkinDay",d.getDate());
	setFieldValue("checkinMonth",1+d.getMonth());
	setFieldValue("checkinYear",year1);
	setFieldValue("carDate1",d.print("%o/%e/%y"));
	setFieldValue("pickupDay",d.getDate());
	setFieldValue("pickupMonth",1+d.getMonth());
	setFieldValue("pickupYear",year1);
	// Set date2s if not set
	var t2 = d.getTime();
	t2 += Date.DAY; // Add 1 day
	var d2 = new Date(t2);
	// Calculate year for NS and IE
	var year2=addYear(d2);
	setFieldValueIfEmpty("airDate2",d2.print("%o/%e/%y"));
	setFieldValueIfEmpty("returningDay",year2);
	setFieldValueIfEmpty("returningMonth",1+d2.getMonth());
	setFieldValueIfEmpty("returningYear",year2);
	setFieldValueIfEmpty("hotelDate2",d2.print("%o/%e/%y"));
	setFieldValueIfEmpty("checkoutDay",d2.getDate());
	setFieldValueIfEmpty("checkoutMonth",1+d2.getMonth());
	setFieldValueIfEmpty("checkoutYear",year2);
	setFieldValueIfEmpty("carDate2",d2.print("%o/%e/%y"));
	setFieldValueIfEmpty("dropoffDay",d2.getDate());
	setFieldValueIfEmpty("dropoffMonth",1+d2.getMonth());
	setFieldValueIfEmpty("dropoffYear",year2);
}

// Set all of the to dates
function setDate2(cal) {
	var d = new Date(cal.date);
	return setDate2Copy(d);
}
function setDate2Copy(d) {
	// Calculate year for NS and IE
	var year2=addYear(d);
	setFieldValue("airDate2",d.print("%o/%e/%y"));
	setFieldValue("returningDay",d.getDate());
	setFieldValue("returningMonth",1+d.getMonth());
	setFieldValue("returningYear",year2);
	setFieldValue("hotelDate2",d.print("%o/%e/%y"));
	setFieldValue("checkoutDay",d.getDate());
	setFieldValue("checkoutMonth",1+d.getMonth());
	setFieldValue("checkoutYear",year2);
	setFieldValue("carDate2",d.print("%o/%e/%y"));
	setFieldValue("dropoffDay",d.getDate());
	setFieldValue("dropoffMonth",1+d.getMonth());
	setFieldValue("dropoffYear",year2);
}

// Set all of the location1's
function setLocation1(loc) {
	setFieldValue("airLocation1",loc);
	setFieldValue("hotelLocation1",loc);
	setFieldValue("carLocation1",loc);
}

// Set all of the location2's
function setLocation2(loc) {
	setFieldValue("airLocation2",loc);
	setFieldValue("carLocation2",loc);
}

function setupCalendars() {
	// Car
	Calendar.setup({
		inputField	 :	"carDate1",
		button		 :	"carIcon1",
		ifFormat	   :	"%o/%e/%y",
		alignment	  :	"BL",
		dateStatusFunc :	dateValid,
		onUpdate	   :	setDate1
	});
	Calendar.setup({
		inputField	 :	"carDate2",
		button		 :	"carIcon2",
		ifFormat	   :	"%o/%e/%y",
		alignment	  :	"BL",
		dateStatusFunc :	dateValid2,
		onUpdate	   :	setDate2
	});
}

function initializePage() {
//	initializeDate('carDate1',21);
	setupCalendars();
}

function validateHotel(hotelForm, cityPrefill) {
	var city = hotelForm.city.value;
	if (city == cityPrefill) {
		city = hotelForm.suggested_cities.options[hotelForm.suggested_cities.selectedIndex].value;
	}
	if (city.length < 3) {
		alert("Please enter a city");
		hotelForm.city.focus();
		return false;
	}
	hotelForm.city.value = city;
	var checkInDate = new Date(hotelForm.hotelDate1.value);
	var checkOutDate = new Date(hotelForm.hotelDate2.value);
	if (!(checkInDate<checkOutDate)) {
		alert("Please check your dates.  The check-out date must be after the check-in date.");
		hotelForm.hotelDate1.focus();
		return false;
	}
	return true;
}


<!--
/**
 * This compares a set of parent elements and their children.  It assumes that
 * the comparison is only based on the attribute "id" and doesn't compare the contents
 * of the elements.  This should only be used with AJAX elements
 */
function ElementDiff(aParentElement, aChildrenTagName, aIdPrefix, aAttribute,
	bParentElement, bChildrenTagName, bIdPrefix, bAttribute) {
	this.NEW = 1;
	this.SAME = 0;
	this.REMOVED = -1;
	
	this.NEW_TEXT = "NEW";
	this.SAME_TEXT = "SAME";
	this.REMOVED_TEXT = "REMOVED";

	this.mAParentElement = aParentElement;
	this.mBParentElement = bParentElement;
	this.mAChildren = this.mAParentElement.getElementsByTagName(aChildrenTagName);
	this.mBChildren = this.mBParentElement.getElementsByTagName(bChildrenTagName);
	this.mAIdPrefix = aIdPrefix;
	this.mBIdPrefix = bIdPrefix;
	this.mAAttribute = aAttribute;
	this.mBAttribute = bAttribute;
	this.mDifferences = new Object();
	
	this.mNumNew = 0;
	this.mNumSame = 0;
	this.mNumRemoved = 0;
}



ElementDiff.prototype.hasChanges = function() {
	return ( this.mNumSame != this.mDifferences.length );
}

ElementDiff.prototype.diff = function() {
	//Assume every new bChild is new
	for( var i = 0; i < this.mBChildren.length; i++ ) {
		var bChildElement = this.mBChildren[i];

		if ( bChildElement.getAttribute(this.mBAttribute) != null ) {
			var bUniqueId = this.getBUniqueId(bChildElement.getAttribute(this.mBAttribute));
			this.mDifferences[bUniqueId] = this.NEW;
		}
	}
	
	for(var i = 0; i < this.mAChildren.length; i++ ) {
		var aChildElement = this.mAChildren[i];
		
		if ( aChildElement.getAttribute(this.mAAttribute) != null ) {
			var aUniqueId = this.getAUniqueId(aChildElement.getAttribute(this.mAAttribute));
			if ( this.mDifferences[aUniqueId] != null ) {
				this.mDifferences[aUniqueId] = this.SAME;
				this.mNumSame++;
			} else {
				this.mDifferences[aUniqueId] = this.REMOVED;
				this.mNumRemoved++;
			}
		}
	}
	
	this.mNumNew = this.mDifferences.length - ( this.mNumSame + this.mNumRemoved);
}

ElementDiff.prototype.getBUniqueId = function(id) {
	return this.mBIdPrefix + id;
}

ElementDiff.prototype.getAUniqueId = function(id) {
	return this.mAIdPrefix + id;
}

ElementDiff.prototype.getValue = function(differenceValue) {
	if ( differenceValue == this.NEW ) {
		return this.NEW_TEXT;
	} else if ( differenceValue == this.SAME ) {
		return this.SAME_TEXT;
	} else if ( differenceValue == this.REMOVED ) {
		return this.REMOVED_TEXT;
	}
	return "";
}

ElementDiff.prototype.getDifferences = function() {
	return this.mDifferences;
}

//-->

// BrowserUtils.js : Implements nextagEncodeURI() for encoding URLs using
//                   the JavaScript built-in function encodeURIComponent() 
//                   where available. For older browsers, IE (pre  version 5.5)
//                   and Netscape (pre version 6) where encodeURIComponent()
//                   is not supported, it mimics the JavaScript version.

function utf8(wide) {
	var c, s;
	var enc = "";
	var i = 0;
	while(i<wide.length) {
		c= wide.charCodeAt(i++);
		// handle UTF-16 surrogates
		if (c>=0xDC00 && c<0xE000) continue;
		if (c>=0xD800 && c<0xDC00) {
			if (i>=wide.length) continue;
			s= wide.charCodeAt(i++);
			if (s<0xDC00 || c>=0xDE00) continue;
			c= ((c-0xD800)<<10)+(s-0xDC00)+0x10000;
		}
		// output value
		if (c<0x80) enc += String.fromCharCode(c);
		else if (c<0x800) enc += String.fromCharCode(0xC0+(c>>6),0x80+(c&0x3F));
		else if (c<0x10000) enc += String.fromCharCode(0xE0+(c>>12),0x80+(c>>6&0x3F),0x80+(c&0x3F));
		else enc += String.fromCharCode(0xF0+(c>>18),0x80+(c>>12&0x3F),0x80+(c>>6&0x3F),0x80+(c&0x3F));
	}
	return enc;
}

var hexchars = "0123456789ABCDEF";

function toHex(n) { return hexchars.charAt(n>>4)+hexchars.charAt(n & 0xF); }

var okURIchars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789_-.";

function nextagEncodeURI(s) {
	var s = utf8(s);
	var c;
	var enc = "";
	if (typeof encodeURIComponent == "function") {
		// Use JavaScript built-in function IE 5.5+ and Netscape 6+ and Mozilla
		// Replace all %26amp%3B in s and after encoding
		return (encodeURIComponent(s.replace(/%26amp%3B/g, '%26')).replace(/%26amp%3B/g, '%26'));
	} 
	// Need to mimic the JavaScript version Netscape 4 and IE 4 and IE 5.0
	for (var i= 0; i<s.length; i++) {
		if (okURIchars.indexOf(s.charAt(i))==-1)
			enc += "%"+toHex(s.charCodeAt(i));
		else
			enc += s.charAt(i);
	}
	return enc.replace(/%26amp%3B/g, '%26');
}

function NextagBrowser(){
	d = document;
	var nav=navigator;
	this.agt=nav.userAgent.toLowerCase();
	this.major = parseInt(nav.appVersion);
	this.ns=(d.layers);
	this.dom=(d.getElementById)?1:0;
	this.ns4up=(this.ns && this.major >=4);
	this.ns6=(this.agt.indexOf("Netscape6")!=-1);
	this.op=(window.opera? 1:0);
	this.ie=(d.all);
	this.ie5=(d.all&&this.dom);
	this.fb=(this.agt.indexOf("firebird")!=-1);
	this.sf=(this.agt.indexOf("safari")!=-1);
	this.win=((this.agt.indexOf("win")!=-1) || (this.agt.indexOf("16bit")!=-1));
	this.mac=(this.agt.indexOf("mac")!=-1);
};


var NextagUtils = new Object();
NextagUtils.sVisibleDiv = null;
NextagUtils.sVisibleDivToggleFlag = 0;

/** public static variables **/
// detect a special case of "web browser"
NextagUtils.is_ie = ( /msie/i.test(navigator.userAgent) &&
		   !/opera/i.test(navigator.userAgent) );
NextagUtils.is_ie5 = ( NextagUtils.is_ie && /msie 5\.0/i.test(navigator.userAgent) );
// detect Opera browser
NextagUtils.is_opera = /opera/i.test(navigator.userAgent);
// detect KHTML-based browsers
NextagUtils.is_khtml = /Konqueror|Safari|KHTML/i.test(navigator.userAgent);

// Event methods
NextagUtils.addEvent = function(el, evname, func) {
	if (el.attachEvent) { // IE
		el.attachEvent("on" + evname, func);
	} else if (el.addEventListener) { // Gecko / W3C
		el.addEventListener(evname, func, false);
	} else {
		el["on" + evname] = func;
	}
};

NextagUtils.stopEvent = function(ev) {
	ev || (ev = window.event);
	if (NextagUtils.is_ie) {
		ev.cancelBubble = true;
		ev.returnValue = false;
	} else {
		ev.preventDefault();
		ev.stopPropagation();
	}
	return false;
};

NextagUtils.defaultDocumentOnClickHandler = function (ev){
	if (NextagUtils.sVisibleDiv != null){
		if (NextagUtils.sVisibleDivToggleFlag==0){
			NextagUtils.sVisibleDiv.style.display = 'none';
			NextagUtils.sVisibleDiv = null;
		} else
			NextagUtils.sVisibleDivToggleFlag = 0;
	}
	return true;
};

// DOM/Object methods
NextagUtils.createElement = function(type, parent) {
	var el = null;
	if (document.createElementNS) {
		// use the XHTML namespace; IE won't normally get here unless
		// _they_ "fix" the DOM2 implementation.
		el = document.createElementNS("http://www.w3.org/1999/xhtml", type);
	} else {
		el = document.createElement(type);
	}
	if (typeof parent != "undefined") {
		parent.appendChild(el);
	}
	return el;
};

// UI methods
NextagUtils.getElementPosition = function(obj){
	var curleft = 0;
	var curtop = 0;
	if (obj.offsetParent){
		while (obj.offsetParent){
			curleft += obj.offsetLeft
			curtop += obj.offsetTop
			obj = obj.offsetParent;
		}
	} else if (obj.x){
		curleft += obj.x;
		curtop += obj.y;
	}
	return { x: curleft, y: curtop };
};

NextagUtils.getRelativePosition = function(obj, offsetX, offsetY){
	var pos = this.getElementPosition(obj);
	var left = pos.x + offsetX;
	var top = pos.y + offsetY;
  return { x: left, y: top };
};

// UI - Popup DIV methods
NextagUtils.toggleShowDiv = function(id, pos){
	// alert("-- in toggle");
	var elem = document.getElementById(id);
	if (!elem)
		return false;
	if (elem == NextagUtils.sVisibleDiv){
		NextagUtils.sVisibleDiv.style.display = 'none';
		NextagUtils.sVisibleDiv = null;
		return true;
	}
	if (pos){
		elem.style.top = pos.y + 'px';
		elem.style.left = pos.x + 'px';
	}
	if (NextagUtils.sVisibleDiv != null)
		NextagUtils.sVisibleDiv.style.display = 'none';
	NextagUtils.sVisibleDiv = elem;
	elem.style.display = 'block';
	NextagUtils.sVisibleDivToggleFlag = 1;

	return true;
};

NextagUtils.expandSearchRefineScrollDiv = function (prefix){
	var tagT = document.getElementById(prefix + '_T');
	var tagC = document.getElementById(prefix + '_C');
	var tagH = document.getElementById(prefix + '_H');
	var tagM = document.getElementById(prefix + '_M');

	if (tagC && (tagC.style.height == '' ||
			tagC.style.height == undefined))
		tagC.style.height = (tagC.offsetHeight-4) + 'px';

	if (tagT) tagT.className = 'advSRScrollTitle_HL';
	if (tagC) tagC.className = 'advSRScrollContainer_HL';
	if (tagH) tagH.className = 'advSRScrollHidden_HL';
	if (tagM) tagM.className = 'advSRScrollMore_HL';
};

NextagUtils.collapseSearchRefineScrollDiv = function (prefix){
	var tagT = document.getElementById(prefix + '_T');
	var tagC = document.getElementById(prefix + '_C');
	var tagH = document.getElementById(prefix + '_H');
	var tagM = document.getElementById(prefix + '_M');

	if (tagT) tagT.className = 'advSRScrollTitle';
	if (tagC) tagC.className = 'advSRScrollContainer';
	if (tagH) tagH.className = 'advSRScrollHidden';
	if (tagM) tagM.className = 'advSRScrollMore';
};


/**
 * element utilities like positioning and event functions
 */

NextagUtils.getElementWidth = function(e,b) {return ((b.op)? e.style.pixelWidth:e.offsetWidth);};
NextagUtils.getElementHeight = function(e,b) { return ((b.op)? e.style.pixelHeight:e.offsetHeight); };

NextagUtils.getPageX = function(o,b) {
	if (b.op) {
		var x=0;
		while(eval(o)) {
			x+=o.style.pixelLeft;
			o=o.offsetParent;
		}
		return x;
	} else {
		var m=(b.mac&&b.ie)? document.body.leftMargin:0;
		var x=0;
		var incase=0;
		var hasBody=false;
		var hasHtml=false;
		while(eval(o)) {
			x+=o.offsetLeft;
			if (b.ie && o && o.tagName == 'TABLE'){
				incase = x;
				// break;
			} else if (b.ie && o.tagName == 'HTML') {
				hasHtml = true;
			} else if (b.ie && o.tagName == 'BODY') {
				hasBody = true;
			}
			o=o.offsetParent;
		}
		if (hasHtml && !hasBody)
		  x = incase;
		return parseInt(x)+parseInt(m)
	}
};

NextagUtils.getPageY = function(o,b) {
	if(b.ns) {
		var y=(o.pageY)? o.pageY:o.y;
		return y;
	} else if (b.op) {
		var y=0;
		while(eval(o)) {
			y+=o.style.pixelTop;
			o=o.offsetParent;
		}
		return y;
	} else {
		var m = (b.mac&&b.ie)? document.body.topMargin:0;
		var y=0;
		var incase=0;
		var hasBody=false;
		var hasHtml=false;
		while(eval(o)) {
			y+=o.offsetTop;
			if (b.ie && o.tagName == 'TABLE'){
				incase = y;
				// break;
			} else if (b.ie && o.tagName == 'HTML') {
				hasHtml = true;
			} else if (b.ie && o.tagName == 'BODY') {
				hasBody = true;
			}
			o=o.offsetParent;
		}
		if (hasHtml && !hasBody)
		  y = incase;
		return parseInt(y)+parseInt(m);
	}
};

NextagUtils.showElement = function(e,disp) {
	(!disp)? 0:e.style.display=disp;
	e.style.visibility='visible';
};

NextagUtils.hideElement = function(e,disp) {
	(!disp)? 0:e.style.display=disp;
	e.style.visibility='hidden';
};

NextagUtils.is_khtml = /Konqueror|Safari|KHTML/i.test(navigator.userAgent);

NextagUtils.hideShowCovered = function (elem, tags) {
	NextagUtils.continuation_for_khtml_browser = function() {
		function getVisib(obj){
			var value = obj.style.visibility;
			if (!value) {
				if (document.defaultView && typeof (document.defaultView.getComputedStyle) == "function") { // Gecko, W3C
					if (!NextagUtils.is_khtml)
						value = document.defaultView.
							getComputedStyle(obj, "").getPropertyValue("visibility");
					else
						value = '';
				} else if (obj.currentStyle) { // IE
					value = obj.currentStyle.visibility;
				} else
					value = '';
			}
			return value;
		};

		var el = elem

		var p = NextagUtils.getElementPosition(el);
		var EX1 = p.x;
		var EX2 = el.offsetWidth + EX1;
		var EY1 = p.y;
		var EY2 = el.offsetHeight + EY1;

		for (var k = tags.length; k > 0; ) {
			var tag = tags[--k];
			var filter = null;
			if (tag.indexOf('input.') == 0){
				filter = tag.replace('input.','');
				tag = 'input';
			}
			var ar = document.getElementsByTagName(tag);
			var cc = null;

			for (var i = ar.length; i > 0;) {
				cc = ar[--i];

				if (filter != null && filter != cc.type){
					continue;
				}

				p = NextagUtils.getElementPosition(cc);
				var CX1 = p.x;
				var CX2 = cc.offsetWidth + CX1;
				var CY1 = p.y;
				var CY2 = cc.offsetHeight + CY1;

				if (el.style.visibility == 'visible' || (CX1 > EX2) || (CX2 < EX1) || (CY1 > EY2) || (CY2 < EY1)) {
					if (!cc.__msh_save_visibility) {
						cc.__msh_save_visibility = getVisib(cc);
					}
					cc.style.visibility = cc.__msh_save_visibility;
				} else {
					if (!cc.__msh_save_visibility) {
						cc.__msh_save_visibility = getVisib(cc);
					}
					cc.style.visibility = "hidden";
				}
			}
		}
	};
	if (NextagUtils.is_khtml)
		setTimeout("NextagUtils.continuation_for_khtml_browser()", 10);
	else
		NextagUtils.continuation_for_khtml_browser();
};


// requires NextagUtils.js and utils.js

var sTimeouts = new Array();
var sPopupGroups = new Array();
var sGroupPreShowCB = new Array();
var sGroupPostShowCB = new Array();
var sGroupPreHideCB = new Array();
var sGroupPostHideCB = new Array();
var sWindowWidth;
var sWindowHeight;

var sHideElements = new Array("select","input.checkbox");
var sBrowser = new NextagBrowser();

/**
 * PopupManager constructor parameters
 * triggerPrefix	- default 'trigLink'
 * popupPrefix		- default 'popup'
 * leftOffset			- default 0
 * topOffset			- default 0
 * showEvent      - default mouseover
 * hideEvent      - default mouseout
 * delay          - default 250
 * hideOverlay    - default true
 * allowClicks    - default false
 * flipX          - default false
 * flipY          - default false
 * preShow        - default null
 * postShow       - default null
 * preHide        - default null
 * postHide       - default null
 */
function PopupManager(params){
	function setParamDefaults(pname, def) { if (typeof params[pname] == "undefined") { params[pname] = def; } };

	setParamDefaults("triggerPrefix","trigLink");
	setParamDefaults("popupPrefix","popup");
	setParamDefaults("leftOffset",0);
	setParamDefaults("topOffset",0);
	setParamDefaults("showEvent","mouseover");
	setParamDefaults("hideEvent","mouseout");
	setParamDefaults("delay", 250);
	setParamDefaults("hideOverlay", true);
	setParamDefaults("allowClicks", false);
	setParamDefaults("flipX", false);
	setParamDefaults("flipY", false);
	setParamDefaults('preShow', null);
	setParamDefaults('postShow', null);
	setParamDefaults('preHide', null);
	setParamDefaults('postHide', null);

	var mGrpId = sPopupGroups.length;
	var mParams = params;
	
	this.getProperty = function(prop){ return mParams[prop]; }

	this.positionPopup = function(popup,tr,adjust){
		if (!popup || !tr)
			return;

		var top = 0;
		var left = 0;

		if (!mParams['flipY']){
			top = (NextagUtils.getPageY(tr,sBrowser) + mParams['topOffset']);
		} else {
			top = (NextagUtils.getPageY(tr,sBrowser) + NextagUtils.getElementHeight(tr,sBrowser) + mParams['topOffset']);
		}
		if (!mParams['flipX']){
			left = (NextagUtils.getPageX(tr,sBrowser) + mParams['leftOffset']);
		} else {
			left = (NextagUtils.getPageX(tr,sBrowser) + NextagUtils.getElementWidth(tr,sBrowser) + mParams['leftOffset']) ;
		}

		popup.style.top = top + 'px';
		popup.style.left = left + 'px';
	};


	if (sBrowser.op)
	  return;

	sPopupGroups[sPopupGroups.length] = this;

	/** private instance methods **/
  var init = function(){
		if (!document.getElementById) {
			return false;
		}

		if( sBrowser.mac == 1 && sBrowser.ie5 == 1 ) {
			return;
		}

		if (mParams['preShow'] != null)
			sGroupPreShowCB[mGrpId] = mParams['preShow'];
		if (mParams['postShow'] != null)
			sGroupPostShowCB[mGrpId] = mParams['postShow'];
		if (mParams['preHide'] != null)
			sGroupPreHideCB[mGrpId] = mParams['preHide'];
		if (mParams['postHide'] != null)
			sGroupPostHideCB[mGrpId] = mParams['postHide'];

		var trigs = 0;
		var tr = null;
		while (tr = document.getElementById(mParams['triggerPrefix'] + '_' + trigs)) {
			var popup = document.getElementById(mParams['popupPrefix'] + '_' + trigs);

			sPopupGroups[mGrpId].positionPopup(popup, tr, false);
			if (mParams['showEvent'] == 'click' && mParams['hideEvent'] == 'click'){
				NextagUtils.addEvent(tr, 'click', funcShow(popup.id,trigs), true);
				if (mParams['allowClicks'])
					NextagUtils.addEvent(popup, 'click', funcShow(popup.id,trigs), true);
				NextagUtils.addEvent(document, 'click', funcClickHide(popup.id), true)
			} else if (mParams['showEvent'] == 'click' && mParams['hideEvent'] != 'click'){
				NextagUtils.addEvent(tr, 'click', funcClickShow(popup.id,trigs));
				NextagUtils.addEvent(popup, 'mouseover', funcClickShow(popup.id,trigs));
				if (mParams['hideEvent'].indexOf('element#.')==0){
					var heId = mParams['hideEvent'].replace('element#.','');
					var hes = heId.split(',');
					for (var h=0; h<hes.length; h++){
						var he = document.getElementById(hes[h]+"_"+trigs);
						if (he){NextagUtils.addEvent(he, 'click', funcClickHide(popup.id));}
					}
				} else if (mParams['hideEvent'].indexOf('element.')==0) {
					var heId = mParams['hideEvent'].replace('element.','');
					var hes = heId.split(',');
					for (var h=0; h<hes.length; h++){
						var he = document.getElementById(hes[h]);
						if (he){NextagUtils.addEvent(he, 'click', funcClickHide(popup.id));}
					}
				} else {
					NextagUtils.addEvent(tr, mParams['hideEvent'], funcHide(popup.id));
					NextagUtils.addEvent(popup, mParams['hideEvent'], funcHide(popup.id));
				}
			} else {
				NextagUtils.addEvent(tr, mParams['showEvent'], funcShow(popup.id,trigs), true);
				NextagUtils.addEvent(popup, mParams['showEvent'], funcShow(popup.id,trigs), true);
				if (mParams['hideEvent'].indexOf('element.')==0){
					var he = mParams['hideEvent'].replace('element.','');
				} else {
					NextagUtils.addEvent(tr, mParams['hideEvent'], funcHide(popup.id));
					NextagUtils.addEvent(popup, mParams['hideEvent'], funcHide(popup.id));
				}
			}
			trigs++;
		}
		sWindowWidth = document.body.clientWidth;
		sWindowHeight = document.body.clientHeight;

		return true;
  };

	var funcShow = function (id,num) {
		return new Function("event", "clearTimeout(sTimeouts['"+id+"']);sTimeouts['"+id+"'] = setTimeout(\"PopupManager.show('"+id+"',"+mGrpId+","+num+");\", " + mParams['delay'] + ");");
	};
	var funcHide = function (id) {
		return new Function("event", "clearTimeout(sTimeouts['"+id+"']);sTimeouts['"+id+"'] = setTimeout(\"PopupManager.hide('"+id+"',"+mGrpId+");\", " + mParams['delay'] + ");");
	};

	var funcClickShow = function (id,num) {
		return new Function("event", "clearTimeout(sTimeouts['"+id+"']);sTimeouts['"+id+"'] = setTimeout(\"PopupManager.show('"+id+"',"+mGrpId+","+num+");\", " + 0 + "); NextagUtils.stopEvent(event);");
	};

	var funcClickHide = function (id) {
		return new Function("PopupManager.hide('"+id+"',"+mGrpId+");");
	};

	/** privileged static methods **/
	PopupManager.show = function (id,grpId,pnum) {
		if (grpId >= sPopupGroups.length || pnum < 0)
			return;
		if (id == sTimeouts['lastshown'])
			return;
		var pm = sPopupGroups[grpId];
		PopupManager.hide(sTimeouts['lastshown'], sTimeouts['lastshown_grpid']);
		var fn = sGroupPreShowCB[grpId];
		if (fn != null){fn('preShow',id,grpId,pnum);}
		var tr = document.getElementById(pm.getProperty('triggerPrefix') + '_' + pnum)
		var popup = document.getElementById(pm.getProperty('popupPrefix') + '_' + pnum);
		pm.positionPopup(popup,tr,true);
		sTimeouts['lastshown'] = id;
		sTimeouts['lastshown_grpid'] = grpId;
		var el = document.getElementById(id);
		if (el) {
			if (NextagUtils.is_ie && pm.getProperty('hideOverlay'))
				NextagUtils.hideShowCovered(el,sHideElements);
			el.style.visibility = "visible";
		}
		try {
			if (tr && tr.blur)
				tr.blur();
		} catch (err){}
		fn = sGroupPostShowCB[grpId];
		if (fn != null){fn('postShow',id,grpId,pnum);}
	};

	PopupManager.hide = function (id,grpId) {
		if (grpId >= sPopupGroups.length)
			return;
		var fn = sGroupPreHideCB[grpId];
		if (fn != null){fn('preHide',id,grpId);}
		var pm = sPopupGroups[grpId];
		var el = document.getElementById(id);
		if (el) {
			if (NextagUtils.is_ie && pm.getProperty('hideOverlay') && el.style.visibility == 'visible')
				NextagUtils.hideShowCovered(el,sHideElements);
			el.style.visibility = "hidden";
			sTimeouts['lastshown'] = null;
			sTimeouts['lastshown_grpid'] = null;
		}
		fn = sGroupPostHideCB[grpId];
		if (fn != null){fn('postHide',id,grpId);}
	};


	/** constructor body */
	init();
};

PopupManager.newPopupGroup = function (params){
	new PopupManager(params);
};



/**
 *  nextag-maps.js
 *  Depends on http://maps.google.com/maps?file=api
 *
 * CVS $Id: nextag-maps.js,v 1.3.24.2 2007/01/04 00:31:10 ddurkin Exp $
 *  @author ddurkin
 */

var nextagMaps_largeMap = null;
var nextagMaps_smallMap = null;

var nextagMaps_maxZoom = 14;
var nextagMaps_minZoom = null;
var nextagMaps_bounds = null;

var nextagMaps_geocoder = null;
var nextagMaps_largeMarkers = new Array();
var nextagMaps_smallMarkers = new Array();
var nextagMaps_lines = new Array();

var nextagMaps_currentMap = null;

var nextagMaps_mapsEnabled = false;

var nextagMaps_currentIndex = 0;
var nextagMaps_indextoIdMap = new Array();
var nextagMaps_idToIndexMap = new Array();

var nextagMaps_useSmallControls = false;
var nextagMaps_allowSatelliteMaps = false;
var nextagMaps_disableMarkerClicking = false;

/**
 * Public Functions
 *
 */
 
 /**
  * Initialize the maps
  * center: string or {lat: , lng: } which is the default center of the map
  * options: mapToDisplay = map to display (default is to show user preferred or small map)
  */
 function nextagMaps_initMap(options) {
	nextagMaps_addOnunload(GUnload);
 
 	nextagMaps_bounds = new GLatLngBounds();
 	nextagMaps_geocoder = new GClientGeocoder();
 	
	if(options) {
		if(options.mapToDisplay) {
			nextagMaps_currentMap = options.mapToDisplay;
		} else {
			nextagMaps_currentMap = nextagMaps_getCookie("nextagMaps_currentMap");
		}
		if(options.useSmallControls) {
			nextagMaps_useSmallControls = true;
		}
		if(options.allowSatelliteMaps) {
			nextagMaps_allowSatelliteMaps = true;
		}
		if(options.disableMarkerClicking) {
			nextagMaps_disableMarkerClicking = true;
		}
	}
	if(!nextagMaps_currentMap) {
		nextagMaps_currentMap = "small";
	}
}

function nextagMaps_showMaps() {
	nextagMaps_mapsEnabled = true;
	if(nextagMaps_currentMap == "small") {
		nextagMaps_hideMap("large");
	} else {
		nextagMaps_hideMap("small");
	}
	nextagMaps_showMap(nextagMaps_currentMap);
}

 /**
  * Pop open the info window for a particular id
  * id: the id of the div which contains the sr-address, ...
  */
function nextagMaps_showInfoWindow(id) {
	var index = nextagMaps_idToIndexMap[id];
	if(nextagMaps_currentMap == "small") {
		nextagMaps_swapMaps();
	}
	if(nextagMaps_largeMarkers[index]) {
		var marker = nextagMaps_largeMarkers[index];
		GEvent.trigger(marker, "click");
	} else {
		var point;
		if(nextagMaps_bounds && nextagMaps_bounds.getCenter()) {
			point = nextagMaps_bounds.getCenter();
		} else {
			point = nextagMaps_largeMap.getCenter();
		}
		var node = nextagMaps_getHtmlFromNode(id);
		if(node) {
			nextagMaps_largeMap.openInfoWindowHtml(point, node);
		}
	}
	var node = document.getElementById("nextag-maps-" + nextagMaps_currentMap + "-outer");
	if(node) {
		node.scrollIntoView();
	}
}

/**
 * Add a new marker to the map
 * id:	div which contains sr-address, etc...
 * options: 	lat = latitude
 * 				lng = longitude
 */
function nextagMaps_addMarker(id, options) {
	var index = nextagMaps_currentIndex++;
	var node = document.getElementById(id);
	nextagMaps_indextoIdMap[index] = id;
	nextagMaps_idToIndexMap[id] = index;
	var addPointFunc = function(point) {
		if (point) {
			if(options && !options.notVisible) {
				nextagMaps_bounds.extend(point);
			}
			nextagMaps_largeMarkers[index] = nextagMaps_addPoint(nextagMaps_largeMap, nextagMaps_getHtmlFromNode, id, null, point, options);
			nextagMaps_smallMarkers[index] = nextagMaps_addPoint(nextagMaps_smallMap, nextagMaps_getHtmlFromNode, id, nextagMaps_largeMarkers[index], point, options);

			if(nextagMaps_mapsEnabled) {
				var nodes = document.getElementsByName(id + "-mapit");
				for(var i = 0; i < nodes.length; i++) {
					nodes.item(i).style.display = "inline";
				}
				nextagMaps_setupNearby(id,point);
			}
		}
	}
	if(options && options.lat && options.lng) {
		var point = new GLatLng(options.lat, options.lng);
		addPointFunc(point);
	} else {
		var addressNode = nextagMaps_getElementsByClassName(node, "sr-address", "div")[0];
		if(addressNode) {
			var address = nextagMaps_cleanAddress(nextagMaps_cleanHTML(addressNode.innerHTML));
			nextagMaps_geocoder.getLatLng(address, addPointFunc);
		}
	}
}

/**
 * Swap which map is visible
 */
function nextagMaps_swapMaps() {
	nextagMaps_hideMap(nextagMaps_currentMap);
	
	if(nextagMaps_currentMap == "small") {
		nextagMaps_currentMap = "large";
	} else {
		nextagMaps_currentMap = "small";
		if(nextagMaps_largeMap) {
			nextagMaps_largeMap.closeInfoWindow();
		}
	}
	nextagMaps_setCookie("nextagMaps_currentMap", nextagMaps_currentMap, "/");
	
	nextagMaps_showMap(nextagMaps_currentMap);
}
 
function nextagMaps_addOnload(fun) {
	var old = window.onload;
	if (old) {
		window.onload = function () { old(); fun(); }
	}
	else {
		window.onload = fun;
	}
}

function nextagMaps_addOnunload(fun) {
	var old = window.onunload;
	if (old) {
		window.onunload = function () { old(); fun(); }
	}
	else {
		window.onunload = fun;
	}
}

/**
 * Private (sorta) Functions
 *
 */
 
function nextagMaps_cleanHTML(html) {
	return html.replace(/(<([^>]+)>)/ig,"").replace(/\n/g," ").replace("&amp;", "&").replace("&nbsp;", " ");
}

function nextagMaps_cleanAddress(address) {
	return address.replace(/-\d\d\d\d/g,"");
}

function nextagMaps_setCookie(c_name,value,path,expiredays) {
	var exdate = new Date();
	exdate.setDate(exdate.getDate() + expiredays);
	document.cookie = c_name + "=" + escape(value) + ((expiredays==null) ? "" : ";expires=" + exdate) + ((path==null) ? "" : ";path=" + path);
}

function nextagMaps_getCookie(c_name) {
	if (document.cookie.length > 0) {
		var c_start = document.cookie.indexOf(c_name + "=");
		if (c_start!=-1) { 
			c_start = c_start + c_name.length + 1;
			var c_end = document.cookie.indexOf(";",c_start);
			if (c_end == -1) {
				c_end = document.cookie.length;
			}
			return unescape(document.cookie.substring(c_start,c_end));
		} 
	}
	return null
}

function nextagMaps_createSmallMap() {
	var node = document.getElementById("nextag-maps-small");
	if(node) {
		nextagMaps_smallMap = new GMap2(node, {draggableCursor: "default", draggingCursor: "default"});
		GEvent.addListener(nextagMaps_smallMap, "click", function(overlay, point) {
			if(point) {
				nextagMaps_swapMaps();
			}
		});
		GEvent.addListener(nextagMaps_smallMap, "dragstart", function() {
			nextagMaps_swapMaps();
		});
		
		if(!nextagMaps_bounds.isEmpty()) {
			var zoom = nextagMaps_smallMap.getBoundsZoomLevel(nextagMaps_bounds);
			if(nextagMaps_maxZoom && zoom > nextagMaps_maxZoom) {
				zoom = nextagMaps_maxZoom;
			}
			if(nextagMaps_minZoom && zoom < nextagMaps_minZoom) {
				zoom = nextagMaps_minZoom;
			}
			nextagMaps_smallMap.setCenter(nextagMaps_bounds.getCenter(),zoom);	
		} else {
			nextagMaps_smallMap.setCenter(new GLatLng(37.4569, -122.1569),12);	
		}
		
		nextagMaps_populateMap(nextagMaps_smallMap, nextagMaps_smallMarkers, nextagMaps_lines);
	}
}

function nextagMaps_createLargeMap() {
	var node = document.getElementById("nextag-maps-large");
	if(node) {
		nextagMaps_largeMap = new GMap2(node);
		if(nextagMaps_useSmallControls) {
			nextagMaps_largeMap.addControl(new GSmallMapControl());
		} else {
			nextagMaps_largeMap.addControl(new GLargeMapControl());
		}
		if(nextagMaps_allowSatelliteMaps) {
			nextagMaps_largeMap.addControl(new GMapTypeControl());
		}
		
		if(!nextagMaps_bounds.isEmpty()) {
			var zoom = nextagMaps_largeMap.getBoundsZoomLevel(nextagMaps_bounds);
			if(nextagMaps_maxZoom && zoom > nextagMaps_maxZoom) {
				zoom = nextagMaps_maxZoom;
			}
			if(nextagMaps_minZoom && zoom < nextagMaps_minZoom) {
				zoom = nextagMaps_minZoom;
			}
			nextagMaps_largeMap.setCenter(nextagMaps_bounds.getCenter(),zoom);	
		} else {
			nextagMaps_largeMap.setCenter(new GLatLng(37.4569, -122.1569),12);	
		}

		nextagMaps_populateMap(nextagMaps_largeMap, nextagMaps_largeMarkers, nextagMaps_lines);
	}
}

function nextagMaps_getHtmlFromNode(id) {
	var html = "";
	var node = document.getElementById(id);
	if(node) {
		var imageNode = nextagMaps_getElementsByClassName(node, "sr-image", "td")[0];
		if(imageNode) {
			imageNodeInner = nextagMaps_getElementsByClassName(node, "sr-image-inner", "div")[0];
			if(imageNodeInner) {
				imageNode = imageNodeInner;
			}
		}
		var nameNode = nextagMaps_getElementsByClassName(node, "sr-title", "a")[0];
		var addressNode = nextagMaps_getElementsByClassName(node, "sr-address", "div")[0];
		var sellersNode = nextagMaps_getElementsByClassName(node, "featuredSeller", "div")[0];
		var htmlContentNode = nextagMaps_getElementsByClassName(node, "sr-html-content", "div")[0];
		var nearbyNode = nextagMaps_getElementsByClassName(node, "sr-find-nearby", "div")[0];
		
		if (htmlContentNode) {
			html = htmlContentNode.innerHTML;
		}
		else {
			html +=		"<table width=\"400\">" +
						"<tr>";
			if(imageNode) {
				html +=	"<td class=\"sr-image\">" + imageNode.innerHTML + "</td>";
			} else {
				html +=	"<td>&nbsp;</td>";
			}
			html +=		"<td>";
			if(nameNode) {
				html +=	"<a class=\"sr-title\" href=\"" + nameNode.getAttribute("href") + "\">" + nameNode.innerHTML +"</a><br>";
			}
			html += "<div class=\"sr-subinfo\">";
			if(addressNode) {
				html +=	"<div class=\"sr-address\">" + addressNode.innerHTML +"</div>";
			}
			if(nearbyNode) {
				html += "<div class=\"sr-find-nearby\">" + nearbyNode.innerHTML + "</div>";
			}
			html += "</div>";
			if(sellersNode) {
				html +=	"<div class=\"featuredSeller\">" + sellersNode.innerHTML +"</div>";
			}
			html +=		"</td>" +
						"</tr>" +
						"</table>";
		}
	}
	return html;
}

function nextagMaps_getNameFromNode(id) {
	var name;
	var node = document.getElementById(id);
	if(node) {
		var nameNode = nextagMaps_getElementsByClassName(node, "sr-title", "a")[0];
		if(nameNode) {
			name = nextagMaps_cleanHTML(nameNode.innerHTML);
		}
	}
	return name;
}

function nextagMaps_getIconLabelFromNode(id) {
	var iconLabel;
	var node = document.getElementById(id);
	if (node) {
		var nameNode = nextagMaps_getElementsByClassName(node, "sr-icon-label", "div")[0];
		if (nameNode) {
			iconLabel = nameNode.innerHTML;
		}
	}
	return iconLabel;
}

function nextagMaps_addPoint(map, getHtmlFunc, id, markerParent, point, options) {
	if(options && !options.notVisible) {
		if(map) {
			var currentMapType = map.getCurrentMapType();
			if(currentMapType) {
				if(!nextagMaps_maxZoom || nextagMaps_maxZoom > currentMapType.getMaximumResolution(point)) {
					nextagMaps_maxZoom = map.getCurrentMapType().getMaximumResolution(point);
				}
				if(!nextagMaps_minZoom || nextagMaps_minZoom < currentMapType.getMinimumResolution(point)) {
					nextagMaps_minZoom = map.getCurrentMapType().getMinimumResolution(point);
				}
			}
			var zoom = map.getBoundsZoomLevel(nextagMaps_bounds);
			zoom = Math.min(zoom, nextagMaps_maxZoom);
			zoom = Math.max(zoom, nextagMaps_minZoom);
			map.setCenter(nextagMaps_bounds.getCenter(),zoom);
		}
	}
	var options = {};
	

	var iconLabel = nextagMaps_getIconLabelFromNode(id);
	if (iconLabel) {
		var baseIcon = new GIcon();
		baseIcon.shadow = "http://www.google.com/mapfiles/shadow50.png";
		baseIcon.iconSize = new GSize(20, 34);
		baseIcon.shadowSize = new GSize(37, 34);
		baseIcon.iconAnchor = new GPoint(9, 34);
		baseIcon.infoWindowAnchor = new GPoint(9, 2);
		baseIcon.infoShadowAnchor = new GPoint(18, 25);
		var icon = new GIcon(baseIcon);
		icon.image = "http://www.google.com/mapfiles/marker" + iconLabel + ".png";
		options.icon = icon;
	}
	
	
	if(nextagMaps_disableMarkerClicking) {
		options.clickable = false;
	}
	var name = nextagMaps_getNameFromNode(id);
	if(name) {
		options.title = name;
	}
	var marker = new GMarker(point, options);
	if(map) {
		map.addOverlay(marker);
	}
	GEvent.addListener(marker, "click", function() {
		var html = null;
		if(getHtmlFunc) {
			html = getHtmlFunc(id);
		}
		if(markerParent) {
			if(html) {
				nextagMaps_swapMaps();
		    	markerParent.openInfoWindowHtml(html);
		    }
	    } else {
	    	if(html) {
		    	marker.openInfoWindowHtml(html);
		    }
	    }
	});
	return marker;
}

function nextagMaps_addLine(points, color) {
	var line = new GPolyline(points, color, 2);
	nextagMaps_lines.push(line);
	if(nextagMaps_largeMap) {
		nextagMaps_largeMap.addOverlay(line);
	}
	if(nextagMaps_smallMap) {
		nextagMaps_smallMap.addOverlay(line);
	}
}

function nextagMaps_populateMap(map, markers, lines) {
	for(var i = 0; i < markers.length; i++) {
		if(markers[i]) {
			map.addOverlay(markers[i]);
			if(nextagMaps_indextoIdMap[i]) {
				var nodes = document.getElementsByName(nextagMaps_indextoIdMap[i] + "-mapit");
				for(var j = 0; j < nodes.length; j++) {
					nodes.item(j).style.display = "inline";
				}
				nextagMaps_setupNearby(nextagMaps_indextoIdMap[i],markers[i].getPoint());
			}
		}
	}
	for(var i = 0; i < lines.length; i++) {
		map.addOverlay(lines[i]);
	}
}

function nextagMaps_setupNearby(id, point) {
	if(window.sortFromLocation) {
		nodes = document.getElementsByName(id + "-nearby");
		var lat = point.lat();
		var lng = point.lng();
		for(var i = 0; i < nodes.length; i++) {
			var node = nodes.item(i);
			var key = node.parentNode.id;
			node.style.display = "inline";
			node.href="javascript:sortFromLocation('"+key+"',"+lat+","+lng+")";
		}
	}
}

function nextagMaps_hideMap(mapName) {
	var node = document.getElementById("nextag-maps-" + mapName + "-outer");
	if(node) {
		node.style.display="none";
	}
}

function nextagMaps_displayMap(mapName) {
	var node = document.getElementById("nextag-maps-" + mapName + "-outer");
	if(node) {
		node.style.display="block";
	}
}

function nextagMaps_showMap(mapName) {
	if(!nextagMaps_mapsEnabled) {
		return;
	}
	nextagMaps_displayMap(mapName);

	if(mapName == "small") {
		if(!nextagMaps_smallMap) {
			nextagMaps_createSmallMap();
		}
	} else {
		if(!nextagMaps_largeMap) {
			nextagMaps_createLargeMap();
		}	
	}
}



/*
v1.03 Copyright (c) 2006 Stuart Colville
http://muffinresearch.co.uk/archives/2006/04/29/getelementsbyclassname-deluxe-edition/

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, 
and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial 
portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
IN THE SOFTWARE.
*/
  
function nextagMaps_getElementsByClassName(objContElm, strClass, strTag) {
  strTag = strTag || "*";
  objContElm = objContElm || document;    
  var objColl = (objContElm.getElementsByTagName(strTag)) ? objContElm.getElementsByTagName(strTag) : document.all;
  var arr = new Array();                              
  var delim = strClass.indexOf('|') != -1  ? '|' : ' ';   
  var arrClass = strClass.split(delim);    
  for (var i = 0, j = objColl.length; i < j; i++) {                         
    var arrObjClass = objColl[i].className.split(' ');   
    if (delim == ' ' && arrClass.length > arrObjClass.length) continue;
    var c = 0;
    comparisonLoop:
    for (var k = 0, l = arrObjClass.length; k < l; k++) {
      for (var m = 0, n = arrClass.length; m < n; m++) {
        if (arrClass[m] == arrObjClass[k]) c++;
        if ((delim == '|' && c == 1) || (delim == ' ' && c == arrClass.length)) {
          arr.push(objColl[i]); 
          break comparisonLoop;
        }
      }
    }
  }
  return arr; 
}

// To cover IE 5 Mac lack of the push method
Array.prototype.push = function(value) {
  this[this.length] = value;                                                              
}


// Taken from: http://www.kryogenix.org/code/browser/sorttable/
// Made modifications to specify which rows to sort by and which rows to ignore, maintain order of items with same values
//  and fix sorting for mixed numeric and non-numeric data

addEvent(window, "load", sortables_init);

var SORT_COLUMN_INDEX;
var REVERSE;

function sortables_init() {
    // Find all tables with class sortable and make them sortable
    if (!document.getElementsByTagName) return;
    tbls = document.getElementsByTagName("table");
    for (ti=0;ti<tbls.length;ti++) {
        thisTbl = tbls[ti];
        if (((' '+thisTbl.className+' ').indexOf("sortable") != -1) && (thisTbl.id)) {
            //initTable(thisTbl.id);
            ts_makeSortable(thisTbl);
        }
    }
}

function ts_makeSortable(table) {
	// Find all rows with class sortrow and make its contents clickable links
    if (table.rows && table.rows.length > 0) {
        for (var row = 0; row < table.rows.length; row++) {
            if ((' '+table.rows[row].className+' ').indexOf("sortrow") != -1) {
		        var sortRow = table.rows[row];
			    for (var i=0;i<sortRow.cells.length;i++) {
                    var cell = sortRow.cells[i];
                    var txt = ts_getInnerText(cell);
			        if (cell.className.indexOf('nosort') == -1) {
                        cell.innerHTML = '<a href="#" class="sortheader" onclick="ts_resortTable(this);return false;">'+txt+'</a><span class="sortarrow">&nbsp;&nbsp;</span>';
                    }
                }
            }
        }
    }
}

function ts_getInnerText(el) {
	if (typeof el == "string") return el;
	if (typeof el == "undefined") { return el };
	if (el.innerText) return el.innerText;	//Not needed but it is faster
	var str = "";

	var cs = el.childNodes;
	var l = cs.length;
	for (var i = 0; i < l; i++) {
		switch (cs[i].nodeType) {
			case 1: //ELEMENT_NODE
				str += ts_getInnerText(cs[i]);
				break;
			case 3:	//TEXT_NODE
				str += cs[i].nodeValue;
				break;
		}
	}
	return str;
}

function ts_resortTable(lnk) {
    // get the span
    var span;
    var td = lnk.parentNode;
    for (var ci = 0; ci < td.childNodes.length; ci++) {
        if (td.childNodes[ci].tagName && td.childNodes[ci].tagName.toLowerCase() == 'span')
            span = td.childNodes[ci];
    }
    REVERSE = span.getAttribute("sortdir") == 'down';
    var spantext = ts_getInnerText(span);
    var column = td.cellIndex;
    var table = getParent(td,'TABLE');

    if (table.rows.length <= 1) return;
    SORT_COLUMN_INDEX = column;
    var sortRows = new Array();
    var bottomRows = new Array();
    var i = 0;
    lastSort = 0;
    for (j = 0; j < table.rows.length; j++) {
		if ((table.rows[j].className.indexOf('nosort') == -1) && (table.rows[j].className.indexOf('sortrow') == -1)) {
            sortRows[i] = table.rows[j];
            sortRows[i].position = i++;
            lastSort = j;
        }
    }
    i = 0;
    for (j = lastSort + 1; j < table.rows.length; j++) {
        bottomRows[i++] = table.rows[j];
    }

    sortRows.sort(ts_sortRows);

    if (REVERSE) {
        ARROW = '&nbsp;&uarr;';
        sortRows.reverse();
        span.setAttribute('sortdir','up');
    } else {
        ARROW = '&nbsp;&darr;';
        span.setAttribute('sortdir','down');
    }

    // We appendChild rows that already exist to the tbody, so it moves them rather than creating new ones
    for (i = 0; i < sortRows.length; i++) {
        if ((' '+table.className+' ').indexOf("nocolor") == -1) {
            /*if (i % 2 == 1) {
                sortRows[i].style.backgroundColor = "#f0f0f0";
            } else {
                sortRows[i].style.backgroundColor = "#fffffc";
            }*/
        }
        table.tBodies[0].appendChild(sortRows[i]);
    }

    // append sortbottom rows
    for (i = 0; i < bottomRows.length; i++) {
        table.tBodies[0].appendChild(bottomRows[i]);
    }

    // Delete any other arrows there may be showing
    var allspans = document.getElementsByTagName("span");
    for (var ci=0;ci<allspans.length;ci++) {
        if (allspans[ci].className == 'sortarrow') {
            if (getParent(allspans[ci],"table") == getParent(lnk,"table")) { // in the same table as us?
                allspans[ci].innerHTML = '&nbsp;&nbsp;&nbsp;';
            }
        }
    }

    span.innerHTML = ARROW;
}

function getParent(el, pTagName) {
	if (el == null) return null;
	else if (el.nodeType == 1 && el.tagName.toLowerCase() == pTagName.toLowerCase())	// Gecko bug, supposed to be uppercase
		return el;
	else
		return getParent(el.parentNode, pTagName);
}

function ts_sortRows(a,b) {
    aa = ts_getInnerText(a.cells[SORT_COLUMN_INDEX]);
    bb = ts_getInnerText(b.cells[SORT_COLUMN_INDEX]);
    sortOrder = ts_sort(aa,bb);
    return sortOrder != 0 ? sortOrder : ts_sort_tiebreaker(a,b);
}

function ts_sort(a,b) {
    if (a == null && b == null || a == '' && b == '') return 0;
    if (a == null || a == '') return -1;
    if (b == null || b == '') return 1;
    // Work out a type for the column
    var sortfn = ts_sort_caseinsensitive;
    var currencyRegEx = /^[�$]/;
    var numericRegEx = /^[-]?[\d\.]+/;
    var dateRegEx = /^\s*\d\d?[\/-]\d\d?[\/-](\d\d){1,2}/;
    var timeRegEx = /^\s*\d\d?:\d\d([\s]*[AP]M)?/i;
    if (a.match(currencyRegEx) || b.match(currencyRegEx)) sortfn = ts_sort_currency;
    if (a.match(numericRegEx) || b.match(numericRegEx)) sortfn = ts_sort_numeric;
    if (a.match(dateRegEx) || b.match(dateRegEx)) sortfn = ts_sort_date;
    if (a.match(timeRegEx) || b.match(timeRegEx)) sortfn = ts_sort_time;

    return sortfn(a,b);
}

function ts_sort_date(a,b) {
    // y2k notes: two digit years less than 50 are treated as 20XX, greater than 50 are treated as 19XX
    aa = a.split(/[\/\s-]/);
    bb = b.split(/[\/\s-]/);
    dt1 = ts_get_date(aa[0], aa[1], aa[2]);
    dt2 = ts_get_date(bb[0], bb[1], bb[2]);
    if (dt1 == dt2) return ts_sort(a.substring(a.indexOf(' ')), b.substring(a.indexOf(' ')));
    if (dt1 < dt2) return -1;
    return 1;
}

function ts_get_date(month, day, year) {
    y = year.length == 4 ? year : parseInt(year) < 50 ? '20' + year : '19' + year;
    m = month.length == 2 ? month : '0' + month;
    d = day.length == 2 ? day : '0' + day;
    return y + m + d;
}

function ts_sort_time(a,b) {
    aa = a.replace(/[^\d:]/g, '').split(/[:]/);
    bb = b.replace(/[^\d:]/g, '').split(/[:]/);
    tm1 = ts_get_time(aa, a.indexOf('AM') > 0, a.indexOf('PM') > 0);
    tm2 = ts_get_time(bb, b.indexOf('AM') > 0, b.indexOf('PM') > 0);
    if (tm1 == tm2) return ts_sort(a.substring(a.indexOf('M') + 1), b.substring(a.indexOf('M')) + 1);
    if (tm1 < tm2) return -1;
    return 1;
}

function ts_get_time(time, am, pm) {
    hour = parseFloat(time[0]);
    if (am && hour == 12) hour = 0;
    if (pm && hour != 12) hour += 12;
    min = parseFloat(time[1]);
    sec = parseFloat(time[2]);
    if (isNaN(sec)) sec = 0;
    return (hour * 60 + min) * 60 + sec;
}

function ts_sort_currency(a,b) {
    aa = a.replace(/[^0-9.]/g,'').replace(/^$/,'0');
    bb = b.replace(/[^0-9.]/g,'').replace(/^$/,'0');
    diff = parseFloat(aa) - parseFloat(bb);
    return diff != 0 ? diff : ts_sort(a.replace(/[\d�$]/g, ''), b.replace(/[\d�$]/g, ''));
}

function ts_sort_numeric(a,b) {
    aa = parseFloat(a.match(/^[-]?[0-9.]+/));
    bb = parseFloat(b.match(/^[-]?[0-9.]+/));
    if (isNaN(aa) && isNaN(bb)) return ts_sort_caseinsensitive(a,b);
    if (isNaN(aa)) return 1;
    if (isNaN(bb)) return -1;
    var diff = aa - bb;
    return diff != 0 ? diff : ts_sort(a.replace(/^[-]?[0-9.]+/,''), b.replace(/^[-]?[0-9.]+/,''));
}

function ts_sort_caseinsensitive(a,b) {
    aa = a.toLowerCase();
    bb = b.toLowerCase();
    if (aa==bb) return 0;
    if (aa<bb) return -1;
    return 1;
}

function ts_sort_default(a,b) {
    if (a==b) return 0;
    if (a<b) return -1;
    return 1;
}

function ts_sort_tiebreaker(a,b) {
	var diff = a.position - b.position;
	return REVERSE ? -diff : diff;
}

function addEvent(elm, evType, fn, useCapture)
// addEvent and removeEvent
// cross-browser event handling for IE5+,  NS6 and Mozilla
// By Scott Andrew
{
  if (elm.addEventListener){
    elm.addEventListener(evType, fn, useCapture);
    return true;
  } else if (elm.attachEvent){
    var r = elm.attachEvent("on"+evType, fn);
    return r;
  } else {
    alert("Handler could not be removed");
  }
}


/* These java functions are shared across NexTag's site */
/* From the header */
window.onerror=handleError;
function handleError(msg, url, line) {
  if (msg == "Not implemented" || msg.indexOf("Access is denied") != -1) {
    return true;
  }
}

/*  convert search term into static link on header and footer search form submission */
function submitStaticSearchLink(sid,nid,url){
	var nodeDropdown = document.getElementById(nid);
	if(nodeDropdown && nodeDropdown[nodeDropdown.selectedIndex].value != '0') return true;
	if (document.getElementById(sid) != null){
		var sKeyword = document.getElementById(sid).value;
		if (/[^\w\-\s,]/.test(sKeyword) || sKeyword.search(/\S/)==-1 || !url) return true;
		sKeyword = sKeyword.replace(/-/g, '_-_');
		sKeyword = sKeyword.replace(/\s+/g, ' ');
		sKeyword = sKeyword.replace(/\s/g, '-');
		var func = typeof(encodeURIComponent) != "undefined" ? encodeURIComponent : escape;
		url = url.replace(/KEYWORD/g, func(sKeyword));
		location.href = url;
		return false;
	}
	return true;
}



var CommonUtils = {
	getValue: function(collection, param, defaultValue) {
		var value = null;
		if ( collection && param ) {
			if ( collection[param] != undefined ) value = collection[param];
			else if ( defaultValue != undefined ) value = defaultValue;
		}
		return value;
	},
	
	getSafeValue: function(variable, defaultValue) {
		return variable != undefined ? variable : defaultValue;
	},

	isEmpty: function(object) {
		if(!object) return true;
		
		for(var key in object) {
			return false;
		}
		return true;
	},
	
	/**/
	getObjectProperty: function(obj, path, propertyName) {
    	if ( !obj ) return null;
    	if ( !path && propertyName ) return obj[propertyName];
    	if ( !path ) return obj;
    	
    	
    	//if the path is a regular property, just return the property
    	if ( $type(path) == 'string') return obj[path];
    	
    	//if the path is an array, then iterate through it until we get the 
    	//property
    	var item = obj;
		for(var i = 0; i < path.length; i++) {
			var nextItem = item[path[i]];
			if ( nextItem ) item = nextItem;
			else return null;
		}
		
		if ( propertyName && path ) return item[propertyName];
		
		return item;    		
	},
	
	isOptionTrue: function(array, index, def){
		if(array[index] != null){
			var type = typeof array[index];
			if(type == 'boolean') return array[index];
			if(type == 'string'){
				if(array[index].matches(/true/i)) return true;
				else if(array[index].matches(/false/i)) return false;
			}
		}
		return def;
	}
};
//MooTools, My Object Oriented Javascript Tools. Copyright (c) 2006 Valerio Proietti, <http://mad4milk.net>, MIT Style License.

var Class = function(properties){
	var klass = function(){
		for (var p in this){
			if (this[p]) this[p]._proto_ = this;
		}
		if (arguments[0] != 'noinit' && this.initialize) return this.initialize.apply(this, arguments);
	};
	klass.extend = this.extend;
	klass.implement = this.implement;
	klass.prototype = properties;
	return klass;
};

Class.empty = function(){};

Class.create = function(properties){
	return new Class(properties);
};

Class.prototype = {

	extend: function(properties){
		var pr0t0typ3 = new this('noinit');
		for (var property in properties){
			var previous = pr0t0typ3[property];
			var current = properties[property];
			if (previous && previous != current) current = previous.parentize(current) || current;
			pr0t0typ3[property] = current;
		}
		return new Class(pr0t0typ3);
	},

	implement: function(properties){
		for (var property in properties) this.prototype[property] = properties[property];
	}

};

Object.extend = function(){
	var args = arguments;
	if (args[1]) args = [args[0], args[1]];
	else args = [this, args[0]];
	for (var property in args[1]) args[0][property] = args[1][property];
	return args[0];
};

Object.Native = function(){
	for (var i = 0; i < arguments.length; i++) arguments[i].extend = Class.prototype.implement;
};

new Object.Native(Function, Array, String, Number);

Function.extend({

	parentize: function(current){
		var previous = this;
		return function(){
			this.parent = previous;
			return current.apply(this, arguments);
		};
	}

});

Function.extend({

	pass: function(args, bind){
		var fn = this;
		if ($type(args) != 'array') args = [args];
		return function(){
			return fn.apply(bind || fn._proto_ || fn, args);
		};
	},

	bind: function(bind){
		var fn = this;
		return function(){
			return fn.apply(bind, arguments);
		};
	},

	bindAsEventListener: function(bind){
		var fn = this;
		return function(event){
			fn.call(bind, event || window.event);
			return false;
		};
	},

	delay: function(ms, bind){
		return setTimeout(this.bind(bind || this._proto_ || this), ms);
	},

	periodical: function(ms, bind){
		return setInterval(this.bind(bind || this._proto_ || this), ms);
	}

});

if (window.ActiveXObject) window.ie = window[window.XMLHttpRequest ? 'ie7' : 'ie6'] = true;
else if (document.childNodes && !document.all && !navigator.taintEnabled) window.khtml = true;
else if (document.getBoxObjectFor != null) window.gecko = true;

function $clear(timer){
	clearTimeout(timer);
	clearInterval(timer);
	return null;
};

function $type(obj){
	if (!obj) return false;
	var type = false;
	if (obj instanceof Function) type = 'function';
	else if (obj.nodeName){
		if (obj.nodeType == 3 && !/\S/.test(obj.nodeValue)) type = 'textnode';
		else if (obj.nodeType == 1) type = 'element';
	}
	else if (obj instanceof Array) type = 'array';
	else if (typeof obj == 'object') type = 'object';
	else if (typeof obj == 'string') type = 'string';
	else if (typeof obj == 'number' && isFinite(obj)) type = 'number';
	return type;
};

var Chain = new Class({

	chain: function(fn){
		this.chains = this.chains || [];
		this.chains.push(fn);
		return this;
	},

	callChain: function(){
		if (this.chains && this.chains.length) this.chains.splice(0, 1)[0].delay(10, this);
	},

	clearChain: function(){
		this.chains = [];
	}

});

if (!Array.prototype.forEach){

	Array.prototype.forEach = function(fn, bind){
		for(var i = 0; i < this.length ; i++) fn.call(bind, this[i], i);
	};
}

Array.extend({

	each: Array.prototype.forEach,

	copy: function(){
		var newArray = [];
		for (var i = 0; i < this.length; i++) newArray.push(this[i]);
		return newArray;
	},

	remove: function(item){
		for (var i = 0; i < this.length; i++){
			if (this[i] == item) this.splice(i, 1);
		}
		return this;
	},

	test: function(item){
		for (var i = 0; i < this.length; i++){
			if (this[i] == item) return true;
		};
		return false;
	},

	extend: function(newArray){
		for (var i = 0; i < newArray.length; i++) this.push(newArray[i]);
		return this;
	},

	associate: function(keys){
		var newArray = [];
		for (var i =0; i < this.length; i++) newArray[keys[i]] = this[i];
		return newArray;
	}

});

function $A(array){
	return Array.prototype.copy.call(array);
};

String.extend({

	test: function(regex, params){
		return this.match(new RegExp(regex, params));
	},
	toInt: function(){
		return parseInt(this);
	},

	camelCase: function(){
		return this.replace(/-\D/gi, function(match){
			return match.charAt(match.length - 1).toUpperCase();
		});
	},
	capitalize: function(){
		return this.toLowerCase().replace(/\b[a-z]/g, function(match){
			return match.toUpperCase();
		});
	},

	trim: function(){
		return this.replace(/^\s*|\s*$/g, '');
	},

	clean: function(){
		return this.replace(/\s\s/g, ' ').trim();
	},

	rgbToHex: function(array){
		var rgb = this.test('([\\d]{1,3})', 'g');
		if (rgb[3] == 0) return 'transparent';
		var hex = [];
		for (var i = 0; i < 3; i++){
			var bit = (rgb[i]-0).toString(16);
			hex.push(bit.length == 1 ? '0'+bit : bit);
		}
		var hexText = '#'+hex.join('');
		if (array) return hex;
		else return hexText;
	},

	hexToRgb: function(array){
		var hex = this.test('^[#]{0,1}([\\w]{1,2})([\\w]{1,2})([\\w]{1,2})$');
		var rgb = [];
		for (var i = 1; i < hex.length; i++){
			if (hex[i].length == 1) hex[i] += hex[i];
			rgb.push(parseInt(hex[i], 16));
		}
		var rgbText = 'rgb('+rgb.join(',')+')';
		if (array) return rgb;
		else return rgbText;
	}

});

Number.extend({

	toInt: function(){
		return this;
	}

});

var Element = new Class({

	initialize: function(el){
		if ($type(el) == 'string') el = document.createElement(el);
		return $(el);
	},

	inject: function(el, where){
		el = $(el) || new Element(el);
		switch(where){
			case "before": $(el.parentNode).insertBefore(this, el); break;
			case "after": {
					if (!el.getNext()) $(el.parentNode).appendChild(this);
					else $(el.parentNode).insertBefore(this, el.getNext());
			} break;
			case "inside": el.appendChild(this); break;
		}
		return this;
	},

	injectBefore: function(el){
		return this.inject(el, 'before');
	},

	injectAfter: function(el){
		return this.inject(el, 'after');
	},

	injectInside: function(el){
		return this.inject(el, 'inside');
	},

	adopt: function(el){
		this.appendChild($(el) || new Element(el));
		return this;
	},

	remove: function(){
		this.parentNode.removeChild(this);
	},

	clone: function(contents){
		return $(this.cloneNode(contents || true));
	},

	replaceWith: function(el){
		var el = $(el) || new Element(el);
		this.parentNode.replaceChild(el, this);
		return el;
	},

	appendText: function(text){
		if (this.getTag() == 'style' && window.ActiveXObject) this.styleSheet.cssText = text;
		else this.appendChild(document.createTextNode(text));
		return this;
	},

	hasClass: function(className){
		return !!this.className.test("\\b"+className+"\\b");
	},

	addClass: function(className){
		if (!this.hasClass(className)) this.className = (this.className+' '+className.trim()).clean();
		return this;
	},

	removeClass: function(className){
		if (this.hasClass(className)) this.className = this.className.replace(className.trim(), '').clean();
		return this;
	},

	toggleClass: function(className){
		if (this.hasClass(className)) return this.removeClass(className);
		else return this.addClass(className);
	},

	setStyle: function(property, value){
		if (property == 'opacity') this.setOpacity(parseFloat(value));
		else this.style[property.camelCase()] = (value.push) ? 'rgb('+value.join(',')+')' : value;
		return this;
	},
	
	setStyles: function(source){
		if ($type(source) == 'object') {
			for (var property in source) this.setStyle(property, source[property]);
		} else if ($type(source) == 'string') {
			if (window.ActiveXObject) this.cssText = source;
			else this.setAttribute('style', source);
		}
		return this;
	},

	setOpacity: function(opacity){
		if (opacity == 0){
			if(this.style.visibility != "hidden") this.style.visibility = "hidden";
		} else {
			if(this.style.visibility != "visible") this.style.visibility = "visible";
		}
		if (window.ActiveXObject) this.style.filter = "alpha(opacity=" + opacity*100 + ")";
		this.style.opacity = opacity;
		return this;
	},

	getStyle: function(property){
		var proPerty = property.camelCase();
		var style = this.style[proPerty] || false;
		if (!style) {
			if (document.defaultView) style = document.defaultView.getComputedStyle(this,null).getPropertyValue(property);
			else if (this.currentStyle) style = this.currentStyle[proPerty];
		}
		if (style && ['color', 'backgroundColor', 'borderColor'].test(proPerty) && style.test('rgb')) style = style.rgbToHex();
		return style;
	},

	addEvent: function(action, fn){
		this[action+fn] = fn.bind(this);
		if (this.addEventListener) this.addEventListener(action, fn, false);
		else this.attachEvent('on'+action, this[action+fn]);
		var el = this;
		if (this != window) Unload.functions.push(function(){
			el.removeEvent(action, fn);
			el[action+fn] = null;
		});
		return this;
	},

	removeEvent: function(action, fn){
		if (this.removeEventListener) this.removeEventListener(action, fn, false);
		else this.detachEvent('on'+action, this[action+fn]);
		return this;
	},

	getBrother: function(what){
		var el = this[what+'Sibling'];
		while ($type(el) == 'textnode') el = el[what+'Sibling'];
		return $(el);
	},

	getPrevious: function(){
		return this.getBrother('previous');
	},

	getNext: function(){
		return this.getBrother('next');
	},

	getFirst: function(){
		var el = this.firstChild;
		while ($type(el) == 'textnode') el = el.nextSibling;
		return $(el);
	},

	getLast: function(){
		var el = this.lastChild;
		while ($type(el) == 'textnode')
		el = el.previousSibling;
		return $(el);
	},

	setProperty: function(property, value){
		switch (property){
			case 'class': this.className = value; break;
			case 'style': this.setStyles(value); break;
			case 'name': if (window.ie){
				var el = $(document.createElement('<'+this.getTag()+' name="'+value+'" />'));
				$each(this.attributes, function(attribute){
					if (attribute.name != 'name') el.setProperty(attribute.name, attribute.value);
				});
				if (this.parentNode) this.replaceWith(el);
				return el;
			}
			default: this.setAttribute(property, value);
		}
		return this;
	},

	setProperties: function(source){
		for (var property in source) this.setProperty(property, source[property]);
		return this;
	},

	setHTML: function(html){
		this.innerHTML = html;
		return this;
	},

	getProperty: function(property){
		return this.getAttribute(property);
	},

	getTag: function(){
		return this.tagName.toLowerCase();
	},

	getOffset: function(what){
		what = what.capitalize();
		var el = this;
		var offset = 0;
		do {
			offset += el['offset'+what] || 0;
			el = el.offsetParent;
		} while (el);
		return offset;
	},

	getTop: function(){
		return this.getOffset('top');
	},

	getLeft: function(){
		return this.getOffset('left');
	},

	getValue: function(){
		var value = false;
		switch(this.getTag()){
			case 'select': value = this.getElementsByTagName('option')[this.selectedIndex].value; break;
			case 'input': if ( (this.checked && ['checkbox', 'radio'].test(this.type)) || (['hidden', 'text', 'password'].test(this.type)) )
				value = this.value; break;
			case 'textarea': value = this.value;
		}
		return value;
	}

});

new Object.Native(Element);

Element.extend({
	hasClassName: Element.prototype.hasClass,
	addClassName: Element.prototype.addClass,
	removeClassName: Element.prototype.removeClass,
	toggleClassName: Element.prototype.toggleClass
});

function $Element(el, method, args){
	if ($type(args) != 'array') args = [args];
	return Element.prototype[method].apply(el, args);
};

function $(el){
	if ($type(el) == 'string') el = document.getElementById(el);
	if ($type(el) == 'element'){
		if (!el.extend){
			Unload.elements.push(el);
			el.extend = Object.extend;
			el.extend(Element.prototype);
		}
		return el;
	} else return false;
};

window.addEvent = document.addEvent = Element.prototype.addEvent;
window.removeEvent = document.removeEvent = Element.prototype.removeEvent;

var Unload = {

	elements: [], functions: [], vars: [],

	unload: function(){
		Unload.functions.each(function(fn){
			fn();
		});

		window.removeEvent('unload', window.removeFunction);

		Unload.elements.each(function(el){
			for(var p in Element.prototype){
				window[p] = null;
				document[p] = null;
				el[p] = null;
			}
			el.extend = null;
		});
	}

};

window.removeFunction = Unload.unload;
window.addEvent('unload', window.removeFunction);
var Fx = fx = {};

Fx.Base = new Class({

	setOptions: function(options){
		this.options = Object.extend({
			onStart: Class.empty,
			onComplete: Class.empty,
			transition: Fx.Transitions.sineInOut,
			duration: 500,
			unit: 'px',
			wait: true,
			fps: 50
		}, options || {});
	},

	step: function(){
		var time = new Date().getTime();
		if (time < this.time + this.options.duration){
			this.cTime = time - this.time;
			this.setNow();
		} else {
			this.options.onComplete.pass(this.element, this).delay(10);
			this.clearTimer();
			this.callChain();
			this.now = this.to;
		}
		this.increase();
	},

	set: function(to){
		this.now = to;
		this.increase();
		return this;
	},

	setNow: function(){
		this.now = this.compute(this.from, this.to);
	},

	compute: function(from, to){
		return this.options.transition(this.cTime, from, (to - from), this.options.duration);
	},

	custom: function(from, to){
		if (!this.options.wait) this.clearTimer();
		if (this.timer) return;
		this.options.onStart.pass(this.element, this).delay(10);
		this.from = from;
		this.to = to;
		this.time = new Date().getTime();
		this.timer = this.step.periodical(Math.round(1000/this.options.fps), this);
		return this;
	},
	clearTimer: function(){
		this.timer = $clear(this.timer);
		return this;
	},

	setStyle: function(element, property, value){
		element.setStyle(property, value + this.options.unit);
	}

});

Fx.Base.implement(new Chain);

Fx.Style = Fx.Base.extend({

	initialize: function(el, property, options){
		this.element = $(el);
		this.setOptions(options);
		this.property = property.camelCase();
	},

	hide: function(){
		return this.set(0);
	},

	goTo: function(val){
		return this.custom(this.now || 0, val);
	},

	increase: function(){
		this.setStyle(this.element, this.property, this.now);
	}

});

Fx.Styles = Fx.Base.extend({

	initialize: function(el, options){
		this.element = $(el);
		this.setOptions(options);
		this.now = {};
	},

	setNow: function(){
		for (var p in this.from) this.now[p] = this.compute(this.from[p], this.to[p]);
	},

	custom: function(objFromTo){
		if (this.timer && this.options.wait) return;
		var from = {};
		var to = {};
		for (var p in objFromTo){
			from[p] = objFromTo[p][0];
			to[p] = objFromTo[p][1];
		}
		return this.parent(from, to);
	},

	increase: function(){
		for (var p in this.now) this.setStyle(this.element, p, this.now[p]);
	}

});

Element.extend({

	effect: function(property, options){
		return new Fx.Style(this, property, options);
	},

	effects: function(options){
		return new Fx.Styles(this, options);
	}

});

Fx.Transitions = {
	linear: function(t, b, c, d){
		return c*t/d + b;
	},
	sineInOut: function(t, b, c, d){
		return -c/2 * (Math.cos(Math.PI*t/d) - 1) + b;
	}

};

function $S(){
	var els = [];
	$A(arguments).each(function(sel){
		if ($type(sel) == 'string') els.extend(document.getElementsBySelector(sel));
		else if ($type(sel) == 'element') els.push($(sel));
	});
	return $Elements(els);
};

var $$ = $S;

function $E(selector, filter){
	return ($(filter) || document).getElement(selector);
};

function $ES(selector, filter){
	return ($(filter) || document).getElementsBySelector(selector);
};

function $Elements(elements){
	return Object.extend(elements, new Elements);
};

Element.extend({

	getElements: function(selector){
		var filters = [];
		selector.clean().split(' ').each(function(sel, i){
			var bits = sel.test('^(\\w*|\\*)(?:#([\\w_-]+)|\\.([\\w_-]+))?(?:\\[["\']?(\\w+)["\']?(?:([\\*\\^\$]?=)["\']?(\\w*)["\']?)?\\])?$');
			if (!bits) return;
			if (!bits[1]) bits[1] = '*';
			var param = bits.remove(bits[0]).associate(['tag', 'id', 'class', 'attribute', 'operator', 'value']);
			if (i == 0){
				if (param['id']){
					var el = this.getElementById(param['id']);
					if (!el || ((param['tag'] != '*') && ($Element(el, 'getTag') != param['tag']))) return;
					filters = [el];
				} else {
					filters = $A(this.getElementsByTagName(param['tag']));
				}
			} else {
				filters = $Elements(filters).filterByTagName(param['tag']);
				if (param['id']) filters = $Elements(filters).filterById(param['id']);
			}
			if (param['class']) filters = $Elements(filters).filterByClassName(param['class']);
			if (param['attribute']) filters = $Elements(filters).filterByAttribute(param['attribute'], param['value'], param['operator']);

		}, this);
		filters.each(function(el){
			$(el);
		});
		return $Elements(filters);
	},

	getElementById: function(id){
		var el = document.getElementById(id);
		if (!el) return false;
		for(var parent = el.parentNode; parent != this; parent = parent.parentNode){
			if (!parent) return false;
		}
		return el;
	},

	getElement: function(selector){
		return this.getElementsBySelector(selector)[0];
	},

	getElementsBySelector: function(selector){
		var els = [];
		selector.split(',').each(function(sel){
			els.extend(this.getElements(sel));
		}, this);
		return $Elements(els);
	}

});

document.extend = Object.extend;

document.extend({
	getElementsByClassName: function(className){
		return document.getElements('.'+className);
	},
	getElement: Element.prototype.getElement,
	getElements: Element.prototype.getElements,
	getElementsBySelector: Element.prototype.getElementsBySelector

});

var Elements = new Class({

	action: function(actions){
		this.each(function(el){
			el = $(el);
			if (actions.initialize) actions.initialize.apply(el);
			for(var action in actions){
				var evt = false;
				if (action.test('^on[\\w]{1,}')) el[action] = actions[action];
				else if (evt = action.test('([\\w-]{1,})event$')) el.addEvent(evt[1], actions[action]);
			}
		});
	},

	//internal methods

	filterById: function(id){
		var found = [];
		this.each(function(el){
			if (el.id == id) found.push(el);
		});
		return found;
	},

	filterByClassName: function(className){
		var found = [];
		this.each(function(el){
			if ($Element(el, 'hasClass', className)) found.push(el);
		});
		return found;
	},

	filterByTagName: function(tagName){
		var found = [];
		this.each(function(el){
			found.extend($A(el.getElementsByTagName(tagName)));
		});
		return found;
	},

	filterByAttribute: function(name, value, operator){
		var found = [];
		this.each(function(el){
			var att = el.getAttribute(name);
			if(!att) return;
			if (!operator) return found.push(el);

			switch(operator){
				case '*=': if (att.test(value)) found.push(el); break;
				case '=': if (att == value) found.push(el); break;
				case '^=': if (att.test('^'+value)) found.push(el); break;
				case '$=': if (att.test(value+'$')) found.push(el);
			}

		});
		return found;
	}

});

new Object.Native(Elements);

var Ajax = ajax = new Class({

	setOptions: function(options){
		this.options = {
			method: 'post',
			postBody: null,
			async: true,
			onComplete: Class.empty,
			onStateChange: Class.empty,
			update: null,
			evalScripts: false
		};
		Object.extend(this.options, options || {});
	},

	initialize: function(url, options){
		this.setOptions(options);
		this.url = url;
		this.transport = this.getTransport();
	},

	request: function(){
		this.transport.open(this.options.method, this.url, this.options.async);
		this.transport.onreadystatechange = this.onStateChange.bind(this);
		if (this.options.method == 'post'){
			this.transport.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
			if (this.transport.overrideMimeType) this.transport.setRequestHeader('Connection', 'close');
		}
		switch($type(this.options.postBody)){
			case 'element': this.options.postBody = $(this.options.postBody).toQueryString(); break;
			case 'object': this.options.postBody = Object.toQueryString(this.options.postBody);
		}
		if($type(this.options.postBody) == 'string') this.transport.send(this.options.postBody);
		else this.transport.send(null);
		return this;
	},

	onStateChange: function(){
		this.options.onStateChange.delay(10, this);
		if (this.transport.readyState == 4 && this.transport.status == 200){
			if (this.options.update) $(this.options.update).setHTML(this.transport.responseText);
			this.options.onComplete.pass([this.transport.responseText, this.transport.responseXML], this).delay(20);
			if (this.options.evalScripts) this.evalScripts.delay(30, this);
			this.transport.onreadystatechange = Class.empty;
			this.callChain();
		}
	},

	evalScripts: function(){
		if(scripts = this.transport.responseText.match(/<script[^>]*?>[\S\s]*?<\/script>/g)){
			scripts.each(function(script){
				eval(script.replace(/^<script[^>]*?>/, '').replace(/<\/script>$/, ''));
			});
		}
	},

	getTransport: function(){
		if (window.XMLHttpRequest) return new XMLHttpRequest();
		else if (window.ActiveXObject) return new ActiveXObject('Microsoft.XMLHTTP');
	}

});

Ajax.implement(new Chain);

Object.toQueryString = function(source){
	var queryString = [];
	for (var property in source) queryString.push(encodeURIComponent(property)+'='+encodeURIComponent(source[property]));
	return queryString.join('&');
};

Element.extend({

	send: function(options){
		options = Object.extend(options, {postBody: this.toQueryString(), method: 'post'});
		return new Ajax(this.getProperty('action'), options).request();
	},

	toQueryString: function(){
		var queryString = [];
		$A(this.getElementsByTagName('*')).each(function(el){
			var name = $(el).name;
			var value = el.getValue();
			if (value && name) queryString.push(encodeURIComponent(name)+'='+encodeURIComponent(value));
		});
		return queryString.join('&');
	}

});
var Drag = {};

Drag.Base = new Class({

	setOptions: function(options){
		this.options = Object.extend({
			handle: false,
			unit: 'px',
			onStart: Class.empty,
			onComplete: Class.empty,
			onDrag: Class.empty,
			xMax: false,
			xMin: false,
			yMax: false,
			yMin: false
		}, options || {});
	},

	initialize: function(el, xModifier, yModifier, options){
		this.setOptions(options);
		this.element = $(el);
		this.handle = $(this.options.handle) || this.element;
		if (xModifier) this.xp = xModifier.camelCase();
		if (yModifier) this.yp = yModifier.camelCase();
		this.handle.onmousedown = this.start.bind(this);
	},

	start: function(evt){
		evt = evt || window.event;
		this.startX = evt.clientX;
		this.startY = evt.clientY;

		this.handleX = this.startX - this.handle.getLeft();
		this.handleY = this.startY - this.handle.getTop();

		this.set(evt);
		this.options.onStart.pass(this.element, this).delay(10);
		document.onmousemove = this.drag.bind(this);
		document.onmouseup = this.end.bind(this);
		return false;
	},

	addStyles: function(x, y){
		if (this.xp){
			var stylex = this.element.getStyle(this.xp).toInt();

			var movex = function(val){
				this.element.setStyle(this.xp, val+this.options.unit);
			}.bind(this);

			if (this.options.xMax && stylex >= this.options.xMax){
				if (this.clientX <= this.handleX+this.handle.getLeft()) movex(stylex+x);
				if (stylex > this.options.xMax) movex(this.options.xMax);
			} else if(this.options.xMin && stylex <= this.options.xMin){
				if (this.clientX >= this.handleX+this.handle.getLeft()) movex(stylex+x);
				if (stylex < this.options.xMin) movex(this.options.xMin);
			} else movex(stylex+x);
		}
		if (this.yp){
			var styley = this.element.getStyle(this.yp).toInt();

			var movey = function(val){
				this.element.setStyle(this.yp, val+this.options.unit);
			}.bind(this);

			if (this.options.yMax && styley >= this.options.yMax){
				if (this.clientY <= this.handleY+this.handle.getTop()) movey(styley+y);
				if (styley > this.options.yMax) movey(this.options.yMax);
			} else if(this.options.yMin && styley <= this.options.yMin){
				if (this.clientY >= this.handleY+this.handle.getTop()) movey(styley+y);
				if (styley < this.options.yMin) movey(this.options.yMin);
			} else movey(styley+y);
		}
	},

	drag: function(evt){
		evt = evt || window.event;
		this.clientX = evt.clientX;
		this.clientY = evt.clientY;
		this.options.onDrag.pass(this.element, this).delay(5);
		this.addStyles((this.clientX-this.lastMouseX), (this.clientY-this.lastMouseY));
		this.set(evt);
		return false;
	},

	set: function(evt){
		this.lastMouseX = evt.clientX;
		this.lastMouseY = evt.clientY;
		return false;
	},

	end: function(){
		document.onmousemove = null;
		document.onmouseup = null;
		this.options.onComplete.pass(this.element, this).delay(10);
	}

});

Drag.Move = Drag.Base.extend({

	extendOptions: function(options){
		this.options = Object.extend(this.options || {}, Object.extend({
			onSnap: Class.empty,
			droppables: [],
			snapDistance: 8,
			snap: true,
			xModifier: 'left',
			yModifier: 'top',
			container: false
		}, options || {}));
	},

	initialize: function(el, options){
		this.extendOptions(options);
		this.container = $(this.options.container);
		this.parent(el, this.options.xModifier, this.options.yModifier, this.options);
	},

	start: function(evt){
		if (this.options.container) {
			var cont = $(this.options.container).getPosition();
			Object.extend(this.options, {
				xMax: cont.right-this.element.offsetWidth,
				xMin: cont.left,
				yMax: cont.bottom-this.element.offsetHeight,
				yMin: cont.top
			});
		}
		this.parent(evt);
		if (this.options.snap) document.onmousemove = this.checkAndDrag.bind(this);
		return false;
	},

	drag: function(evt){
		this.parent(evt);
		this.options.droppables.each(function(drop){
			if (this.checkAgainst(drop)){
				if (drop.onOver && !drop.dropping) drop.onOver.pass([this.element, this], drop).delay(10);
				drop.dropping = true;
			} else {
				if (drop.onLeave && drop.dropping) drop.onLeave.pass([this.element, this], drop).delay(10);
				drop.dropping = false;
			}
		}, this);
		return false;
	},

	checkAndDrag: function(evt){
		evt = evt || window.event;
		var distance = Math.round(Math.sqrt(Math.pow(evt.clientX - this.startX, 2)+Math.pow(evt.clientY - this.startY, 2)));
		if (distance > this.options.snapDistance){
			this.set(evt);
			this.options.onSnap.pass(this.element, this).delay(10);
			document.onmousemove = this.drag.bind(this);
			this.addStyles(-(this.startX-evt.clientX), -(this.startY-evt.clientY));
		}
		return false;
	},

	checkAgainst: function(el){
		x = this.clientX+Window.getScrollLeft();
		y = this.clientY+Window.getScrollTop();
		var el = $(el).getPosition();
		return (x > el.left && x < el.right && y < el.bottom && y > el.top);
	},

	end: function(){
		this.parent();
		this.options.droppables.each(function(drop){
			if (drop.onDrop && this.checkAgainst(drop)) drop.onDrop.pass([this.element, this], drop).delay(10);
		}, this);
	}

});

Element.extend({

	makeDraggable: function(options){
		return new Drag.Move(this, options);
	},

	makeResizable: function(options){
		return new Drag.Base(this, 'width', 'height', options);
	},

	getPosition: function(){
		var obj = {};
		obj.width = this.offsetWidth;
		obj.height = this.offsetHeight;
		obj.left = this.getLeft();
		obj.top = this.getTop();
		obj.right = obj.left + obj.width;
		obj.bottom = obj.top + obj.height;
		return obj;
	}

});

var Window = {

	disableImageCache: function(){
		if (window.ActiveXObject) document.execCommand("BackgroundImageCache", false, true);
	},

	extend: Object.extend,

	getWidth: function(){
		return window.innerWidth || document.documentElement.clientWidth || 0;
	},

	getHeight: function(){
		return window.innerHeight || document.documentElement.clientHeight || 0;
	},

	getScrollHeight: function(){
		return document.documentElement.scrollHeight;
	},

	getScrollWidth: function(){
		return document.documentElement.scrollWidth;
	},

	getScrollTop: function(){
		return document.documentElement.scrollTop || window.pageYOffset || 0;
	},

	getScrollLeft: function(){
		return document.documentElement.scrollLeft || window.pageXOffset || 0;
	},

	onDomReady: function(init){
		var state = document.readyState;
		if (state && document.childNodes && !document.all && !navigator.taintEnabled){ //khtml
			if (state.test(/loaded|complete/)) return init();
			else return Window.onDomReady.pass(init).delay(100);
		} else if (state && window.ActiveXObject){ //ie
			var script = $('_ie_ready_');
			if (!script) document.write("<script id='_ie_ready_' defer='true' src='://'></script>");
			$('_ie_ready_').addEvent('readystatechange', function(){
				if (this.readyState == 'complete') init();
			});
			return;
		} else { //others
			var myInit = function() {
				if (arguments.callee.done) return;
				arguments.callee.done = true;
				init();
			};
			window.addEvent("load", myInit);
			document.addEvent("DOMContentLoaded", myInit);
		}
	}

};

var Cookie = {

	set: function(key, value, duration){
		var date = new Date();
		date.setTime(date.getTime()+((duration || 365)*86400000));
		document.cookie = key+"="+value+"; expires="+date.toGMTString()+"; path=/";
	},

	get: function(key){
		var myValue, myVal;
		document.cookie.split(';').each(function(cookie){
			if(myVal = cookie.trim().test(key+'=(.*)')) myValue = myVal[1];
		});
		return myValue;
	},

	remove: function(key){
		this.set(key, '', -1);
	}

};

var Json = {

	toString: function(el){
		var string = [];

		var isArray = function(array){
			var string = [];
			array.each(function(ar){
				string.push(Json.toString(ar));
			});
			return string.join(',');
		};

		var isObject = function(object){
			var string = [];
			for (var property in object) string.push('"'+property+'":'+Json.toString(object[property]));
			return string.join(',');
		};

		switch($type(obj)){
			case 'number': string.push(obj); break;
			case 'string': string.push('"'+obj+'"'); break;
			case 'function': string.push(obj); break;
			case 'object': string.push('{'+isObject(obj)+'}'); break;
			case 'array': string.push('['+isArray(obj)+']');
		}

		return string.join(',');
	},

	evaluate: function(str){
		return eval('(' + str + ')');
	}

};

var Sortables = new Class({

	setOptions: function(options) {
		this.options = {
			handles: false,
			fxDuration: 250,
			fxTransition: Fx.Transitions.sineInOut,
			maxOpacity: 0.5,
			onComplete: Class.empty,
			onStart: Class.empty,
			contain: false
		};
		Object.extend(this.options, options || {});
	},

	initialize: function(elements, options){
		this.setOptions(options);
		this.options.handles = this.options.handles || elements;
		var trash = new Element('div').injectInside($(document.body));
		$A(elements).each(function(el, i){
			var copy = $(el).clone().setStyles({
				'position': 'absolute',
				'opacity': '0',
				'display': 'none'
			}).injectInside(trash);
			var elEffect = el.effect('opacity', {
				duration: this.options.fxDuration,
				wait: false,
				transition: this.options.fxTransition
			}).set(1);
			var copyEffects = copy.effects({
				duration: this.options.fxDuration,
				wait: false,
				transition: this.options.fxTransition,
				onComplete: function(){
					copy.setStyle('display', 'none');
				}
			});
			var yMax = false;
			var yMin = false;
			if (this.options.contain){
				yMax = $(el.parentNode).getTop()+el.parentNode.offsetHeight-el.offsetHeight;
				yMin = el.parentNode.getTop();
			}
			var dragger = new Drag.Move(copy, {
				handle: this.options.handles[i],
				yMax: yMax,
				yMin: yMin,
				xModifier: false,
				onStart: function(){
					this.options.onStart.bind(this).delay(10);
					copy.setHTML(el.innerHTML).setStyles({
						'display': 'block',
						'opacity': this.options.maxOpacity,
						'top': el.getTop()+'px',
						'left': el.getLeft()+'px'
					});
					elEffect.custom(elEffect.now, this.options.maxOpacity);
				}.bind(this),
				onComplete: function(){
					this.options.onComplete.bind(this).delay(10);
					copyEffects.custom({
						'opacity': [this.options.maxOpacity, 0],
						'top': [copy.getTop(), el.getTop()]
					});
					elEffect.custom(elEffect.now, 1);
				}.bind(this),
				onDrag: function(){
					if (el.getPrevious() && copy.getTop() < (el.getPrevious().getTop())) el.injectBefore(el.getPrevious());
					else if (el.getNext() && copy.getTop() > (el.getNext().getTop())) el.injectAfter(el.getNext());
				}
			});
		}, this);
	}

});

Fx.Scroll = Fx.Base.extend({

	initialize: function(el, options) {
		this.element = $(el);
		this.setOptions(options);
	},

	down: function(){
		return this.custom(this.element.scrollTop, this.element.scrollHeight-this.element.offsetHeight);
	},

	up: function(){
		return this.custom(this.element.scrollTop, 0);
	},

	increase: function(){
		this.element.scrollTop = this.now;
	}
});

Fx.Slide = Fx.Base.extend({

	initialize: function(el, options){
		this.element = $(el);
		this.wrapper = new Element('div').injectAfter(this.element).setStyle('overflow', 'hidden').adopt(this.element);
		this.setOptions(options);
		if (!this.options.mode) this.options.mode = 'vertical';
		this.now = [];
	},

	setNow: function(){
		[0,1].each(function(i){
			this.now[i] = this.compute(this.from[i], this.to[i]);
		}, this);
	},

	vertical: function(){
		this.margin = 'top';
		this.layout = 'height';
		this.startPosition = [this.element.scrollHeight, '0'];
		this.endPosition = ['0', -this.element.scrollHeight];
		return this;
	},

	horizontal: function(){
		this.margin = 'left';
		this.layout = 'width';
		this.startPosition = [this.element.scrollWidth, '0'];
		this.endPosition = ['0', -this.element.scrollWidth];
		return this;
	},

	hide: function(){
		this[this.options.mode]();
		this.wrapper.setStyle(this.layout, '0');
		this.element.setStyle('margin-'+this.margin, -this.element['scroll'+this.layout.capitalize()]+this.options.unit);
		return this;
	},

	show: function(){
		this[this.options.mode]();
		this.wrapper.setStyle(this.layout, this.element['scroll'+this.layout.capitalize()]+this.options.unit);
		this.element.setStyle('margin-'+this.margin, '0');
		return this;
	},

	toggle: function(mode){
		this[this.options.mode]();
		if (this.wrapper['offset'+this.layout.capitalize()] > 0) return this.custom(this.startPosition, this.endPosition);
		else return this.custom(this.endPosition, this.startPosition);
	},

	increase: function(){
		this.wrapper.setStyle(this.layout, this.now[0]+this.options.unit);
		this.element.setStyle('margin-'+this.margin, this.now[1]+this.options.unit);
	}

});

Fx.Color = Fx.Base.extend({

	initialize: function(el, property, options){
		this.element = $(el);
		this.setOptions(options);
		this.property = property;
		this.now = [];
	},

	custom: function(from, to){
		return this.parent(from.hexToRgb(true), to.hexToRgb(true));
	},

	setNow: function(){
		[0,1,2].each(function(i){
			this.now[i] = Math.round(this.compute(this.from[i], this.to[i]));
		}, this);
	},

	increase: function(){
		this.element.setStyle(this.property, "rgb("+this.now[0]+","+this.now[1]+","+this.now[2]+")");
	},

	fromColor: function(color){
		return this.custom(color, this.element.getStyle(this.property));
	},

	toColor: function(color){
		return this.custom(this.element.getStyle(this.property), color);
	}

});

Fx.Height = Fx.Style.extend({

	initialize: function(el, options){
		this.parent(el, 'height', options);
		this.element.setStyle('overflow', 'hidden');
	},

	toggle: function(){
		if (this.element.offsetHeight > 0) return this.custom(this.element.offsetHeight, 0);
		else return this.custom(0, this.element.scrollHeight);
	},

	show: function(){
		return this.set(this.element.scrollHeight);
	}

});

Fx.Width = Fx.Style.extend({

	initialize: function(el, options){
		this.parent(el, 'width', options);
		this.element.setStyle('overflow', 'hidden');
		this.iniWidth = this.element.offsetWidth;
	},

	toggle: function(){
		if (this.element.offsetWidth > 0) return this.custom(this.element.offsetWidth, 0);
		else return this.custom(0, this.iniWidth);
	},

	show: function(){
		return this.set(this.iniWidth);
	}

});

Fx.Opacity = Fx.Style.extend({

	initialize: function(el, options){
		this.parent(el, 'opacity', options);
		this.now = 1;
	},

	toggle: function(){
		if (this.now > 0) return this.custom(1, 0);
		else return this.custom(0, 1);
	},

	show: function(){
		return this.set(1);
	}

});

Fx.Transitions = {
	linear: function(t, b, c, d){
		return c*t/d + b;
	},
	quadIn: function(t, b, c, d){
		return c*(t/=d)*t + b;
	},
	quadOut: function(t, b, c, d){
		return -c *(t/=d)*(t-2) + b;
	},
	quadInOut: function(t, b, c, d){
		if ((t/=d/2) < 1) return c/2*t*t + b;
		return -c/2 * ((--t)*(t-2) - 1) + b;
	},
	cubicIn: function(t, b, c, d){
		return c*(t/=d)*t*t + b;
	},
	cubicOut: function(t, b, c, d){
		return c*((t=t/d-1)*t*t + 1) + b;
	},
	cubicInOut: function(t, b, c, d){
		if ((t/=d/2) < 1) return c/2*t*t*t + b;
		return c/2*((t-=2)*t*t + 2) + b;
	},
	quartIn: function(t, b, c, d){
		return c*(t/=d)*t*t*t + b;
	},
	quartOut: function(t, b, c, d){
		return -c * ((t=t/d-1)*t*t*t - 1) + b;
	},
	quartInOut: function(t, b, c, d){
		if ((t/=d/2) < 1) return c/2*t*t*t*t + b;
		return -c/2 * ((t-=2)*t*t*t - 2) + b;
	},
	quintIn: function(t, b, c, d){
		return c*(t/=d)*t*t*t*t + b;
	},
	quintOut: function(t, b, c, d){
		return c*((t=t/d-1)*t*t*t*t + 1) + b;
	},
	quintInOut: function(t, b, c, d){
		if ((t/=d/2) < 1) return c/2*t*t*t*t*t + b;
		return c/2*((t-=2)*t*t*t*t + 2) + b;
	},
	sineIn: function(t, b, c, d){
		return -c * Math.cos(t/d * (Math.PI/2)) + c + b;
	},
	sineOut: function(t, b, c, d){
		return c * Math.sin(t/d * (Math.PI/2)) + b;
	},
	sineInOut: function(t, b, c, d){
		return -c/2 * (Math.cos(Math.PI*t/d) - 1) + b;
	},
	expoIn: function(t, b, c, d){
		return (t==0) ? b : c * Math.pow(2, 10 * (t/d - 1)) + b;
	},
	expoOut: function(t, b, c, d){
		return (t==d) ? b+c : c * (-Math.pow(2, -10 * t/d) + 1) + b;
	},
	expoInOut: function(t, b, c, d){
		if (t==0) return b;
		if (t==d) return b+c;
		if ((t/=d/2) < 1) return c/2 * Math.pow(2, 10 * (t - 1)) + b;
		return c/2 * (-Math.pow(2, -10 * --t) + 2) + b;
	},
	circIn: function(t, b, c, d){
		return -c * (Math.sqrt(1 - (t/=d)*t) - 1) + b;
	},
	circOut: function(t, b, c, d){
		return c * Math.sqrt(1 - (t=t/d-1)*t) + b;
	},
	circInOut: function(t, b, c, d){
		if ((t/=d/2) < 1) return -c/2 * (Math.sqrt(1 - t*t) - 1) + b;
		return c/2 * (Math.sqrt(1 - (t-=2)*t) + 1) + b;
	},
	elasticIn: function(t, b, c, d, a, p){
		if (t==0) return b;  if ((t/=d)==1) return b+c;  if (!p) p=d*.3; if (!a) a = 1;
		if (a < Math.abs(c)){ a=c; var s=p/4; }
		else var s = p/(2*Math.PI) * Math.asin(c/a);
		return -(a*Math.pow(2,10*(t-=1)) * Math.sin( (t*d-s)*(2*Math.PI)/p )) + b;
	},
	elasticOut: function(t, b, c, d, a, p){
		if (t==0) return b;  if ((t/=d)==1) return b+c;  if (!p) p=d*.3; if (!a) a = 1;
		if (a < Math.abs(c)){ a=c; var s=p/4; }
		else var s = p/(2*Math.PI) * Math.asin(c/a);
		return a*Math.pow(2,-10*t) * Math.sin( (t*d-s)*(2*Math.PI)/p ) + c + b;
	},
	elasticInOut: function(t, b, c, d, a, p){
		if (t==0) return b;  if ((t/=d/2)==2) return b+c;  if (!p) p=d*(.3*1.5); if (!a) a = 1;
		if (a < Math.abs(c)){ a=c; var s=p/4; }
		else var s = p/(2*Math.PI) * Math.asin(c/a);
		if (t < 1) return -.5*(a*Math.pow(2,10*(t-=1)) * Math.sin( (t*d-s)*(2*Math.PI)/p )) + b;
		return a*Math.pow(2,-10*(t-=1)) * Math.sin( (t*d-s)*(2*Math.PI)/p )*.5 + c + b;
	},
	backIn: function(t, b, c, d, s){
		if (!s) s = 1.70158;
		return c*(t/=d)*t*((s+1)*t - s) + b;
	},
	backOut: function(t, b, c, d, s){
		if (!s) s = 1.70158;
		return c*((t=t/d-1)*t*((s+1)*t + s) + 1) + b;
	},
	backInOut: function(t, b, c, d, s){
		if (!s) s = 1.70158;
		if ((t/=d/2) < 1) return c/2*(t*t*(((s*=(1.525))+1)*t - s)) + b;
		return c/2*((t-=2)*t*(((s*=(1.525))+1)*t + s) + 2) + b;
	},
	bounceIn: function(t, b, c, d){
		return c - Fx.Transitions.bounceOut (d-t, 0, c, d) + b;
	},
	bounceOut: function(t, b, c, d){
		if ((t/=d) < (1/2.75)){
			return c*(7.5625*t*t) + b;
		} else if (t < (2/2.75)){
			return c*(7.5625*(t-=(1.5/2.75))*t + .75) + b;
		} else if (t < (2.5/2.75)){
			return c*(7.5625*(t-=(2.25/2.75))*t + .9375) + b;
		} else {
			return c*(7.5625*(t-=(2.625/2.75))*t + .984375) + b;
		}
	},
	bounceInOut: function(t, b, c, d){
		if (t < d/2) return Fx.Transitions.bounceIn(t*2, 0, c, d) * .5 + b;
		return Fx.Transitions.bounceOut(t*2-d, 0, c, d) * .5 + c*.5 + b;
	}

};

var Tips = new Class({

	setOptions: function(options){
		this.options = {
			transitionStart: Fx.Transitions.sineInOut,
			transitionEnd: Fx.Transitions.sineInOut,
			maxTitleChars: 30,
			fxDuration: 150,
			maxOpacity: 1,
			timeOut: 100,
			className: 'tooltip'
		};
		Object.extend(this.options, options || {});
	},

	initialize: function(elements, options){
		this.elements = elements;
		this.setOptions(options);
		this.toolTip = new Element('div').addClassName(this.options.className).setStyle('position', 'absolute').injectInside(document.body);
		this.toolTitle = new Element('H4').injectInside(this.toolTip);
		this.toolText = new Element('p').injectInside(this.toolTip);
		this.fx = new fx.Style(this.toolTip, 'opacity', {duration: this.options.fxDuration, wait: false}).hide();
		$A(elements).each(function(el){
			$(el).myText = el.title || false;
			if (el.myText) el.removeAttribute('title');
			if (el.href){
				if (el.href.test('http://')) el.myTitle = el.href.replace('http://', '');
				if (el.href.length > this.options.maxTitleChars) el.myTitle = el.href.substr(0,this.options.maxTitleChars-3)+"...";
			}
			if (el.myText && el.myText.test('::')){
				var dual = el.myText.split('::');
				el.myTitle = dual[0].trim();
				el.myText = dual[1].trim();
			}
			el.onmouseover = function(){
				this.show(el);
				return false;
			}.bind(this);
			el.onmousemove = this.locate.bindAsEventListener(this);
			el.onmouseout = function(){
				this.timer = $clear(this.timer);
				this.disappear();
			}.bind(this);
		}, this);
	},

	show: function(el){
		this.toolTitle.innerHTML = el.myTitle;
		this.toolText.innerHTML = el.myText;
		this.timer = $clear(this.timer);
		this.fx.options.transition = this.options.transitionStart;
		this.timer = this.appear.delay(this.options.timeOut, this);
	},

	appear: function(){
		this.fx.custom(this.fx.now, this.options.maxOpacity);
	},

	locate: function(evt){
		var doc = document.documentElement;
		this.toolTip.setStyles({'top': evt.clientY + doc.scrollTop + 15 + 'px', 'left': evt.clientX + doc.scrollLeft - 30 + 'px'});
	},

	disappear: function(){
		this.fx.options.transition = this.options.transitionEnd;
		this.fx.custom(this.fx.now, 0);
	}

});

Fx.Elements = Fx.Base.extend({

	initialize: function(elements, options){
		this.elements = [];
		elements.each(function(el){
			this.elements.push($(el));
		}, this);
		this.setOptions(options);
		this.now = {};
	},

	setNow: function(){
		for (var i in this.from){
			var iFrom = this.from[i];
			var iTo = this.to[i];
			var iNow = this.now[i] = {};
			for (var p in iFrom) iNow[p] = this.compute(iFrom[p], iTo[p]);
		}
	},

	custom: function(objObjs){
		if (this.timer && this.options.wait) return;
		var from = {};
		var to = {};
		for (var i in objObjs){
			var iProps = objObjs[i];
			var iFrom = from[i] = {};
			var iTo = to[i] = {};
			for (var prop in iProps){
				iFrom[prop] = iProps[prop][0];
				iTo[prop] = iProps[prop][1];
			}
		}
		return this.parent(from, to);
	},

	increase: function(){
		for (var i in this.now){
			var iNow = this.now[i];
			for (var p in iNow) this.setStyle(this.elements[i.toInt()], p, iNow[p]);
		}
	}

});

Fx.Accordion = Fx.Elements.extend({

	extendOptions: function(options){
		Object.extend(this.options, Object.extend({
			start: 'open-first',
			fixedHeight: false,
			fixedWidth: false,
			alwaysHide: false,
			wait: false,
			onActive: Class.empty,
			onBackground: Class.empty,
			height: true,
			opacity: true,
			width: false
		}, options || {}));
	},

	initialize: function(togglers, elements, options){
		this.parent(elements, options);
		this.extendOptions(options);
		this.previousClick = 'nan';
		togglers.each(function(tog, i){
			$(tog).addEvent('click', function(){this.showThisHideOpen(i)}.bind(this));
		}, this);
		this.togglers = togglers;
		this.h = {}; this.w = {}; this.o = {};
		this.elements.each(function(el, i){
			this.now[i] = {};
			$(el).setStyles({'height': 0, 'overflow': 'hidden'});
		}, this);
		switch(this.options.start){
			case 'first-open': this.elements[0].setStyle('height', this.elements[0].scrollHeight+this.options.unit); break;
			case 'open-first': this.showThisHideOpen(0); break;
		}
	},

	hideThis: function(i){
		if (this.options.height) this.h = {'height': [this.elements[i].offsetHeight, 0]};
		if (this.options.width) this.w = {'width': [this.elements[i].offsetWidth, 0]};
		if (this.options.opacity) this.o = {'opacity': [this.now[i]['opacity'] || 1, 0]};
	},

	showThis: function(i){
		if (this.options.height) this.h = {'height': [this.elements[i].offsetHeight, this.options.fixedHeight || this.elements[i].scrollHeight]};
		if (this.options.width) this.w = {'width': [this.elements[i].offsetWidth, this.options.fixedWidth || this.elements[i].scrollWidth]};
		if (this.options.opacity) this.o = {'opacity': [this.now[i]['opacity'] || 0, 1]};
	},

	showThisHideOpen: function(iToShow){
		if (iToShow != this.previousClick || this.options.alwaysHide){
			this.previousClick = iToShow;
			var objObjs = {};
			var err = false;
			var madeInactive = false;
			this.elements.each(function(el, i){
				this.now[i] = this.now[i] || {};
				if (i != iToShow){
					this.hideThis(i);
				} else if (this.options.alwaysHide){
					if (el.offsetHeight == el.scrollHeight){
						this.hideThis(i);
						madeInactive = true;
					} else if (el.offsetHeight == 0){
						this.showThis(i);
					} else {
						err = true;
					}
				} else if (this.options.wait && this.timer){
					this.previousClick = 'nan';
					err = true;
				} else {
					this.showThis(i);
				}
				objObjs[i] = Object.extend(this.h, Object.extend(this.o, this.w));
			}, this);
			if (err) return;
			if (!madeInactive) this.options.onActive.call(this, this.togglers[iToShow], iToShow);
			this.togglers.each(function(tog, i){
				if (i != iToShow || madeInactive) this.options.onBackground.call(this, tog, i);
			}, this);
			return this.custom(objObjs);
		}
	}

});
Array.extend({
	append: function(item) {
		this[this.length] = item;
	}
});
Element.implement({
	getParent: function() {
		return this.parentNode;
	},
	
	getContentHeight: function() {
		if ( this.getTag() == 'iframe' ) 
			return this.getFrameDocument().body.scrollHeight;
		
		return this.getVisibleHeight();
	},
	
	getFrameDocument: function() { 
		if ( this.getTag() != 'iframe' ) return false;

		return this.contentDocument || this.document ||
			(this.contentWindow && this.contentWindow.document ? 
			this.contentWindow.document :
			null);
			
	},
	
	getVisibleHeight: function() {
		return this.scrollHeight;
	},
	
	getText: function() {
		return this.textContent || this.innerText;
	},
	
	/**/
	toQueryString: function(){
		var queryString = [];
		$A(this.getElementsByTagName('*')).each(function(el){
			if ( el.nodeType != 8 ) {
				var name = $(el).name;
				var value = el.getValue();
				if (value && name) queryString.push(encodeURIComponent(name)+'='+encodeURIComponent(value));
			}
		});
		return queryString.join('&');
	},
	
	isSelected: function() {
		return this['type'] == 'checkbox' && 
			( this['checked'] == true || 
			this.checked == true ); //on is for IE
	}

});


String.extend({
	startsWith: function(text) {
		return this.test('^' + text) != null;
	},
	
	endsWith: function(text) {
		return this.test(text + '$') != null;
	},
	
	contains: function(text) {
		return this.test(text) != null;
	},
	
	addParameter: function (param, value) { //for a url string
		return this + (( this.contains('?') ? null : '?') || 
			( this.endsWith('&') ? '' : '&' )) + 
			param + '=' + value;
	}
});

// By lenhatanh | nhatanh.voxfamilyvn.com | Depends on mootools
// Heavily modified from original (very heavily modified)
var Slider = new Class({

	initialize: function(background, sliders, options) {
		this.options(options);
		this.setup(background, sliders);
		//this.addCheckMarks();
		for(i=0;i<this.sliders.length;i++)
		{
			this.sliders[i].onmousedown = this.start.bind(this);
		}
		if(this.opt.centerClickable)
		{
			this.bg_bar.onmousedown = this.setPos.bind(this);
		}
	},

	options: function(options)
	{
		this.opt = {
			onComplete: Class.empty, 
			onDrag: Class.empty,
			a: 'hoz',
			centerClickable: false,
			prioritySlider: 1,
			numIntervals: 20,
			minValue: 0,
			maxValue: 10,
			sliderPositions: [0,100]
		};
		Object.extend(this.opt, options || {});
		this.intervalSize = 100/this.opt.numIntervals;
		this.opt.minValue = 0;
		this.opt.maxValue = 100;
	},
	
	reOptions: function()
	{
		if(this.bg_bar.position[0] != this.findPosition(this.bg_bar)[0])
		{
			this.bg_bar.position = this.findPosition(this.bg_bar);
		}
	},
	
	setup: function(background, sliders) {
		this.bg_bar = $(background);
		this.bg_bar.position = this.findPosition(this.bg_bar);

		var aX = this.bg_bar.scrollWidth || this.bg_bar.width || this.bg_bar.getStyle('width');
		var aY = this.bg_bar.scrollHeight || this.bg_bar.height || this.bg_bar.getStyle('height');
		var _2 = this.isHorizontal() ? aX : aY;
		this.length = parseInt(_2);

		//slider information
		//slider.position is always the pixel center of the slider
		
		this.currentMoving = -1;

		this.sliders = new Array();
		for(i=0;i<sliders.length;i++)
		{
			if($(sliders[i][0]))
			{
				this.sliders[i] = $(sliders[i][0]);
				this.sliders[i].text = $(sliders[i][1]);
				var sliderWidth = this.sliders[i].getStyle('width') || this.sliders[i].width;
				var sliderHeight = this.sliders[i].getStyle('height') || this.sliders[i].height;
				var _1 = this.isHorizontal() ? sliderWidth : sliderHeight;
				_1 = parseInt(_1);
				this.sliders[i].left_border = Math.ceil(_1/2);
				this.sliders[i].right_border = _1 - this.sliders[i].left_border;
				
				if ( this.opt.sliderPositions[i] != null ) {
					this.sliders[i].interval = this.opt.sliderPositions[i];
				} else if ( i == 0 ) {
					this.sliders[i].interval = this.opt.minValue;
				} else if (i==sliders.length-1 ) {
					this.sliders[i].interval = this.opt.maxValue;
				} else {
					this.sliders[i].interval = this.findClosestInterval(this.findPosition(this.sliders[i])[0] + this.sliders[i].left_border);
				}

				this.sliders[i].position = this.convertIntervalToPixels(this.sliders[i].interval);

				this.currentMoving = i;
				this.setPositionStyle();
			}
		}
		for(i=0;i<this.sliders.length;i++)
		{
			this.sliders[i].min_int = (i == 0) ? this.opt.minValue : this.sliders[i-1].interval + this.intervalSize;
			this.sliders[i].max_int = (i == this.sliders.length-1) ? this.opt.maxValue : this.sliders[i+1].interval - this.intervalSize;
			this.sliders[i].array_position = i;
		}

		//All sliders must be the same width
		var sliderWidth = this.sliders[0].getStyle('width') || this.sliders[0].width;
		var maxIntervals = Math.floor(this.length/sliderWidth);
		this.opt.numIntervals = (this.opt.numIntervals < 3) ? 3 : this.opt.numIntervals;
		this.opt.numIntervals = (this.opt.numIntervals > maxIntervals) ? maxIntervals : this.opt.numIntervals;
	},
	
	/*experimental, unlikely to work
	addCheckMarks : function()
	{
		this.reOptions();
		for(i=0;i<this.opt.numIntervals;i++)
		{
			console.log("Place at pixel position: " + (this.convertIntervalToPixels(this.intervalSize * i)));
			document.write('<div id="sliderMarker' + i + '" style="position:absolute;top:' + this.bg_bar.position[1] + 'px;left:' + (this.convertIntervalToPixels(this.intervalSize * i)) + 'px;width:8px;height:23px;background: url(/imagefiles/style/slider_marker.gif) left no-repeat;float:left;"></div>');
		}
	},*/
	
	isHorizontal: function () {
		return this.opt.a == 'hoz' ? 1 : 0;
	},
	
	findPosition: function(obj) {
	var curleft = 0;
	var curtop = 0;
	if (obj.offsetParent) {
		curleft = obj.offsetLeft
		curtop = obj.offsetTop
		while (obj = obj.offsetParent) {
			curleft += obj.offsetLeft
			curtop += obj.offsetTop
		}
	}
	return (this.isHorizontal()) ? [curleft, curtop] : [curtop,curleft];
	},
			
	start: function(e) {
		if (!e) var e = window.event;
		if (e.target) targ = e.target;
		else if (e.srcElement) targ = e.srcElement;
		if (targ.nodeType == 3) // defeat Safari bug
			targ = targ.parentNode;

		this.currentMoving = targ.array_position;
		document.onmousemove = this.drag.bind(this);
		document.onmouseup = this.end.bind(this);
	},
	
	drag: function(e){
		if (!e) var e = window.event;
		if (e.target) targ = e.target;
		else if (e.srcElement) targ = e.srcElement;
		if (targ.nodeType == 3) // defeat Safari bug
			targ = targ.parentNode;

		this.updatePositions(e);
		this.setPositionStyle();
		this.setText();
		this.opt.onDrag(this.sliders[0].interval, this.sliders[this.sliders.length-1].interval,this);
	},
		
	end: function(){
		document.onmousemove = null;
		document.onmouseup = null;
		this.currentMoving = -1;
		this.opt.onComplete(this.sliders[0].interval, this.sliders[this.sliders.length-1].interval,this);
	},
	
	setPos: function(e) {
		if(this.currentMoving == -1)
		{
			this.currentMoving = this.opt.prioritySlider-1;
			this.updatePositions(e);
			this.setPositionStyle();
			this.opt.onComplete(this.sliders[0].interval, this.sliders[this.sliders.length-1].interval,this);
			this.currentMoving = -1;
		}
	},

	getScroll: function() {
		return this.isHorizontal() ? Window.getScrollLeft() : Window.getScrollTop();
	},

	updatePositions: function(e,position) {
		this.reOptions();
		if(this.currentMoving != -1)
		{
			var current_mouse_pos = (position != null) ? position : this.getMousePosition(e);
			var new_interval = this.findClosestInterval(current_mouse_pos);

			var valid_interval = this.checkInterval(new_interval);
			this.sliders[this.currentMoving].interval = valid_interval;
			this.sliders[this.currentMoving].position = this.convertIntervalToPixels(valid_interval);

			if(this.currentMoving > 0)//don't need to do left if there is no left
				this.sliders[this.currentMoving - 1].max_int = this.sliders[this.currentMoving].interval - this.intervalSize;
			if(this.currentMoving < this.sliders.length-1)
				this.sliders[this.currentMoving + 1].min_int = this.sliders[this.currentMoving].interval + this.intervalSize;
		}
	},
	
	findClosestInterval: function(position)
	{
		var percentage = (position - this.bg_bar.position[0])/this.length;
		var currentPosition = this.opt.minValue + percentage * (this.opt.maxValue - this.opt.minValue);
		var intervalRight = (Math.round(currentPosition/this.intervalSize) + 1) * this.intervalSize;
		var intervalCenter = (Math.round(currentPosition/this.intervalSize)) * this.intervalSize;
		var intervalLeft = (Math.round(currentPosition/this.intervalSize) - 1) * this.intervalSize;
		var nearestInvertal = -1;
		if(intervalRight - currentPosition > Math.abs(currentPosition - intervalCenter))
			if(currentPosition - intervalLeft > Math.abs(currentPosition - intervalCenter))
				nearestInterval = intervalCenter;
			else
				nearestInterval = intervalLeft;
		else
			if(currentPosition - intervalLeft > intervalRight - currentPosition)
				nearestInterval = intervalRight;
			else
				nearestInterval = intervalLeft;
		nearestInterval = (percentage >= 0.98) ? this.opt.maxValue : nearestInterval;
		nearestInterval = (percentage <= 0.02) ? this.opt.minValue : nearestInterval;
		return nearestInterval;
	},

	checkInterval: function(interval)
	{
		interval = (interval > this.sliders[this.currentMoving].max_int) ? this.sliders[this.currentMoving].max_int : interval;
		interval = (interval < this.sliders[this.currentMoving].min_int) ? this.sliders[this.currentMoving].min_int : interval;
		return interval;
	},
	
	convertIntervalToPixels: function(interval)
	{
		return (this.length * (interval - this.opt.minValue)/(this.opt.maxValue - this.opt.minValue));
	},
	
	//actually sets the position of the slider in the style
	setPositionStyle: function(){
		if(this.currentMoving != -1 && this.sliders[this.currentMoving] != null)
		{
			var axis = (this.isHorizontal()) ? 'left' : 'top';
			var newPosition = this.sliders[this.currentMoving].position - this.sliders[this.currentMoving].left_border;
			if(!isNaN(newPosition) && newPosition != "Infinity")
			{
				this.sliders[this.currentMoving].setStyle(axis,newPosition);
			}
		}
	},
	
	setText: function()
	{
		if(this.currentMoving != -1)
		{
			this.sliders[this.currentMoving].text.firstChild.nodeValue = this.sliders[this.currentMoving].interval + "%";
		}
	},

	firstPos: function() {
		return this.isHorizontal() ? this.bg_bar.getOffset('left') : this.bg_bar.getOffset('top');
	},
	
	curPos: function(e) {
		e = e || window.event;
		return this.isHorizontal() ? e.clientX : e.clientY;
	},
	
	getScroll: function() {
		return this.isHorizontal() ? Window.getScrollLeft() : Window.getScrollTop();
	},
	
	getMousePosition: function(e)
	{
		var posx = 0;
		var posy = 0;
		if (!e) var e = window.event;
		if (e.pageX || e.pageY) 	{
			posx = e.pageX;
			posy = e.pageY;
		}
		else if (e.clientX || e.clientY) 	{
			posx = e.clientX + document.body.scrollLeft
				+ document.documentElement.scrollLeft;
			posy = e.clientY + document.body.scrollTop
				+ document.documentElement.scrollTop;
		}
		return (this.isHorizontal() ? posx : posy);
	},
	
	resetPositions: function()
	{
		this.sliders[0].interval = this.opt.minValue;
		this.sliders[this.sliders.length-1].interval = this.opt.maxValue;
		this.opt.onComplete(this.sliders[0].interval, this.sliders[this.sliders.length-1].interval,this);
	}
});

var TimeSlider = Slider.extend({
	options: function(options)
	{
		this.opt = {
			onComplete: Class.empty, 
			onDrag: Class.empty,
			a: 'hoz',
			centerClickable: false,
			prioritySlider: 1,
			numIntervals: 20
		};
		Object.extend(this.opt, options || {});
		this.opt.minDate = new Date(this.opt.minValue);
		this.opt.maxDate = new Date(this.opt.maxValue);
		this.opt.minValue = Math.round(this.opt.minDate.getTime()/60000);
		this.opt.maxValue = Math.round(this.opt.maxDate.getTime()/60000);

		for(i=0;i<this.opt.sliderPositions.length;i++)
		{
			if(this.opt.sliderPositions[i] > 525948)//used to distinguish a date from a number already in minutes (it's 1 yr in min)
			{
				date = new Date(this.opt.sliderPositions[i]);
				this.opt.sliderPositions[i] = Math.round(date.getTime()/60000);
			}
		}
		
		this.daysOfWeek = ["Su","Mo","Tu","We","Th","Fr","Sa"];
		var increments = [1,5,10,30,60];//increments in minutes
		var range = this.opt.maxValue - this.opt.minValue;
		for(i=0;i<increments.length;i++)
			if(range/this.opt.numIntervals < increments[i] || i == increments.length-1)
				break;
		this.intervalSize = increments[i];
	},
	
	end: function(){
		document.onmousemove = null;
		document.onmouseup = null;
		this.currentMoving = -1;
		this.opt.onComplete(this.sliders[0].interval*60000, this.sliders[this.sliders.length-1].interval*60000,this);
	},
		
	setText: function()
	{
		var currDate = new Date(this.sliders[this.currentMoving].interval*60000);
		var extraZero = (currDate.getMinutes() < 10) ? "0" : "";
		var timePostFix = (currDate.getHours() >= 12) ? "p" : "a";
		var hourToDisplay = (currDate.getHours() == 0 || currDate.getHours()%12 == 0) ? 12 : currDate.getHours()%12;
		this.sliders[this.currentMoving].text.firstChild.nodeValue = this.daysOfWeek[currDate.getDay()] + " " + 
																		hourToDisplay + ":" + 
																		extraZero + currDate.getMinutes() + 
																		timePostFix;
	}
});


var PriceSlider = Slider.extend({
	options: function(options)
	{
		this.opt = {
			onComplete: Class.empty, 
			onDrag: Class.empty,
			a: 'hoz',
			centerClickable: false,
			prioritySlider: 1,
			numIntervals: 20,
			minValue: 0,
			maxValue: 500,
			currencyPrefix: '$',
			sliderPositions: [null,null]
		};
		Object.extend(this.opt, options || {});
		var increments = [1,5,10,20,50,100,200,500,1000];
		var range = this.opt.maxValue - this.opt.minValue;
		for(i=0;i<8;i++)
			if(range/this.opt.numIntervals < increments[i])
				break;
		this.intervalSize = increments[i];
	},
	
	setText: function()
	{
		var slider = this.sliders[this.currentMoving];
		slider.text.innerHTML = this.opt.currencyPrefix + slider.interval;
	}
});




var AbstractFilterGroup = Class.create({
	initialize: function(options) {
		this.mDisplayableName = null;
		this.mFilterType = null;
		this.mContainer = null;
		this.mHasCheckbox = false;
		this.mDefaultChecked = true;
		this.mHasLink = false;
		this.mStrictItems = false;
		this.mItemLocation = null;
		this.mPropertyName = null;
		this.mFilterName = null;
		this.mKeyPrefix = '';
		this.mFilterOptions = null;
		this.mMatchValue = true;
		this.mStrict = false;
		this.mAutoBucket = true;
		this.boldLinks = false;
		
		this.mFilter = null;
		
		this.setup(options);
	},		
		
	setup: function(options) {
		this.mDisplayableName = CommonUtils.getValue(
			options, 'displayableName', this.mDisplayableName);
		this.mFilterType = CommonUtils.getValue(
			options, 'filterType', this.mFilterType);
		this.mContainer = CommonUtils.getValue(
			options, 'container', this.mContainer);
		this.mHasCheckbox = CommonUtils.getValue(
			options, 'hasCheckbox', this.mHasCheckbox);
		this.mDefaultChecked = CommonUtils.getValue(
			options, 'defaultChecked', this.mDefaultChecked);
		this.mHasLink = CommonUtils.getValue(
			options, 'hasLink', this.mHasLink);
		this.mStrictItems = CommonUtils.getValue(
			options, 'strictItems', this.mItemLocation);
		this.mItemLocation = CommonUtils.getValue(
			options, 'itemLocation', this.mItemLocation);
		this.mPropertyName = CommonUtils.getValue(
			options, 'propertyName', this.mPropertyName);
		this.mFilterName = CommonUtils.getValue(
			options, 'filterName', this.mFilterName);
		this.mKeyPrefix = CommonUtils.getValue(
			options, 'keyPrefix', this.mKeyPrefix);
		this.mMatchValue = CommonUtils.getValue(
			options, 'matchValue', this.mMatchValue);
		this.mStrict = CommonUtils.getValue(
			options, 'strict', this.mStrict);
		this.mAutoBucket = CommonUtils.getValue(
			options, 'autoBucket', this.mAutoBucket);
		this.mBoldLinks = CommonUtils.getValue(
			options, 'boldLinks', this.mBoldLinks);
	},

	reset: function() {
		for( key in this.mFilterOptions) {
			this.mFilterOptions[key].reset();
		}
				
		this.mFilter = null;
	},
	
	hasNoFilter: function() {
		return !this.mFilter || this.mFilter.isEmpty();
	},
	
	isEmpty: function() {
		if ( this.mFilterOptions == null ) return true;
		
		for( key in this.mFilterOptions ) {
			return false;
		}
				
		return true;
	},

	addFilter: function(filter) {
		if ( !this.mActiveFilters ) this.mActiveFilters = [];
		this.mActiveFilters.push(filter);
	},
	
	removeFilter: function(filter) {
		if ( this.mActiveFilters ) this.mActiveFilters.remove(filter);
	},
	
	isCheckboxType: function() {
		return this.mHasCheckbox;
	},
	
	isLinkType: function() {
		return !this.mHasCheckbox && this.mHasLink;
	},
	
	isSliderType: function() {
		return false;
	}
	
});
var FilterGroup = AbstractFilterGroup.extend({
	initialize: function(options) {
		this.parent(options);
	}
});
var RangeFilterGroup = AbstractFilterGroup.extend({
	initialize: function(options) {
		this.parent(options);
		
		this.mMinPropertyName = CommonUtils.getValue(
			options, 'minPropertyName', this.mMinPropertyName);
		this.mMaxPropertyName = CommonUtils.getValue(
			options, 'maxPropertyName', this.mMaxPropertyName);
			
		this.mFilterOptions = new Object();
		
		var ranges = options['ranges'] || [];
		for(var i = 0; i < ranges.length; i++) {
			var range = ranges[i];
			var minValue = range[0];
			var maxValue = range[1];
			this.addFilterOption( minValue, maxValue);
		}
	},

	addFilterOption: function( minValue, maxValue ) {
		this.mFilterOptions[this.mKeyPrefix + minValue + '_' + maxValue] =
				new RangeFilterOption(minValue, maxValue);
	}

});
var AbstractFilterOption = Class.create( {
			
	initialize: function() {
		this.mLowPrice = 9999999;
		this.mCount = 0;
	},
	
	addResult: function(result) { 
		if ( parseInt(result['lowPrice']) < this.mLowPrice && 
			parseInt(result['lowPrice']) != 0 ) 
			this.mLowPrice = result['lowPrice'];
		this.mCount++; 
	},
	
	reset: function() {
		this.mCount = 0;
	}
});

var MatchFilterOption = AbstractFilterOption.extend({
	initialize: function(filterValue) {
		this.mFilterValue = filterValue;
		this.parent();
	}
});
var RangeFilterOption = AbstractFilterOption.extend({
	initialize: function(minValue, maxValue) {
		this.parent();
		
		this.mMinRange = minValue;
		this.mMaxRange = maxValue;
	}
});
var AbstractFilter = Class.create({
	initialize: function(filterBy, keyPrefix, itemLocation) {
 		this.mFilterBy = filterBy;
        this.mFilterOptions = new Object();
        this.mNumFilterOptions = 0;
        this.mItemLocation = itemLocation;
 
        this.mKeyPrefix = CommonUtils.getSafeValue(keyPrefix, 'fov_');		
	},

	testItem: function(itemOptionValue) {},
		
	testItems: function(itemOptionValues) {
		var passes = false;
		for ( itemOptionValue in itemOptionValues) {
			if ( this.testItem(itemOptionValue) ) {
				return true;
			}
		}		
	},
    
    getMatchResult: function() {
    	return true;
    },
    
    /**/    
	isEmpty: function() {
		return this.getNumFilterOptions() == 0;	
	},
	
	getNumFilterOptions: function() {
		return this.mNumFilterOptions;
	},
	
    addFilterOption: function(filterOption) {
    	this.mNumFilterOptions++;
        this.mFilterOptions[this.generateKey(filterOption)] = 0;
    },
    
    setQuantity: function(filterOption, num) {
    	this.mFilterOptions[this.generateKey(filterOption)] = num;
    },
    
    getQuantity: function(filterOption) {
    	return this.mFilterOptions[this.generateKey(filterOption)] || 0;
    },
    
    incrementQuantity: function(filterOption) {
    	var quantity = this.getQuantity(filterOption);
    	this.setQuantity(filterOption, quantity++);
    },
    
    reset: function() {
    	this.mFilterOptions = new Object();
    	this.mNumFilterOptions = 0;
    },
    
    testProperty: function(item, property) {
    	if ( !item || (item[property] != 0 && 
    		!item[property]) ) return false;
		var passes = false;
		if ( $type(item[property]) == 'object' ||
				$type(item[property] == 'array')) {
			passes = this.testItems(item[property]);	
		} else {
			passes = this.testItem(item[property]);
		}    	
		return passes;
    },
    
    
    test: function(obj) {
    	var passes = false;

    	/**/
    	if ( this.mItemLocation && $type(this.mItemLocation) == 'array' ) {
    		passes = true;
    		for(var i = 0; i < this.mItemLocation.length; i++) {
    			var path = this.mItemLocation[i];
    			if ( $type(path) != 'array' ) {
    				passes = this.testObject(
    					CommonUtils.getObjectProperty(obj, this.mItemLocation));
    			} else {
	    			var testObj = CommonUtils.getObjectProperty(obj, path);
	
	    			if ( testObj ) {
	    				passes = this.testObject(testObj);
	    				if ( passes == false ) return false;
	    			}
    			}
    		}
    	} else {
    		passes = this.testObject(obj);
    	}
	
		return passes;
    }, 

    testObject: function(item) {
		var passes = false;
		if ( $type(this.mFilterBy) == 'string' ) {
			passes = this.testProperty(item, this.mFilterBy);
		} else if ( $type(this.mFilterBy) == 'array' ) {
			for( var i = 0; i < this.mFilterBy.length; i++ ) {
				passes = this.testProperty(item, this.mFilterBy[i]);
				if ( passes ) break; 
			}
		}
				
		return passes;
    },
    
    generateKey: function(value) {
    	var key = this.mKeyPrefix + ($type(value) == 'string' ? 
    		value.toUpperCase() : value);
    	return key;
    }
});
var KeywordMatchFilter = AbstractFilter.extend({
	initialize: function(filterBy, keyPrefix, itemLocation) {
		this.parent(filterBy, keyPrefix, itemLocation);
    	this.mFilterType = 'match';
	},
	
	testItem: function(itemOptionValue) {
    	itemOptionValue = itemOptionValue.toLowerCase();
    	if ( this.mFilterOptions ) {
    		for( key in this.mFilterOptions ) {
    			if ( itemOptionValue.toLowerCase().indexOf( 
    				key.trim().toLowerCase()) > -1 ) {
    				return this.getMatchResult();
    			}
    		}
    	}
    	
    	return !this.getMatchResult();		
	}
	

});
/**/
/* */
var PositiveOrMatchFilter = AbstractFilter.extend({
    initialize: function(filterBy, keyPrefix, itemLocation) {
    	this.parent(filterBy, keyPrefix, itemLocation);
    	this.mFilterType = 'match';
       
    },

/**/
	
    testItem: function(itemOptionValue) {
    	if ( $type(itemOptionValue) == 'string' ) itemOptionValue = 
    		itemOptionValue.toUpperCase().replace(' ', '_');
    	
    	if ( this.mFilterOptions[this.generateKey(itemOptionValue)] > -1 ) {
			return this.getMatchResult();
    	}
    	return !this.getMatchResult();
    }
});
/* */
var PositiveAndMatchFilter = PositiveOrMatchFilter.extend({
	testItems: function(itemOptionValues) {
		var passes = true;
		var numTestCases = 0;
		for ( itemOptionValue in itemOptionValues) {
			numTestCases++;
			if ( !this.testItem(itemOptionValue) ) {
				return false;
			} 
		}	
		return passes && numTestCases > 0;	
	}	
});
/* */
var PositiveAndStrictMatchFilter = PositiveAndMatchFilter.extend({
	testItems: function(itemOptionValues) {
		var passedTestCases = 0;
		for ( itemOptionValue in itemOptionValues) {
			if ( this.testItem(itemOptionValue) ) {
				passedTestCases++;
			} 
		}	
		return passedTestCases == this.getNumFilterOptions();	
	}	
});
/**/
var NegativeOrMatchFilter = PositiveOrMatchFilter.extend({
    getMatchResult: function() {
    	return false;
    }
});
var RangeSearchResultsFilter = Class.create({
	initialize: function(filterByLow, filterByHigh, keyPrefix, itemLocation) {
		this.mFilterType = 'range';
		this.mFilterByLow = filterByLow;
		this.mFilterByHigh = filterByHigh || filterByLow;
		this.mLowRange = -1;
		this.mHighRange = 999999999999;
		this.mItemLocation = itemLocation;
        this.mFilterOptions = new Array();
        this.mNumFilterOptions = 0;
        this.mKeyPrefix = keyPrefix || 'fov_';
	},
	
	update: function(lowRange, highRange) {
		this.mLowRange = lowRange;
		this.mHighRange = highRange;
	},

    test: function(obj) {
    	var passes = false;
    	
    	/**/
    	if ( this.mItemLocation && $type(this.mItemLocation) == 'array' ) {
    		passes = true;
    		for(var i = 0; i < this.mItemLocation.length; i++) {
    			var path = this.mItemLocation[i];
    			var testObj = CommonUtils.getObjectProperty(obj, path);
    			if ( testObj ) {
    				passes = this.testObject(testObj);
    				if ( passes == false ) return false;
    			}
    		}
    	} else {
    		passes = this.testObject(obj);
    	}
	
		return passes;
    }, 
	
	testObject: function(item) {

		if ( !item || !item[this.mFilterByLow] == undefined ) return false;	
		return this.mLowRange <= parseFloat(item[this.mFilterByHigh]) && 
			parseFloat(item[this.mFilterByLow]) <= this.mHighRange;
	},
	
	isEmpty: function() {
		return this.mNumFilterOptions == 0; //here to fit into filter framework
	},
	
	addFilterOption: function(filterOption) {
    	this.mNumFilterOptions++;
    	var range = filterOption.split('_');
    	if ( range.length == 2) {
    		this.update(range[0], range[1]);
    	}
        this.mFilterOptions[this.generateKey(filterOption)] = 0;
    },
        
    generateKey: function(value) {
    	var key = this.mKeyPrefix + ($type(value) == 'string' ? 
    		value.toUpperCase() : value);
    	return key;
    }
});
var RefinementProcessor= Class.create({
	initialize: function() {
		this.mInvalidFilters = {};
	},
	
	process: function(items, filters) {
		if ( !items || !filters || filters.length == 0 ) return items;

		var results = new Array();
		
		for(var i = 0; i < items.length; i++) {
			var passes = true;
			var item = items[i];
			for( filterName in filters) {
				var filter = filters[filterName];
				if (!this.mInvalidFilters[filterName] && !filter.test(item) ) {
					passes = false;
					break;
				} 
			}
			if ( passes ) results[results.length] = item;
		}
		
		return results;
	}
});

/*
 * Depends on mootools.86+
 * Copyright NexTag 2006, 2007
 */
var AbstractUIManager = Class.create({
	initialize: function(container) {
		this.mContainer = $(container);
		this.mAllowRestore = true;
	},

	updateUI: function() {},
	save: function() {},
	restore: function() {}
});
/*
 * 
 * Depends on mootools.86+
 * Copyright NexTag 2006, 2007
 */
var ProgressUIManager = AbstractUIManager.extend({
	initialize: function(container, 
			startValue, maxValue, 
			barElement, textElement,
			callback) {
		this.parent(container)
		this.mViewable = true;
		this.mProgressBar = new ProgressBar($(barElement), $(textElement),
			callback);
		this.mStartValue = startValue;
		this.mStartMax = maxValue;
	},

	/* */	
	start: function() {
		this.mProgressBar.start(this.mStartValue, this.mStartMax);
	},
	
	updateUI: function(newMax, maxValue) {
		this.mProgressBar.updateTo(newMax);
	},
	
	getValue: function() {
		if ( this.mProgressBar ) return this.mProgressBar.mBarValue;
		return 0;
	}
});
var IMapMarker = Class.create({
	initialize: function() {},

	getHTML: function() {},

	getLatitude: function() {},

	getLongitude: function() {},
	
	getStarRating: function() {},
	
	getDistance: function() {},
	
	getPrice: function() {}
});

var HotelMapMarker = IMapMarker.extend({
	initialize: function(hotel) {
		this.mHotel = hotel;
	},

	getHTML: function() {
		return infoWindowHTML(this.mHotel);
	},

	getLatitude: function() {
		return this.mHotel['geoLocation'] ? this.mHotel['geoLocation']['latitude']: undefined;
	},

	getLongitude: function() {
		return this.mHotel['geoLocation'] ? this.mHotel['geoLocation']['longitude'] : undefined;
	},
	
	getStarRating: function() {
		return this.mHotel['starRating'];
	},
	
	getDistance: function() {
		return this.mHotel['distance'];
	},
	
	getPrice: function(){
		return this.mHotel['lowPrice'];
	}
});

var GoogleMapMarker = Class.create({
	initialize: function(IMapMarker, iconType) {
		var icon = this.buildBaseIcon();
		if(iconType == "price"){
			icon.image = "/images/travel/markers/icon" + this.getIndexByPrice(IMapMarker) + ".png";
		} else if(iconType == "distance") {
			icon.image = "/images/travel/markers/icon" + this.getIndexByDistance(IMapMarker) + ".png";
		} else if(iconType == "stars"){
			icon.image = "/images/travel/markers/stars" + (5-IMapMarker.getStarRating()) + ".png";
		} else {
			icon.image = "http://www.google.com/intl/en_us/mapfiles/marker.png";
		}
		var marker = new GMarker(new GLatLng(IMapMarker.getLatitude(), IMapMarker.getLongitude()), icon)
		GEvent.addListener(marker, "click", function() {
			marker.openInfoWindowHtml(IMapMarker.getHTML());
		});
		return marker;
	},
	
	buildBaseIcon: function(){
		var baseIcon = new GIcon();
		baseIcon.shadow = "http://www.google.com/mapfiles/shadow50.png";
		baseIcon.iconSize = new GSize(20, 34);
		baseIcon.shadowSize = new GSize(37, 34);
		baseIcon.iconAnchor = new GPoint(9, 34);
		baseIcon.infoWindowAnchor = new GPoint(9, 2);
		baseIcon.infoShadowAnchor = new GPoint(18, 25);
		return baseIcon
	},
	
	getIndexByDistance: function(IMapMarker) {
		var distance = IMapMarker.getDistance();
		if(distance < 1) return 1;
		if(distance < 5) return 2;
		if(distance < 10) return 3;
		if(distance < 20) return 4;
		return 5;
	},

	getIndexByPrice: function(IMapMarker) {
		var price = IMapMarker.getPrice()/100;
		if(price < 50) return 1;
		if(price < 100) return 2;
		if(price < 150) return 3;
		if(price < 300) return 4;
		return 5;
	}
});

var HotelMapMarkerFactory = new Object({
	createMarkers: function(hotels, options) {
		var markers = [];
		var maxNum = (options['maxNum']) ? options['maxNum'] : "100000";
		var totalMarkers = 0;
		for(var i = 0; i < hotels.length && i < maxNum; i++) {
			var hotel = hotels[i];
			var marker = this.createMarker(hotel,options);
			markers.push(marker);
			if(hotel['geoLocation'])
				totalMarkers++;
		}
		return markers;
	},
	
	createMarker: function(hotel,options) {
		if ( hotel['geoLocation'] ) {
			if(options["type"] == "google") {
				return new GoogleMapMarker(new HotelMapMarker(hotel),options["iconType"]);
			}
		}
		return null;
	}
});

var MapUIManager = AbstractUIManager.extend({
	initialize: function(largeMapLink, smallMapLink) {
		this.mLargeMapLink = $(largeMapLink);
		if(this.mLargeMapLink)
			this.mLargeMapLink.addEvent('click',this.swapMaps.bind(this));
		
		this.mSmallMapLink = $(smallMapLink);
		if(this.mSmallMapLink)
			this.mSmallMapLink.addEvent('click',this.swapMaps.bind(this));
		
		this.mMap = null;
		this.mRegisteredElements = [];
	},
	
	swapMaps: function() {
		this.notifyMapElements(new MapEvent("swapmap",""));
	},
	
	centerMapOn: function(i) {
		this.notifyMapElements(new MapEvent("centeron",i));
	},
	
	hideMaps: function() {
		this.notifyMapElements(new MapEvent("hidemaps",""));
	},
	
	createMiniMap: function(i) {
		var miniMap = new MiniMapListener(i,this,this.mResults[i]);
	},
	
	removeMiniMap: function(i) {
		this.notifyMapElements(new MapEvent("deleteMiniMap",i));
		for(var i=0;i<this.mRegisteredElements.length;i++){
			if(this.mRegisteredElements[i].rowNum != null && this.mRegisteredElements[i].rowNum == i){
				this.mRegisteredElements.remove(this.mRegisteredElements[i]);
			}
		}
	},
	
	updateUI: function(results) {
		if ( !results || !GBrowserIsCompatible()) return;
		this.mResults = results;
		this.notifyMapElements(new MapEvent("update",results));
	},
	
	registerMapElement: function(elem){
		this.mRegisteredElements.push(elem);
	},

	notifyMapElements: function(event){
		for(var i=0;i<this.mRegisteredElements.length;i++){
			this.mRegisteredElements[i].notify(event);
		}
	}	
});

var AbstractMapListener = new Class({
	notify: function(event){},
	alert: function(event){}
});

var MapListener = AbstractMapListener.extend({
	initialize: function(smallContainer,largeContainer,manager,city) {
		if(!GBrowserIsCompatible()) return;
		this.mSmallContainer = $(smallContainer);
		this.mLargeContainer = $(largeContainer);
		this.mSmallOuterContainer = $(smallContainer + "-outer-titled");
		this.mLargeOuterContainer = $(largeContainer + "-outer");

		this.mManager = manager;
		this.mManager.registerMapElement(this);

		this.mCity = city;
		this.mMarkBy = "default";
		this.mMaxMarkersToShow = 15;
		
		this.mMapsDisabled = false;

		this.mCurrentMap = (this.getCookie("nextagMap") == null) ? "small" : this.getCookie("nextagMap");
		this.setCookie("nextagMap",this.mCurrentMap,"/");
		if(this.mCurrentMap == "small") {
			this.mSmallMap = new GMap2(this.mSmallContainer);
			this.mSmallMap.addControl(new GSmallMapControl());
		} else {
			this.mSmallOuterContainer.setStyle('display','none');
			this.mLargeOuterContainer.setStyle('display','block');
			this.mLargeMap = new GMap2(this.mLargeContainer);
			this.mLargeMap.addControl(new GSmallMapControl());
		}
		this.centerMap();
	},
	
	swapMaps: function(){
		this.mCurrentMap = (this.mCurrentMap == "small") ? "large" : "small";
		if(this.mCurrentMap == "large") {
			this.mSmallOuterContainer.setStyle('display','none');
			this.mLargeOuterContainer.setStyle('display','block');
			if(!this.mLargeMap) {
				this.mLargeMap = new GMap2(this.mLargeContainer);
				this.mLargeMap.addControl(new GSmallMapControl());
				this.centerMap();
			}
			this.mLargeMap.checkResize();
			this.setCookie("nextagMap","large","/");
		} else if (this.mCurrentMap == "small") {
			this.mSmallOuterContainer.setStyle('display','block');
			this.mLargeOuterContainer.setStyle('display','none');
			if(!this.mSmallMap) {
				this.mSmallMap = new GMap2(this.mSmallContainer);
				this.mSmallMap.addControl(new GSmallMapControl());
				this.centerMap();
			}
			this.mSmallMap.checkResize();
			this.setCookie("nextagMap","small","/");
		}
	},
	
	hideMaps: function(){
		this.mSmallOuterContainer.setStyle('display','none');
		this.mLargeOuterContainer.setStyle('display','none');
	},
	
	centerMap: function() {
		getLatLong(this.mCity,this.cityCenterCallBack.bind(this));
	},
	
	cityCenterCallBack: function(newCenter){
		if(newCenter) {
			var map = (this.mCurrentMap == "small") ? this.mSmallMap : this.mLargeMap;
			map.setCenter(newCenter,11);
			this.updateResults();
		} else {
			if( this.mCurrentMap == "small" ) {
				$('nextag-maps-small-outer').innerHTML = "<b>Sorry, we are unable to provide hotel maps at this time. <a href=\"javascript:pc.mMapUIManager.hideMaps();\">Hide this message</a></b>";
			} else {
				$('nextag-maps-large-outer').innerHTML = "<b>Sorry, we are unable to provide hotel maps at this time. <a href=\"javascript:pc.mMapUIManager.hideMaps();\">Hide this message</a></b>";
			}
			this.mMapsDisabled = true;
		}
	},
	
	centerMapOnMarker: function(markerIndex) {
		var map = (this.mCurrentMap == "small") ? this.mSmallMap : this.mLargeMap;
		if(this.mMarkers[markerIndex]) {
			this.mMarkers[markerIndex].openInfoWindowHtml(infoWindowHTML(this.mResults[markerIndex]));
		}
	},
	
	notify: function(event){
		if(event.type == "hidemaps"){
			this.hideMaps();
		} else if(this.mMapsDisabled) {
			return;
		} else if(event.type == "update"){
			this.updateResults(event.info);
		} else if(event.type == "markby"){
			this.setMarkBy(event.info);
			this.updateResults();
		} else if(event.type == "swapmap"){
			this.swapMaps();
		} else if(event.type == "centeron"){
			this.centerMapOnMarker(event.info);
		} else if(event.type == "maxmarkers"){
			this.mMaxMarkersToShow = event.info;
			this.updateResults();
		}
	},

	updateResults: function(contextResults) {
		if(contextResults) this.mResults = contextResults;
		if(!this.mResults) return;
		var currentMap = (this.mCurrentMap == "small") ? this.mSmallMap : this.mLargeMap;
		if(this.mMapsDisabled) return;
		if(!currentMap.isLoaded()){this.updateResults.delay(1000);return;}
	
		currentMap.clearOverlays();
		//this.markerManager = new GMarkerManager(currentMap);
		var markers = HotelMapMarkerFactory.createMarkers(this.mResults,{"type":"google","iconType":this.mMarkBy,"maxNum":this.mMaxMarkersToShow});
		this.mMarkers = markers;
		for(var i=0;i<markers.length;i++)
			if(markers[i]) currentMap.addOverlay(markers[i]);
		//this.markerManager.addMarkers(markers);
		//this.markerManager.refresh();
	},
	
	setMarkBy: function(markBy){
		this.mMarkBy = markBy;
	},
	
	setCookie: function(c_name,value,path,expiredays){
		var exdate = new Date();
		exdate.setDate(exdate.getDate() + expiredays);
		document.cookie = c_name + "=" + escape(value) + ((expiredays==null) ? "" : ";expires=" + exdate) + ((path==null) ? "" : ";path=" + path);
	},

	getCookie: function(c_name) {
		if (document.cookie.length > 0) {
			var c_start = document.cookie.indexOf(c_name + "=");
			if (c_start!=-1) { 
				c_start = c_start + c_name.length + 1;
				var c_end = document.cookie.indexOf(";",c_start);
				if (c_end == -1) {
					c_end = document.cookie.length;
				}
				return unescape(document.cookie.substring(c_start,c_end));
			} 
		}
		return null;
	}
});

var MiniMapListener = AbstractMapListener.extend({
	initialize: function(rowNum,manager,hotel){
		this.mManager = manager;
		this.mManager.registerMapElement(this);
		this.mRow = rowNum;
		//find it's containing divs..
		var row = $('sr-template-' + rowNum);
		if( !row ) return null;
		this.mOuterContainer = row.getElement('div.nextag-maps-minimap-outer');
		this.mMapContainer = this.mOuterContainer.getElement('div.nextag-maps-minimap');
		this.mOuterContainer.setStyle('display','block');
		this.mMap = new GMap2(this.mMapContainer);
		var point = new GLatLng(hotel['geoLocation']['latitude'],hotel['geoLocation']['longitude']);
		this.mMap.setCenter(point,14);
		this.mMap.addOverlay(new GMarker(point));
	},
	
	notify: function(event){
		if(event.type == "deleteMiniMap") {
			if(event.info == this.mRow){
				this.mOuterContainer.setStyle('display','none');
				this.mMap = null;
			}
		}
	},
	alert: function(event){this.mManager.notifyMapElements(event);}
});

var MarkByListener = AbstractMapListener.extend({
	initialize: function(dropDown,numInput,updateLink,manager) {
		this.mDropDown = $(dropDown);

		this.mNumDisplayInput = $(numInput);
		this.mUpdateLink = $(updateLink);
		this.mUpdateLink.addEvent('click',this.updateCallback.bind(this));
		this.mManager = manager;
	},
	updateCallback: function(){
		this.alert(new MapEvent("markby",this.mDropDown.value));
		if(this.mNumDisplayInput.value.match(/^\d+$/))
			this.alert(new MapEvent("maxmarkers",parseInt(this.mNumDisplayInput.value)));
	},
	notify: function(event){},
	alert: function(event){this.mManager.notifyMapElements(event);}
});

var ContextResultsHelper = AbstractMapListener.extend({
	
});

function getLatLong(searchParam,callBack){
	if(!this.mGC)
		this.mGC = new GClientGeocoder();
	this.mGC.getLatLng(searchParam,callBack);
}

var MapEvent = new Class({
	initialize: function(type,info){
		this.type = type;
		this.info = info;
	}
});

function infoWindowHTML(hotel){
	var html = "<table border=\"0\" style=\"width:380px;\"><tr><td>";
	html += "<a target=\"_blank\" href=\"" + hotel['itemUrl'] + "\">"
	html += "<img border=\"0\" height=\"" + hotel['imageHeight'] + "\" width=\"" + hotel['imageWidth'] + "\" src=\"" + hotel['imageUrl'] + "\"/>";
	html += "</a>";
	html += "</td><td class=\"sr-info\">";
	html += "<a class=\"sr-title\" href=\"" + hotel['itemUrl'] + "\">";
	html += hotel['itemName'] + "</a>";
	html += "<div style=\"padding:10px 0px;\">" + hotel['hotelLocation'] + "</div>";
	html += "<div class=\"featuredSeller\">"
	for(var i=0;i<3 && i<hotel['featuredSellers'].length;i++){
		html += "<span class=\"sr-fs\">";
		html += "<a class=\"featuredSeller\" target=\"_blank\" href=\"" + hotel['featuredSellers'][i].url + "\">" + hotel['featuredSellers'][i].sellerName;
		if(hotel['featuredSellers'][i].price != "") html += ":";
		html += hotel['featuredSellers'][i].price;
		html += "</a>";
	}
	html += "</div>";
	html += "</td></tr></table>";
	return html;
}

var FeaturedSellerMapping = Class.create({
	initialize: function(seller, price) {
		this.mSeller = seller;
		this.mPrice = price;
	}
});
/*
 * Depends on mootools.86+
 * Copyright NexTag 2006, 2007
 */
var AbstractSearchResultsUIManager = AbstractUIManager.extend({
	initialize: function(container, resultTemplate, cachedContainer, options) {
		this.parent(container);
		this.mViewable = true; 
		this.mNumDisplayable = 15;
		this.mDisplayRowsPool = null;
		this.mShowClickable = false;
		this.mResultsToDisplay = null;
		this.mCachedContainer = $(cachedContainer);
		this.mResultsContainer = $(this.mContainer);
		this.mResultTemplate = resultTemplate;
		this.mTemplateMappings = null;
		
		this.mShuffleStartIndex = 0;

		this.mIsSetupDone = false;

		this.mTemplateIdPrefix = 'sr-template-';
		this.mOptions = options;
	},

/**/	
	setupRows: function() {	
		var resultTemplateElement = $(this.mResultTemplate);
		if ( !resultTemplateElement ) return;

		this.mTemplateMappings = new Array();
		this.mDisplayRowsPool = new Array();
		
		for(var i = 0; i < this.mNumDisplayable; i++) {
			this.mDisplayRowsPool[i] = $(resultTemplateElement.
				cloneNode(true));
			this.mDisplayRowsPool[i].id = this.mTemplateIdPrefix + i;
			this.mDisplayRowsPool[i].setStyle('float', 'none');
			this.mDisplayRowsPool[i].injectInside(this.mResultsContainer);
			this.mTemplateMappings[this.mDisplayRowsPool[i].id] = 
				this.createTemplateMapping(this.mDisplayRowsPool[i]);
			this.processRow(i);
		}
		
		this.mIsSetupDone = true;
		
	},
	
	processRow: function(i) {
		//abstract
	},
	
	updateRow: function(displayRow, searchResult) {
		this.updateUI(displayRow, searchResult);
	},
	
	updateFeaturedSellersUI: function(templateMapping,
			featuredSellers) {

		if ( this.showClickable() && featuredSellers.length > 0) {	
			for ( k = 0; k < templateMapping.mFeaturedSellerMappings.length; k++ ) {
				var featuredSeller = featuredSellers[k];
				var featuredSellerMapping = 
					templateMapping.mFeaturedSellerMappings[k];
				if ( featuredSeller != null ) {
					featuredSellerMapping.mSeller.setProperty('href',
						featuredSeller['url']);
					featuredSellerMapping.mSeller.setHTML(
						featuredSeller['sellerName']);
					if ( featuredSeller['price'] != '' && !featuredSeller['hidePrice'] && 
						featuredSeller['price'] != '$0') {
						featuredSellerMapping.mPrice.setHTML(": " +
							featuredSeller['price']);
					} else {
						featuredSellerMapping.mPrice.setHTML('');	
					}
					
					templateMapping.featuredSellerSections[k].
						setStyle('display', 'inline')
				} else {
					templateMapping.featuredSellerSections[k].
						setStyle('display', 'none');
				}
			}
			templateMapping.mFeaturedSellers.style.display = 'block';
		} else {
			templateMapping.mFeaturedSellers.style.display = 'none';
		}		
	},

	createFeaturedSellersTemplateMapping: function(featuredSellerSections) {
		var featuredSellerMappings = new Array();

		for ( var k = 0; k < featuredSellerSections.length; k++ ) {
			var fsCache = new FeaturedSellerMapping( 
				featuredSellerSections[k].getElement('a'),
				featuredSellerSections[k].getElement('span.fs-price'));					
			featuredSellerMappings.push(fsCache);
		}
		
		return featuredSellerMappings;

	},

	createTemplateMapping: function(row) {
		//abstract
	},
	
/**/
	  	
	updateRows: function(searchResults) {
		if ( this.mIsSetupDone == false) {
			return;
		}
		this.mContainer.setStyle('display', 'block');
		if ( this.mCachedContainer ) 
			this.mCachedContainer.setStyle('display', 'none');

		this.mResultsToDisplay = searchResults;

		if ( this.mResultsToDisplay == null ) return;


   		var shuffleIndex = 0;
   		for(var i = 0; i < this.mResultsToDisplay.length; i++) {
   			if ( this.mResultsToDisplay[i]['selected'] ) shuffleIndex++;
   		}
   		this.mShuffleStartIndex = shuffleIndex;

		for( i = 0; i < this.mDisplayRowsPool.length && 
				i < this.mResultsToDisplay.length; i++ ) {	
			this.updateRow(this.mTemplateMappings[this.mDisplayRowsPool[i].id], 
				this.mResultsToDisplay[i]);
			this.mDisplayRowsPool[i].setStyle('display', 'block');
		} 
		
		while ( i < this.mDisplayRowsPool.length ) {
			this.mDisplayRowsPool[i].setStyle('display', 'none');
			i++;
		}
		
	},
		
   	shuffle: function() {
   		var rows = this.getRows();
		var shuffleStartIndex = this.getShuffleStartIndex();
		if ( rows && rows.length > 0 ) {
			if ( rows[shuffleStartIndex] ) {
				var lastElement = rows[(rows.length)-1];
				lastElement.remove();
				lastElement.injectBefore(rows[shuffleStartIndex]);		
			}
		}
   	},
   	
   	getShuffleStartIndex: function() {
   		return this.mShuffleStartIndex;
   	},
   	
   	unshuffle: function() {
   		var rows = this.getRows();
   		if ( rows && rows.length < 1 ) return;
   		do {
   			this.shuffle();
   			rows = this.getRows();
   		} while (rows && rows[this.getShuffleStartIndex()].id != 
   			(this.mTemplateIdPrefix + this.getShuffleStartIndex()));
   	},
	
	showClickable: function() { //not entirely necessarily since we can refer to this statically, but.. allows for abstraction.
		return this.mShowClickable;
	},
	
	save: function() {
		if ( $('displayedResults') ) {
			$('displayedResults').value = this.mContainer.innerHTML;
		}
	},
	
	restore: function() {
		this.mContainer.setStyle('display', 'none');
		this.mCachedContainer.setStyle('display', 'block');
		if ( this.mCachedContainer ) 
			this.mCachedContainer.setHTML($('displayedResults').getValue());		
	}, 
	
	getRows: function() { return {}; }
});
var AbstractRefinementUIManager = AbstractUIManager.extend({
	initialize: function(container, 
		url, callback) {
		
		this.parent(container);
		this.mUrl = url;
		this.mCallback = callback;
		
		this.mFilterGroups = null;	
		this.mActiveFilters = new Object();		

		this.mLowestValues = {};
		this.mHighestValues = {};

	},

	/**/
    updateAction: function() {
    	this.mCallback.call();
    },
    
    getActiveFilters: function() {
    	return this.mActiveFilters;
    },

	getFilterGroups: function() {
		return this.mFilterGroups;
	},
	
	getFilterGroup: function(name) {
		return this.mFilterGroups ? this.mFilterGroups[name] : null;
	},

	createFilters: function() {
		//abstract
	},
	
	createLowValueSettings: function() {
		//abstract
	},
	
	createHighValueSettings: function() {
		//abstract
	},

	setup: function(totalResults, restoring) {
		this.setupLowHighMap();
		this.mFilterGroups = this.createFilters();
		this.setupBuckets(totalResults);
		this.postConstructFilters();
		this.setupFilters(restoring);
		this.updateLook();
	},
	
	setupLowHighMap: function() {
		var lowestValueSettings = this.createLowValueSettings();
		var highestValueSettings = this.createHighValueSettings();
		
		if ( lowestValueSettings ) {
			for(key in lowestValueSettings) {
				this.mLowestValues[key] = 9999999999999999;
			}
		}
		
		if ( highestValueSettings ) {
			for(key in highestValueSettings) {
				this.mHighestValues[key] = 0;
			}
		}
	},
	
	analyzeResult: function(result, filterGroups) {
		this.prepLowestValues(result);
		this.prepHighestValues(result);
		this.prepFilterData(result, filterGroups);
	},
	

	prepLowestValues: function(result) {
		var lowestValueSettings = this.createLowValueSettings();
		if ( !lowestValueSettings ) return;
		
		for(key in lowestValueSettings) {
			this.prepLowValues(key, lowestValueSettings[key], result);
		}
	},
	
	prepHighestValues: function(result) {
		var highestValueSettings = this.createHighValueSettings();
		if ( !highestValueSettings ) return;
		
		for(key in highestValueSettings) {
			this.prepHighValues(key, highestValueSettings[key], result);
		}		

	},
	
	/*  */
	prepLowValues: function(key, property, result) {
		var value = CommonUtils.getObjectProperty(result, property);
		if ( !value ) return;
		this.mLowestValues[key] = ( value < this.mLowestValues[key] &&
    		value > 0 ) ? value : this.mLowestValues[key];
	},

	/*  */
	prepHighValues: function(key, property, result) {
		var value = CommonUtils.getObjectProperty(result, property);
		if ( !value ) return;
		this.mHighestValues[key] = (value > this.mHighestValues[key]) ? 
    		value : this.mHighestValues[key];
	},
		
	prepFilterData: function(result, filterGroups) {
		//abstract
	},
	
	postConstructFilters: function() {
		//abstract
	},

    setupFilters: function(restoring) {
    	for( key in this.mFilterGroups ) {
    		var filterGroup = this.mFilterGroups[key];
    		if ( filterGroup.mHasCheckbox ) {
    			this.setupCheckboxFilter(filterGroup, restoring);
    		} else if ( filterGroup.mHasLink ) {
    			this.setupLinkFilter(filterGroup);
    		} else if ( filterGroup.mFilterType == 'keyword') {
		    					 
				 var keywordInputButton = $('wsearchsubmit');
				 if ( keywordInputButton ) {
				 	keywordInputButton.addEvent('click', 
				 		this.updateAction.bind(this) );
				 }
    		}
    	}
    },
 
    setupCheckboxFilter: function(filterGroup, restoring) {
    	var container = $(filterGroup.mContainer);
    	if ( !container ) return;
    	var checkboxes = container.
    		getElementsBySelector('input[name="' + filterGroup.mFilterName + '"]');
    	var links = container.getElementsBySelector('a.' + filterGroup.mFilterName);
    	for( var i = 0; i < checkboxes.length; i++ ) {
    		if ( !restoring ) {
	    		if ( !filterGroup.mDefaultChecked ) checkboxes[i]['checked'] = false;
	    		else checkboxes[i]['checked'] = true;
    		}

    		checkboxes[i].addEvent('click', 
    			this.check.pass([filterGroup, checkboxes, links, i], this));
    	}
 	
 		if ( filterGroup.mHasLink ) {
	    	for( var i = 0; i < links.length; i++ ) {
	    		links[i].addEvent('click', 
	    			this.updateToggles.pass([ filterGroup, checkboxes, links, i ], this));
	    	}
 		}
    },  	
        
    setupLinkFilter: function(filterGroup) {
    	var container = $(filterGroup.mContainer);
    	if ( !container ) return;
    	var links = container.getElementsBySelector('a.' + filterGroup.mFilterName)
		for( var i = 0; i < links.length; i++ ) {
			links[i].addEvent('click', this.link.pass([filterGroup, links[i]],this));
		}
    },
    
    link: function(filterGroup, link) {
    	if ( filterGroup.mBoldLinks == true ) link.addClass('selected');
    	if ( filterGroup.mFilterType == 'range' ) {
    		filterGroup.mFilter = new RangeSearchResultsFilter(0, parseInt(link.getAttribute('title')), 'distance', 'distance');
    	}
    	this.updateAction();
    },

    setupBuckets: function(totalResults) {
    	if (!totalResults) return;
    	for( var i = 0; i < totalResults.length; i++) {
    		 this.analyzeResult(totalResults[i], this.mFilterGroups);
    	}
    	
    	for( filterGroupName in this.mFilterGroups ) {
    		var filterGroup = this.mFilterGroups[filterGroupName];
    		if ( !filterGroup.mAutoBucket ) continue;
    		filterGroup.reset();
    		filterGroup.mFilterOptions = 
    			this.gatherFilterOptions(filterGroup, totalResults);
    	}
    },

	/*
	 */
    updateLook: function() {
    	for( filterName in this.mFilterGroups ) {
    		var filterGroup = this.mFilterGroups[filterName];
    		if ( !filterGroup.mHasLink ) continue;
    		var filterOptions = filterGroup.mFilterOptions;
    		for( key in filterOptions) {
    			var filterOption = filterOptions[key];

    			var section = filterGroup.mContainer && $(filterGroup.mContainer) ? 
    				$(filterGroup.mContainer).getElement('#' + key) : undefined;
    			if ( section ) {
	    			var link = section.getElement('a');
	    			var lowPrice = section.getElement('span.l-price');
	    			var count = section.getElement('span.b-size');
	    			if ( filterOption.mCount > 0 ) {
	    				if ( link ) link.removeClass("smallGrayText");
	    				if ( lowPrice ) {
	    					if ( filterOption.mLowPrice != 0 &&
	    						filterOption.mLowPrice != 9999999) {
		    					lowPrice.setHTML(parseInt(filterOption.mLowPrice/100));
	    					} else {
	    						lowPrice.setHTML('na');
	    					}
	    				}
	    				
	    				if ( count ) count.setHTML(filterOption.mCount);
	    			} else 
	    				link.addClass('smallGrayText');
    			}
    		}
    	}
    },

    gatherFilterOptions: function(filterGroup, totalResults) {
		var results = totalResults;
		var buckets = new Object();
		var property = filterGroup.mPropertyName;
		var itemLocation = filterGroup.mItemLocation;
		for( var i = 0; i < results.length; i++) {
		    var result = results[i];
		    var bucketName = CommonUtils.
		    	getObjectProperty(result, itemLocation, property);

		    if ( $type(bucketName) == 'object' ) {
		    	var collection = bucketName;

		    	for(key in collection) {
		    			
		    		key = filterGroup.mKeyPrefix + key;
		    		if ( !buckets[key] ) {
		    			buckets[key] = new MatchFilterOption(key);
		    		}
		    		buckets[key].addResult(result);
		    	}
		    } else {
		    	
			    if ( !bucketName ) 
			    	bucketName = 'OTHER';
			    
			    if ( $type(bucketName) == 'string' ) bucketName =
			    	bucketName.replace(' ', '_');
			   
			    bucketName = filterGroup.mKeyPrefix + bucketName;
		       
		        if ( !buckets[bucketName] ) {
		        	buckets[bucketName] = new MatchFilterOption(bucketName);
	        	}
	        	buckets[bucketName].addResult(result);
		    }
		}
		return buckets;
    },
    
    check: function(filterGroup, checkboxes, links, i) {
    	if ( filterGroup.mBoldLinks == true && links && links[i] ) {
    		if ( checkboxes[i].isSelected() ) {
    			links[i].addClass('selected');
    		} else {
    			links[i].removeClass('selected');
    		}
    	}
    	this.updateAction.delay(100);
    },

    updateToggles: function(filterGroup, checkboxes, links, selected) {
    	for(var i = 0; i < checkboxes.length && i < links.length; i++) {
    		if ( i != selected ) {
    			checkboxes[i]['checked'] = false;
    			if ( filterGroup.mBoldLinks == true ) 
    				links[i].removeClass('selected');
    		} else { 
    			checkboxes[i]['checked'] = true;
    			if ( filterGroup.mBoldLinks == true )
    				links[i].addClass('selected');
    		}
    	}

    	this.updateAction.delay(100);
    },
   
    generateFilters: function() {
		this.mActiveFilters = new Object();
    	for(key in this.mFilterGroups) {
    		var filterGroup = this.mFilterGroups[key];

    		if ( filterGroup.isCheckboxType() ) {
    			filterGroup.mFilter = 
    				this.generateFilterFromCheckboxes(filterGroup);
    		} else if ( filterGroup.mFilterName == 'price') {
    			filterGroup.mFilter = new RangeSearchResultsFilter(
					'lowPrice', 'lowPrice');	   
				var minValue = parseInt($('plw').value);
				var maxValue = parseInt($('phi').value);
				if ( minValue != 0 && maxValue != 0 ) {
					filterGroup.mFilter.addFilterOption(
						 minValue + '_' + maxValue);
				}
    		} else if ( filterGroup.mFilterName == 'outdeptime') {
    			filterGroup.mFilter = new RangeSearchResultsFilter('time','time','',filterGroup.mItemLocation);
    			var minValue = parseInt($('va1').value);
    			var maxValue = parseInt($('va2').value);
				if ( minValue != 0 && maxValue != 0 )
	    			filterGroup.mFilter.addFilterOption(minValue + '_' + maxValue);
    		} else if ( filterGroup.mFilterName == 'outarrtime') {
    			filterGroup.mFilter = new RangeSearchResultsFilter('time','time','',filterGroup.mItemLocation);
    			var minValue = parseInt($('lva1').value);
    			var maxValue = parseInt($('lva2').value);
				if ( minValue != 0 && maxValue != 0 )
	    			filterGroup.mFilter.addFilterOption(minValue + '_' + maxValue);
    		} else if ( filterGroup.mFilterName == 'retdeptime') {
    			filterGroup.mFilter = new RangeSearchResultsFilter('time','time','',filterGroup.mItemLocation);
    			var minValue = parseInt($('ava1').value);
    			var maxValue = parseInt($('ava2').value);
				if ( minValue != 0 && maxValue != 0 )
	    			filterGroup.mFilter.addFilterOption(minValue + '_' + maxValue);
    		} else if ( filterGroup.mFilterName == 'retarrtime') {
    			filterGroup.mFilter = new RangeSearchResultsFilter('time','time','',filterGroup.mItemLocation);
    			var minValue = parseInt($('lava1').value);
    			var maxValue = parseInt($('lava2').value);
				if ( minValue != 0 && maxValue != 0 )
	    			filterGroup.mFilter.addFilterOption(minValue + '_' + maxValue);
    		} else if ( filterGroup.mFilterType == 'keyword') {
    			if ( $(filterGroup.mFilterName) &&
    				$(filterGroup.mFilterName).value.trim() != '' ) {
					filterGroup.mFilter = 
						this.generateFilterFromFilterGroup(filterGroup);
				
					filterGroup.mFilter.addFilterOption(
						$(filterGroup.mFilterName).value);
    			}
    		}
    	}

    	for(key in this.mFilterGroups) {
    		var filterGroup = this.mFilterGroups[key];
    		if ( !filterGroup.hasNoFilter()) {
    			this.mActiveFilters[filterGroup.mFilterName] = filterGroup.mFilter;    			
    		} 
    	}    

    },
    
    generateFilterFromLink: function(filterGroup) {
    	
    	return null;
    },
    
	generateFilterFromFilterGroup: function(filterGroup) {
		var filter = null;
    	var filterBy = filterGroup.mPropertyName;
    	
    	if ( !$(filterGroup.mContainer)) return;
    	
    	if ( filterGroup.mFilterType == 'range') {
    		
    		filter = new RangeSearchResultsFilter(
    				filterGroup.mMinPropertyName,
    				filterGroup.mMaxPropertyName,
    				filterGroup.mKeyPrefix,
    				filterGroup.mItemLocation    				
    			);
    	} else if ( filterGroup.mFilterType == 'keyword') {
	    	filter = new KeywordMatchFilter(
	    				filterBy, filterGroup.mKeyPrefix,
    					filterGroup.mItemLocation    
	    			);
    	} else if ( filterGroup.mMatchValue ) { 
			filter = filterGroup.mStrict ? 
				new PositiveAndStrictMatchFilter(filterBy, filterGroup.mKeyPrefix,
    				filterGroup.mItemLocation ) : 
				new PositiveAndMatchFilter(filterBy, filterGroup.mKeyPrefix,
    				filterGroup.mItemLocation );
    	} else 	
    		filter = new NegativeOrMatchFilter(filterBy, filterGroup.mKeyPrefix,
    				filterGroup.mItemLocation );
    	
    	return filter;
    	  
	},
    
    generateFilterFromCheckboxes: function(filterGroup) {
  		var linkClass = filterGroup.mFilterName;  	
		var filter = this.generateFilterFromFilterGroup(filterGroup);	
		if ( !$(filterGroup.mContainer) ) return;
    	var checkboxes = $(filterGroup.mContainer).
    		getElementsBySelector('input[name="' + linkClass + '"]');
    	
    	for( var i = 0; i < checkboxes.length; i++ ) {
    		if ( checkboxes[i]['checked'] == filterGroup.mMatchValue ) {
				/**/
    			if(checkboxes[i]['value'] == "on")
    				filter.addFilterOption(checkboxes[i]['title']);
    			else
	    			filter.addFilterOption(checkboxes[i]['value']);
    		}
    	}    
    	return filter;	
    },

    reset: function() {
    	
    	for( key in this.mFilterGroups ) {
    		var filterGroup = this.mFilterGroups[key];
    		if ( !$(filterGroup.mContainer) ) continue;
    		if ( filterGroup.isCheckboxType() ) {
		    	var checkboxes = $(filterGroup.mContainer).
		    		getElementsBySelector('input[name="' + filterGroup.mFilterName + '"]');
		    	for(var i = 0; i < checkboxes.length; i++) {
		    		checkboxes[i]['checked'] = filterGroup.mDefaultChecked;
		    	}   			
		    	
				var links = $(filterGroup.mContainer).
		    		getElementsBySelector('a.' + filterGroup.mFilterName);
		    	for(var i = 0; i < links.length; i++ ) {
		    		links[i].removeClass('selected');
		    	}
    		} else if ( filterGroup.mFilterType == 'keyword') {
    			
    			if ( $(filterGroup.mFilterName) ) {
    				$(filterGroup.mFilterName).value = '';
    			}
    			filterGroup.reset();
    		}
    	}
		
		this.initializeSliders();
		
    	this.mActiveFilters = new Object();
    	this.updateAction();
    },
    
    initializeSliders: function(reset) {
    	//abstract
    },
    
    getNumActiveFilters: function() {
		var total = 0;
		for( keys in this.mActiveFilters ) {
		    total++;
		}
		return total;
    },
    
    hasNoFilters: function() {
    	return this.getNumActiveFilters() == 0;
    }
});

var SearchResultsSummaryUIManager = AbstractUIManager.extend({
	initialize: function(searchingContainerId,searchTotalId,postSearchContainerId,lowNumId,highNumId,totalId,postFixId)
	{
		this.mSearchingContainer = $(searchingContainerId);
		this.mSearchTotalId = $(searchTotalId);
		
		this.mPostSearchContainer = $(postSearchContainerId);
		this.mLowNum = $(lowNumId);
		this.mHighNum = $(highNumId);
		this.mCurrTotalNum = $(totalId);
		this.mPostFixText = $(postFixId);
		
		this.mIsDoneSearching = false;
	},
	
	updatePostSearchUI: function(lowNum,highNum,totalNum,refinedNum) {
		if ( refinedNum < highNum ) highNum = refinedNum;
		if ( refinedNum < lowNum ) lowNum = refinedNum;
		
		if(this.mLowNum)
			this.mLowNum.innerHTML = parseInt(lowNum);
		if(this.mHighNum) {
			this.mHighNum.innerHTML = parseInt(highNum);
		}
		if(totalNum == refinedNum)
		{
			this.mPostFixText.innerHTML = "total results";
			
			if(parseInt(highNum) > parseInt(totalNum))
				this.mCurrTotalNum.innerHTML = parseInt(highNum);
			else
				this.mCurrTotalNum.innerHTML = parseInt(totalNum);
		}
		else
		{
			this.mPostFixText.innerHTML = "refined results (" + totalNum + " total)";
			
			if(parseInt(highNum) > parseInt(refinedNum))
				this.mCurrTotalNum.innerHTML = parseInt(highNum);
			else
				this.mCurrTotalNum.innerHTML = refinedNum;
		}
	},
	
	updateSearchingUI: function(totalFound)
	{
		this.mSearchTotalId.innerHTML = totalFound;
	},
	
	showPostSearchUI: function(range)
	{
		if(this.mSearchingContainer)
			this.mSearchingContainer.setStyle("display","none");
		if(this.mPostSearchContainer)
			this.mPostSearchContainer.setStyle("display","block");
		if(this.mLowNum)
			this.mLowNum.innerHTML = parseInt(range[0]);
		if(this.mHighNum)
			this.mHighNum.innerHTML = parseInt(range[1]);
		this.mIsDoneSearching = true;
	},
	
	showSearchingUI: function()
	{
		if(this.mSearchingContainer)
			this.mSearchingContainer.setStyle("display","block");
	},
	
	updateUI: function(arg1,arg2,arg3,arg4)
	{
		if(this.mIsDoneSearching)
			this.updatePostSearchUI(arg1,arg2,arg3,arg4);
		else
			this.updateSearchingUI(arg1);
	}
});
/* 
 * Depends on mootools.86+
 * Copyright NexTag 2006, 2007
 */
 var PaginationUIManager = AbstractUIManager.extend({
	initialize: function(container, numPerPage, callback) {
		this.parent();
		this.mContainer = $(container);
		this.mNumberLinks = null;
		this.mNextLink = null;
		this.mPrevLink = null;
		this.mNextSetLink = null;
		this.mCurrentPosition = null;
		this.mCurrentSet = null;

		this.mNumPerPage = numPerPage || 10;
		this.mNumResults = 10;
		this.mMaxPage = 1;

		this.mCallback = callback;

		this.setup();
	},

/**/
	setup: function() {
		this.determineMaxPage();
		this.setupNumLinks();
		
		this.restore();

		this.mPrevLink = this.mContainer.getElement('a[title="prev"]');
		this.mPrevLink.addEvent('click', this.goPrevious.bind(this));

		this.mNextLink = this.mContainer.getElement('a[title="next"]');
		this.mNextLink.addEvent('click', this.goNext.bind(this));

		this.mNextSetLink = this.mContainer.getElement('a[title="nextSet"]');
		this.mNextSetLink.addEvent('click', this.goNextSet.bind(this));

		this.updateNums();
		this.updateEmphasis();


	},

	determineMaxPage: function() {
		
		this.mMaxPage = this.mNumResults % this.mNumPerPage == 0 ?
			this.mNumResults / this.mNumPerPage :
			parseInt(this.mNumResults / this.mNumPerPage + 1);
		
	},

	setupNumLinks: function() {
		this.mNumberLinks = this.mContainer.getElementsBySelector('a[title="pageNum"]');
		for(var i = 0; i < this.mNumberLinks.length; i++) {
			var numberLink = this.mNumberLinks[i];
			numberLink.addEvent('click', this.goPageNum.pass([i], this));
		}
	},

	updateNums: function() {
		for(var i = 0; i < this.mNumberLinks.length; i++) {
			var numberLink = this.mNumberLinks[i];
			//set number
			var number = ((this.mCurrentSet-1) * this.mNumberLinks.length) + i + 1;
			this.setLinkNumber(numberLink, number);

			if ( this.getLinkNumber( numberLink ) > this.mMaxPage ) {
				numberLink.setStyle('display', 'none');
			} else {
				numberLink.setStyle('display', 'inline');
			}
		}


		if( this.mCurrentSet * this.mNumPerPage *
			this.mNumberLinks.length >= this.mNumResults ) {
			this.mNextSetLink.setStyle('display', 'none');
		} else {
			this.mNextSetLink.innerHTML = this.mCurrentSet * this.mNumberLinks.length + 1 + "+";
			this.mNextSetLink.setStyle('display', 'inline');
		}
	},

	goPageNum: function(i) {
		this.setCurrentPosition(i);
	},

	goNext: function() {
		if ( this.getCurrentPageNum() < this.mMaxPage ) {
			if ( this.mCurrentPosition == this.mNumberLinks.length - 1 ) {
				this.goNextSet();
			} else {
				this.setCurrentPosition(++this.mCurrentPosition);
			}
		}
	},

	goPrevious: function() {
		if ( this.mCurrentPosition == 0 && this.getCurrentPageNum() > 1 ) {
			this.goPreviousSet();
		} else if ( this.getCurrentPageNum() > 1 ) {
			this.setCurrentPosition(--this.mCurrentPosition);
		}
	},

	goPreviousSet: function() {
		--this.mCurrentSet;
		this.updateNums();
		this.setCurrentPosition(this.mNumberLinks.length - 1);
		this.mNextSetLink.innerHTML = ((this.mCurrentSet - 1) * this.mNumberLinks.length) + this.mNumberLinks.length + 1 + "+";
	},

	goNextSet: function() {
		++this.mCurrentSet;
		this.updateNums();
		this.setCurrentPosition(0);
	},

	pageChanged: function() {
		this.mCallback.call();
	},

	setLinkNumber: function(link, number) {
		link.setHTML(number);
	},

	getLinkNumber: function(link) {
		if ( !link ) return 1;
		return parseInt(link.innerHTML);
	},

	updateEmphasis: function() {
		for ( var i = 0 ; i < this.mNumberLinks.length; i++ ) {
			var numberLink = this.mNumberLinks[i];
			//set bold
			if ( this.getLinkNumber(this.getCurrentLink()) == this.getLinkNumber(numberLink) ) {
				numberLink.addClass('selected');
			} else {
				numberLink.removeClass('selected');
			}
		}
	},

	getCurrentLink: function() {
		return this.mNumberLinks[this.mCurrentPosition];
	},

	setCurrentPosition: function(currentPosition) {
		this.mCurrentPosition = currentPosition;
		this.updateEmphasis(this.getCurrentLink());
		this.save();
		this.pageChanged();
	},

/**/
	save: function() {
		if ( this.mAllowRestore ) {
			$('currentSet').value = this.mCurrentSet;
			$('currentPosition').value = this.mCurrentPosition;	
		}
	},
	
	restore: function() {
		if ( this.mAllowRestore ) {
	
			var currentSet = parseInt($('currentSet').value);
			var currentPosition = parseInt($('currentPosition').value);

			if ( $type(currentSet) != 'number' || 
				$type(currentPosition) != 'number' ) {
				this.reset();
				return false;
			} 
			this.mCurrentSet = currentSet;
			this.mCurrentPosition = currentPosition;
		}
	},
	
	reset: function() {
		this.mCurrentSet = 1;
		this.mCurrentPosition = 0;
	},
	
	updateUI: function(numResults, doNotReset) {
		this.mContainer.setStyle('display', 'block');

		this.mNumResults = numResults;
		
		if ( !doNotReset ) {
			this.reset();
		}
		this.determineMaxPage();
		this.updateNums();
		this.updateEmphasis();

	},

	getCurrentPageNum: function() {
			return this.getLinkNumber(this.getCurrentLink());
	},

	getCurrentRange: function() {
		var min = ( this.getCurrentPageNum() - 1 ) *
			this.mNumPerPage;
		var max = max > this.mNumResults ? this.mNumResults - 1 :
			min + this.mNumPerPage - 1;
		return [ min, max ];
	}
});


var SortingUIManager = AbstractUIManager.extend({
	initialize: function(controlItems,callBack)
	{
		this.sortCallBack = callBack;
		this.mCurrentSortBy = "bm";
		this.mSortLinks = {
			"bm":$(controlItems['bm']),
			"price":$(controlItems['price']),
			"az":$(controlItems['az']),
			"dist":$(controlItems['dist']),
			"stops":$(controlItems['stops']),
			"duration":$(controlItems['duration'])
		};
		this.mSortContainer = $('sort-bar');
		
		if(this.mSortLinks['bm'])
			this.mSortLinks['bm'].addEvent('click',this.sortByAction.bind(this).pass('bm'));
		if(this.mSortLinks['price'])
			this.mSortLinks['price'].addEvent('click',this.sortByAction.bind(this).pass('price'));
		if(this.mSortLinks['az'])
			this.mSortLinks['az'].addEvent('click',this.sortByAction.bind(this).pass('az'));
		if(this.mSortLinks['dist'])
			this.mSortLinks['dist'].addEvent('click',this.sortByAction.bind(this).pass('dist'));
		if(this.mSortLinks['stops'])
			this.mSortLinks['stops'].addEvent('click',this.sortByAction.bind(this).pass('stops'));
		if(this.mSortLinks['duration'])
			this.mSortLinks['duration'].addEvent('click',this.sortByAction.bind(this).pass('duration'));
	},
	
	sortByAction: function(type)
	{
		if(this.mSortLinks[type])
		{
			this.mCurrentSortBy = (this.mCurrentSortBy == type && type != "bm") ? "r" + type : type;
			this.sortCallBack();
		}
	},
	
	updateUI: function()
	{
		if ( !this.mViewable ) {
			this.mViewable = true;
			this.showUI();
		}
		for(key in this.mSortLinks)
		{
			if ( !this.mSortLinks[key] ) continue;
			if(this.mSortLinks[this.mCurrentSortBy] == this.mSortLinks[key] 
				|| this.mSortLinks[this.mCurrentSortBy.substring(1)] == this.mSortLinks[key])
			{
				this.mSortLinks[key].addClass('selected');
			}
			else
			{
				this.mSortLinks[key].removeClass('selected');
			}
		}
	},
	
	getCurrentSortBy: function()
	{
		return this.mCurrentSortBy;
	},
	
	showUI: function()
	{
		if(this.mSortContainer)
			this.mSortContainer.setStyle('display','block');
	},
	
	restore: function()
	{
	
	},
	
	save: function()
	{
	
	}
});
var ErrorUIManager = AbstractUIManager.extend({

	initialize: function(container,type) {
		this.mContainer = $(container);
		this.mAllowRestore = false;
		this.mHeaderText = "There has been an error";
		this.mErrorMessages = new Array();
		this.mErrorObjectType = type;
	},

	updateUI: function(){//refreshes the header and error messages in mContainer
		for(i=0;i<this.mContainer.childNodes.length;i++)
		{
			if(this.mContainer.childNodes[i].nodeValue != " ")
			{
				this.mContainer.childNodes[i].remove();
			}
		}
		var container = new Element('div');
		var headerSpan = new Element('span');
		headerSpan.addClass('error-header');
		headerSpan.innerHTML = this.mHeaderText;
		container.adopt(headerSpan);
		for(i=0;i<this.mErrorMessages.length;i++){
			container.innerHTML += "<span class=\"error-message\">" + this.mErrorMessages[i] + "</span><br/>";
		}
		this.mContainer.adopt(container);
	},
	
	showUI: function(){this.mContainer.setStyle('display','block');},
	
	hideUI: function(){
		this.mContainer.setStyle('display','none');
		this.clearMessages();
	},
	
	setHeader: function(text){
		this.mHeaderText = text;
	},
	
	clearMessages: function(){
		this.mErrorMessages = new Array();
	},	
	
	addErrorMessage: function(message){
		this.mErrorMessages[this.mErrorMessages.length] = message;
	},
	
	save: function() {},
	restore: function() {}

});


var SortingProcessor = new Class({
	initialize: function(){},
	
	sort: function(array,comparatorIndex)
	{
		if(SortingComparators[comparatorIndex] != null)
			return array.sort(SortingComparators[comparatorIndex]);
		return array;
	}
});

var SortingComparators = 
	{
		"price":function(a,b)
		{
			if(a.lowPrice == 0 && b.lowPrice == 0)
				return 0;
			else if(a.lowPrice == 0)
				return 1;
			else if(b.lowPrice == 0)
				return -1;
			
			if(a.lowPrice > b.lowPrice){
				return 1;
			} else if (a.lowPrice < b.lowPrice){
				return -1;
			}
			return 0;
		},
		
		"rprice":function(a,b)
		{
			if(a.lowPrice < b.lowPrice)
				return 1;
			else if(a.lowPrice > b.lowPrice)
				return -1;
			return 0;
		},
		
		"az":function(a,b)
		{
			var nameA = a.itemName.toLowerCase();
			var nameB = b.itemName.toLowerCase();
			if(nameA != "" && b.itemName != "") {
				if(nameA > nameB)
					return 1;
				else if(nameA < nameB)
					return -1;
				return 0;
			} else {
				if(a.airlineNameDisplayText > b.airlineNameDisplayText)
					return 1;
				else if(a.airlineNameDisplayText < b.airlineNameDisplayText)
					return -1;
				return 0;			
			}
		},
		
		"raz":function(a,b)
		{
			var nameA = a.itemName.toLowerCase();
			var nameB = b.itemName.toLowerCase();
			if(nameA != "" && b.itemName != "") {
				if(nameA < nameB)
					return 1;
				else if(nameA > nameB)
					return -1;
				return 0;
			} else {
				if(a.airlineNameDisplayText < b.airlineNameDisplayText)
					return 1;
				else if(a.airlineNameDisplayText > b.airlineNameDisplayText)
					return -1;
				return 0;			
			}
		},		
		
		"dist": function(a,b)
		{
			if(a.distance > b.distance)
				return 1;
			else if(a.distance < b.distance)
				return -1;
			return 0;
		},
		
		"rdist": function(a,b)
		{
			if(a.distance < b.distance)
				return 1;
			else if(a.distance > b.distance)
				return -1;
			return 0;
		},
		
		"stops": function(a,b)
		{
			var aTotalStops = a.airItemLegs.leave.numStops;
			if(a.airItemLegs['return']) aTotalStops += a.airItemLegs['return'].numStops;
			var bTotalStops = b.airItemLegs.leave.numStops;
			if(b.airItemLegs['return']) bTotalStops += b.airItemLegs['return'].numStops;
			if(aTotalStops > bTotalStops)
				return 1;
			else if(aTotalStops < bTotalStops)
				return -1;
			else
				return 0;
		},
		
		"rstops": function(a,b)
		{
			var aTotalStops = a.airItemLegs.leave.numStops;
			if(a.airItemLegs['return']) aTotalStops += a.airItemLegs['return'].numStops;
			var bTotalStops = b.airItemLegs.leave.numStops;
			if(b.airItemLegs['return']) bTotalStops += b.airItemLegs['return'].numStops;
			if(aTotalStops < bTotalStops)
				return 1;
			else if(aTotalStops > bTotalStops)
				return -1;
			else
				return 0;
		},
		
		"duration": function(a,b)
		{
			var aMinutes = SortingComparators.getFlightDuration(a);
			var bMinutes = SortingComparators.getFlightDuration(b);
			if(aMinutes > bMinutes)
				return 1;
			else if(aMinutes < bMinutes)
				return -1;
			else
				return 0;
		},
		
		"rduration": function(a,b)
		{
			var aMinutes = SortingComparators.getFlightDuration(a);
			var bMinutes = SortingComparators.getFlightDuration(b);
			if(aMinutes < bMinutes)
				return 1;
			else if(aMinutes > bMinutes)
				return -1;
			else
				return 0;
		},
		
		"getFlightDuration": function(flight){
			var timeParts = flight.airItemLegs.leave.flightDurationText.split(' ');
			var hours = parseInt(timeParts[0].substring(0,timeParts[0].length-1));
			var leaveMinutes = parseInt((timeParts[1].substring(0,timeParts[1].length-1))) + hours * 60;
			var returnMinutes = 0;
			if(flight.airItemLegs['return']) {
				var timeParts = flight.airItemLegs['return'].flightDurationText.split(' ');
				var hours = parseInt(timeParts[0].substring(0,timeParts[0].length-1));
				returnMinutes = parseInt((timeParts[1].substring(0,timeParts[1].length-1))) + hours * 60;
			}
			return leaveMinutes + returnMinutes;
		}
	}
/*
 * Copyright NexTag 2006, 2007
 */
var ResultsManager = Class.create({
	initialize: function(url, callback) {
		
		this.mIsSearchDone = false;
		this.mCrawlerPercentage = 0;
		this.mNumResults = 0;
		this.mCrawlerStatusText = null;
		this.mResultsText = null;
		
		this.mUrl = url;
		this.mCycle = 0;
		this.mRTTravelAjax = null;

		this.mAllowRestore = true;

		this.mMinimumQueryInterval = 5000;		
		this.mLastQueryTime = new Date() - this.mMinimumQueryInterval;

		this.mCallback = callback;		
	},

	save: function() {
		if ( this.mAllowRestore ) {
			$('savedResults').value = this.mResultsText;
			$('numResults').value = this.mNumResults;
			$('isSearchDone').value = this.mIsSearchDone;
			$('crawlerStatusText').value = this.mCrawlerStatusText;
			$('crawlerPercentage').value = this.mCrawlerPercentage;
		}
	},

	restore: function() {
		if ( this.mAllowRestore ) {
			this.mResultsText = $('savedResults').value;	
			this.mIsSearchDone = $('isSearchDone').value;
			this.mNumResults = $('numResults').value;
			this.mCrawlerStatusText = $('crawlerStatusText').value;
			this.mCrawlerPercentage = $('crawlerPercentage').value;
		} 
	},	

	getUrl: function(resultsOptOut) {
		if ( this.mUrl && !this.mUrl.endsWith('&')) this.mUrl = this.mUrl + '&';
		return this.mUrl + '&cycle=' + this.mCycle + '&' + (resultsOptOut ? 
			'tdr=' + resultsOptOut : '');
	},
		
	retrieve: function(resultsOptOut) {
		var currentTime = new Date();
		var timeSinceLastQuery = (currentTime - this.mLastQueryTime);
					
		if ( !this.mLastQueryTime || 
			timeSinceLastQuery >= this.mMinimumQueryInterval ) {
			this.mLastQueryTime = currentTime;

			this.query(resultsOptOut);
		} else {
			this.retrieve.pass(resultsOptOut).delay(1000);
		}
	},
	
	query: function(resultsOptOut) {
		this.mCycle++;
		this.mRTTravelAjax = new Ajax(this.getUrl(resultsOptOut), 
			{
				method: 'get',
				onComplete: this.parseResults.bind(this)
			});
		this.mRTTravelAjax.request();	
	},
	
	parseResults: function() {
		var results = this.mRTTravelAjax.transport.responseXML;
		if ( results ) {
			var documentRoot = results.getElementsByTagName("div")[0];
			this.parse(documentRoot);
		}
		
		this.mCallback.call(); //notify that we're done
	},
	
	parse: function(documentRoot) {

		this.mIsSearchDone = documentRoot.getElementsByTagName("search-finished")[0].
			childNodes[0].nodeValue == 'true';

		this.mNumResults = documentRoot.getElementsByTagName("num-results")[0].
			childNodes[0].nodeValue;
					
		this.mCrawlerStatusText = documentRoot.
			getElementsByTagName("crawler-status-display")[0].
			childNodes[0].nodeValue;
			
		this.mCrawlerPercentage = documentRoot.
			getElementsByTagName("crawler-status-percentage")[0].
			childNodes[0].nodeValue;

		var searchResults = documentRoot.getElementsByTagName('result');
		if ( searchResults && searchResults[0] && searchResults[0].childNodes) {
			this.mResultsText = searchResults[0].
				childNodes[0].nodeValue;
		}

	}
});
var AirResultsManager = ResultsManager.extend({
	parse: function(documentRoot) {
		this.parent(documentRoot);

		var nearbyOriginAirportsNode = documentRoot.
			getElementsByTagName("nearby-origin-airports");
		var nearbyDepartureAirportsNode = documentRoot.
			getElementsByTagName("nearby-destination-airports");
			
		if ( nearbyOriginAirportsNode && nearbyOriginAirportsNode[0]) {
			this.mNearbyOriginAirportsText = nearbyOriginAirportsNode[0].
				childNodes[0].nodeValue;
		}
		
		if ( nearbyDepartureAirportsNode && nearbyDepartureAirportsNode[0]) {
			this.mNearbyDestinationAirportsText = nearbyDepartureAirportsNode[0].
				childNodes[0].nodeValue;
		}
			
	}
});
/*
 * Depends on mootools.86+
 * Copyright NexTag 2006
 */
var incrementResultsCount = 0;
var incrementResultsCountNext = 0;

var PageController = Class.create({
		
	initialize: function() {
		this.mHardResults = null;
		this.mContextResults = null;
		this.mResultFilters = null;

		this.mResultsUIManager = null;
		this.mMapUIManager = null;
		this.mRefinementUIManager = null;
		this.mPaginationUIManager = null;
		this.mGGUIManager = null;
		this.mSkyscraperUIManager = null;
		this.mProgressUIManager = null;
		this.mSortingUIManager = null;
		this.mSearchResultsSummaryUIManager = null;
		this.mErrorUIManager = null;
		
		this.mRefinementProcessor = null;
		this.mSortingProcessor = null;
		
		this.mResultsManager= null;
			
		this.mFeaturedResult = null;
			
		this.mIsDone = false;
		this.mIsWaitDone = false;
				
		this.mMinimumInterstitialUpdateInterval = 1000;
		this.mLastInterstitialUpdateTime = new Date() - 
			this.mMinimumInterstitialUpdateInterval;
		
		this.mMinimumRepaintResults = 30;	
	},
/**/
	/* */	
	getResults: function() {
		var resultsOptOut = this.mHardResults && 
			this.mHardResults.length > 29;
		this.mResultsManager.retrieve(resultsOptOut);
	},
	
	/* */	
	retrievalCallback: function() {
		$('crawler-status').setHTML(this.mResultsManager.mCrawlerStatusText);

		var percentageDone = parseInt(this.mResultsManager.mCrawlerPercentage);
				
		this.mProgressUIManager.updateUI(percentageDone);

		if ( !this.mIsDone ) {
			this.mIsDone = 
				this.mResultsManager.mIsSearchDone || percentageDone >= 100;
		}
		
		var numPastResults = this.mHardResults ? this.mHardResults.length : 0;
		
		this.readResults();
			
		//airfare specific - refactor out
		if ( this.mResultsManager.mNearbyOriginAirportsText ) {
			this.mOriginAirports = 
				Json.evaluate(this.mResultsManager.mNearbyOriginAirportsText);
		}
		
		//airfare specific - refactor out
		if ( this.mResultsManager.mNearbyDestinationAirportsText ) {
			this.mDestinationAirports = 
				Json.evaluate(this.mResultsManager.mNearbyDestinationAirportsText);
		}
		
		if ( !this.mIsDone && !this.mIsWaitDone )  {

			/* */
			if ( this.mHardResults.length > numPastResults &&
				numPastResults < 30) {
				this.renderResults();
			}
			
			this.getResults();
		} else {
			this.display();
		}

	},
	
	pinResult: function(i) {
		this.mPinnedResultsUIManager.mShowClickable = true;
		var pinHotel = this.mResultsUIManager.mResultsToDisplay[i];
		var pinnedResults = this.mPinnedResultsUIManager.mResultsToDisplay;
		if ( !pinnedResults ) {
			pinnedResults = [];
		} 
		if ( !pinnedResults.test(pinHotel) ) pinnedResults.push(pinHotel);
		this.mPinnedResultsUIManager.updateRows( pinnedResults );
	},	
	/* */	
	updateInterstitial: function() {
		if ( this.mIsWaitDone ) return;	
		if ( this.mResultsUIManager.mResultsToDisplay &&
				this.mResultsUIManager.mResultsToDisplay.length > 5 ) {
			if ( (Math.floor(Math.random() * 10) % 5 ) < 3 ) {
				this.mResultsUIManager.shuffle();
			}
			this.mSearchResultsSummaryUIManager.updateUI(this.mHardResults.length);
		} 
	},
	
	/**/
	hideInterstitial: function() {
		$('hsr-l').setStyle('display', 'none');
		$('sv-cs').getElement('h2 span').setHTML('Search Completed');
		$('stop-button').setStyle('display', 'none');
		var progressMessage = $('progress-msg');
		var progressContainer = $('progress-container');
		if ( progressMessage ) progressMessage.remove();
		if ( progressContainer ) progressContainer.remove();
		this.mSearchResultsSummaryUIManager.showPostSearchUI(this.mPaginationUIManager.getCurrentRange());
	},
	
	display: function(restoring) {
		/* */	
		this.mIsWaitDone = true; //explicitly set in case others call this directly
		this.hideInterstitial();
		this.prepareUIManagers(restoring);	
		this.renderRefinements();
		this.refineResults();
		this.renderResultSummary();
		this.renderPagination(restoring);
		this.renderResults(restoring);
		this.save();
		//add google ui
		//add vertical ads 
	},
	
	isFeaturedHotel: function(specificResult) {
		return specificResult['featuredSellers'].length > 0;
	},
	
	populateFeaturedResult: function() {
		/**/
		if ( this.mFeaturedResult ) {
			for(var i = 0; i < this.mHardResults.length; i++ ) {
				var result = this.mHardResults[i];
				if ( result['PTitleId'] == 
					this.mFeaturedResult['PTitleId'] &&
					this.isFeaturedHotel(result) ) {
					result['selected'] = true;
					this.mHardResults.splice(i, 1);
					this.mHardResults.splice(0, 1, result);
				}
			}
		}
	},
	
	prepareUIManagers: function(restoring) {
		if ( $('ad-container') ) $('ad-container').setStyle('display', 'block');
		if ( $('price-disclaimer')) $('price-disclaimer').setStyle('display', 'block');
		this.prepareSponsoredLinks();
		this.mResultsUIManager.mShowClickable = true;	
		this.mResultsUIManager.unshuffle();
		
		this.mRefinementUIManager.setup(this.mHardResults, restoring);
	},
	
	prepareSponsoredLinks: function() { 
		/**/
	},

	renderRefinements: function() {
		this.mRefinementUIManager.updateUI();
	},
	
	renderPagination: function(restoring) {
		this.mPaginationUIManager.updateUI(this.getContextResults().length, 
			restoring);
	},
	
	renderSorting: function() {
		this.mSortingUIManager.updateUI();
	},

	renderMap: function(results) {
		if(this.mMapUIManager)
			this.mMapUIManager.updateUI(results);
	},
	
	renderResultSummary: function() {
		this.mSortingUIManager.updateUI();

		this.mSearchResultsSummaryUIManager.
			updateUI(this.mPaginationUIManager.getCurrentRange()[0]+1,
					this.mPaginationUIManager.getCurrentRange()[1]+1,
					this.mHardResults.length, this.getContextResults().length);	
					
	},
		
	renderResults: function(restoring ) {
		var sliceStart = this.mPaginationUIManager.getCurrentRange()[0];
		var sliceEnd = this.mPaginationUIManager.getCurrentRange()[1] + 1;
		var resultsToDisplay = this.getContextResults().
			slice(sliceStart, sliceEnd);
		if ( restoring ) {
			this.mResultsUIManager.restore();
		} else if ( this.mPaginationUIManager ) {		
			if(resultsToDisplay.length == 0) {
				this.setErrorMessages();
			} else {
				this.mErrorUIManager.hideUI();
			}
			this.mResultsUIManager.updateRows(resultsToDisplay);
			this.mResultsUIManager.save();			
		} else {
			this.renderResults.delay(200);
		}
		this.renderMap(resultsToDisplay);
	},
	
	paginationCallback: function() {
		this.renderResultSummary();
		this.renderResults();
		window.scrollTo(0,0);
	},
	
	refinementCallback: function() {
		this.refineResults();
		this.renderResultSummary();
		this.renderPagination();
		this.renderResults();	
	},
	
	refineResults: function() {
		this.mRefinementUIManager.generateFilters();
		this.mResultFilters = this.mRefinementUIManager.getActiveFilters();
		this.setContextResults(this.mRefinementProcessor.process(
			this.mHardResults,
			this.mResultFilters));
	},
	
	setErrorMessages: function() {
		var filters = this.mRefinementUIManager.getActiveFilters()
		this.mErrorUIManager.setHeader("No " + this.mErrorUIManager.mErrorObjectType + "s were found.<br/>Improve your results by:<br/>");
		this.mErrorUIManager.clearMessages();
		for(key in filters)
		{
			var filterSpan = "";
			var curFilter = filters[key];
			if(curFilter.mFilterBy) {
				if(curFilter.mFilterBy == "amenities") {
					filterSpan += "- Removing your <span style=\"color:red;\">amenities</span> preferences";
				} else if (curFilter.mFilterBy == "chain") {
					filterSpan += "- Removing your <span style=\"color:red;\">hotel chain</span> preference";
				} else if (curFilter.mFilterBy == "starRating") {
					filterSpan += "- Expanding your <span style=\"color:red;\">hotel class</span> preference";
				} else if ( key == 'wsearch' ) {
					filterSpan += "- Changing your keyword search term.";	
				} else if ( curFilter.mFilterBy == 'isMultiStop') { 
					filterSpan += "- Removing your <span style=\"color:red;\">stop</span> preference";
				} else if ( curFilter.mFilterBy == 'airlineCode') {
					filterSpan += "- Removing/Expanding your <span style=\"color:red;\">airline</span> preference";
				} else if ( curFilter.mFilterBy == 'takeOffPlaceText' || 
					curFilter.mFilterBy == 'landingPlaceText') {
					filterSpan += "- Removing/Expanding your <span style=\"color:red;\">airport</span> preference";
					
				}
			} else if(curFilter.mFilterByHigh) {
				if(filters[key].mFilterByHigh == "distance") {
					filterSpan += "- Expanding the <span style=\"color:red;\">distance</span> preference";
				} else if (filters[key].mFilterByLow == "lowPrice"){
					filterSpan += "- Expanding your <span style=\"color:red;\">price</span> range";
				} else if (filters[key].mFilterByLow == 'time') {
					if(filters[key].mItemLocation[0][1] == 'leave' && filters[key].mItemLocation[0][2] == 'takeOffDate') {
						filterSpan += "- Expanding your <span style=\"color:red;\">outbound departure time</span> range";
					} else if(filters[key].mItemLocation[0][1] == 'leave' && filters[key].mItemLocation[0][2] == 'landingDate') {
						filterSpan += "- Expanding your <span style=\"color:red;\">outbound arrival time</span> range";
					} else if(filters[key].mItemLocation[0][1] == 'return' && filters[key].mItemLocation[0][2] == 'takeOffDate') {
						filterSpan += "- Expanding your <span style=\"color:red;\">returning departure time</span> range";
					} else if(filters[key].mItemLocation[0][1] == 'return' && filters[key].mItemLocation[0][2] == 'landingDate') {
						filterSpan += "- Expanding your <span style=\"color:red;\">returning arrival time</span> range";
					}
				} 
			} 
			
			this.mErrorUIManager.addErrorMessage(filterSpan);
		}
		this.mErrorUIManager.updateUI();
		this.mErrorUIManager.showUI();
	},
	
	sortResults: function() {
		this.mSortBy = this.mSortingUIManager.getCurrentSortBy();
		this.mResultFilters = this.mRefinementUIManager.getActiveFilters();
		if(this.mSortBy == "bm"){
			this.refineResults();
		} else {
			this.setContextResults(this.mSortingProcessor.sort(
				this.getContextResults(),this.mSortBy));
		}
	},
	
	sortCallback: function() {
		this.sortResults();
		this.renderSorting();
		this.renderPagination();
		this.renderResults();
		this.renderResultSummary();
	},
	
	readResults: function() {
		this.mHardResults = Json.evaluate(this.mResultsManager.mResultsText);	

		if ( this.mFeaturedResult ) {
			this.mHardResults.unshift(this.mFeaturedResult);
			this.populateFeaturedResult();
		}

		this.setContextResults(this.mHardResults);	

	},
	
	setContextResults: function(contextResults) {
		this.mContextResults = contextResults || [];
	},
	
	getContextResults: function() {
		return this.mContextResults || [];
	},

	restorable: function() {
		return parseInt($('persisting').value) == 1;	
	},
	
	kickoff: function() {
		this.getResults();
		this.mResultsUIManager.setupRows();
		this.mSearchResultsSummaryUIManager.showSearchingUI();
		this.updateInterstitial();
	},
	
/**/	
	start: function() {
		var isRestorable = this.restorable();
		if ( isRestorable ) {
			this.restore();
		} else {
			this.kickoff();
		}
	},
	
	/**/
	save: function() {
		$('persisting').value = 1;
		this.mResultsManager.save();
		
	},
	
	restore: function() {
		if ( parseInt($('persisting').value) != 1 ) return false;

		this.mResultsManager.restore();
		this.readResults();
		
		this.mPaginationUIManager.restore();
		this.display(true);
		
		this.mResultsUIManager.setupRows();

		return true;
	}
});


/* 
 * Copyright NexTag 2006, 2007
 */
var ProgressBar = Class.create({
	initialize: function(barElement, textElement, callback) {
		
		this.mSpeed = 1200;
		this.mIncrement = 1;
		this.mBarElement = barElement;
		this.mTextElement = textElement;
		
		this.mUpdatable = true;
		
		this.mBarMax = 0;
		this.mBarMaxLast = this.mBarMax;
		this.mBarStartValue = this.mBarMax;
		this.mBarValue = this.mBarStartValue;
		
		this.mHasStarted = false;
		this.mCallback = callback;
	},
	
	start: function(startValue, max) { 
		this.mBarMax = startValue;
		this.updateUI(startValue);
		this.updateTo(max); 
		return this;
	},

	/* */	
	updateTo: function(barMaxNew) {
		if ( !this.mHasStarted ) this.progress();
		
		barMaxNew = parseInt(barMaxNew);
		if ( barMaxNew >= 100 ) {
			this.updateUI(100);
			return this;
		}

		if ( barMaxNew > this.mBarMaxLast &&
				barMaxNew > this.mBarValue &&
				barMaxNew > this.mBarMax) {
			this.mBarMaxLast = this.mBarMax;
			this.mBarMax = barMaxNew;
			this.updateUI(this.mBarMaxLast);		
		}

		return this;
	},


	/* */	
	progress: function() {
		this.mHasStarted = true;
		if ( this.mBarValue < this.mBarMax ) {
			this.mBarValue += this.mIncrement;
			this.updateUI(this.mBarValue);
		} 		
		this.progress.delay(this.mSpeed);
		
		return this;
	},
		
	updateUI: function(value) {
		if ( !this.mUpdatable ) return; 
		this.mBarValue = value;
		if ( this.mTextElement ) {
			this.mTextElement.setHTML(this.mBarValue);
			this.mBarElement.setStyle('width', this.mBarValue + '%');
		}	
		if ( this.mCallback ) this.mCallback.call();	
		return this;
	}
});

/**
 *  Keyboard.js
 */
var Keyboard = {
	KEY_BACKSPACE: 8,
	KEY_TAB:       9,
	KEY_RETURN:   13,
	KEY_ESC:      27,
	KEY_LEFT:     37,
	KEY_UP:       38,
	KEY_RIGHT:    39,
	KEY_DOWN:     40,
	KEY_DELETE:   46,
	KEY_HOME:     36,
	KEY_END:      35,
	KEY_PAGEUP:   33,
	KEY_PAGEDOWN: 34
};

/**
 *  AutoSuggester.js
 *  Depends on Keyboard.js, mootools.js
 *
 * CVS $Id: AutoSuggester.js,v 1.1.4.6 2007/02/06 00:01:13 ddurkin Exp $
 *  @author ddurkin
 */
var AutoSuggester = new Class({
	initialize: function(inputNode, url) {
		this.url = url;
		this.inputNode = inputNode;
		if(!this.inputNode || !this.url) {
			return;
		}
		
		this.query = "";
		this.ajaxRequest = null;
		this.suggestions = {};
		this.current = null;
		this.dropDown = null;
		this.dropDownOuter = null;
		this.animateDrop = false;
		this.handledKeyEvent = false;
		
		this.inputNode.addEvent("keyup",this.keyup.bind(this));
		this.inputNode.addEvent("keydown",this.keydown.bind(this));
		this.inputNode.addEvent("click",this.click.bind(this));
		this.inputNode.addEvent("blur",this.blur.bind(this));
		this.inputNode.addEvent("focus",this.focus.bind(this));
		this.inputNode.setAttribute("autocomplete","off");
		
		this.iframe = new Element("iframe");
		this.iframe.frameBorder = "0";
		this.iframe.marginHeight = "0";
		this.iframe.marginWidth = "0";
		this.iframe.scrolling = "no";
		this.iframe.zIndex = 999;
		this.iframe.style.visibility="hidden";
		this.iframe.injectInside(document.body);
	},
	
	paint: function() {
		var regexp = new RegExp("("+this.query+")","gi");
		var firstTime = true;
		if(this.dropDownOuter) {
			firstTime = false;
			this.dropDown = null;
			this.dropDownOuter.remove();
			this.dropDownOuter = null;
			this.iframe.style.visibility="hidden";
		}
		
		var oldCurrent = this.current;
		this.current = null;
		
		if(CommonUtils.isEmpty(this.suggestions)) {
			return;
		}
		
		this.dropDownOuter = new Element("div");
		this.dropDownOuter.addClass("autosuggest-outer");
		this.dropDownOuter.setStyles({
			position: "absolute", 
			top: this.inputNode.getTop() + this.inputNode.offsetHeight + "px", 
			left: this.inputNode.getLeft() + "px",
			zIndex: 1000
		});
		var dropDownShadow = new Element("div");
		dropDownShadow.addClass("autosuggest-shadow");
		this.dropDown = new Element("div");
		this.dropDown.addClass("autosuggest");
		for(var key in this.suggestions) {
			var div = new Element("div");
			if(key.search(regexp) != -1) {
				if(oldCurrent) {
					if(key == oldCurrent.innerHTML) {
						this.setCurrent(div);
					}
				}
				div.addClass("autosuggest-row");
				div.setHTML(key.replace(regexp,"<b>$1</b>"));
				div.addEvent("click",this.selectCurrent.bind(this));
				div.addEvent("mouseover",this.itemMouseOver.bind(this));
				div.injectInside(this.dropDown);
			}
		}
		if(firstTime && this.animateDrop) {
			this.dropDownOuter.style.visibility="hidden";
		}

		this.dropDown.injectInside(dropDownShadow);
		dropDownShadow.injectInside(this.dropDownOuter);
		this.dropDownOuter.injectInside(document.body);
		
		if(firstTime && this.animateDrop) {
			var height = this.dropDownOuter.offsetHeight;
			this.dropDownOuter.effect('height').set(0);
			this.dropDownOuter.style.visibility="visible";
			this.dropDownOuter.effect('height', {duration: 500}).custom(0,height);
		}
		if(!this.current && this.dropDown) {
			this.setCurrent(this.dropDown.getFirst());
		}

		var pos = this.dropDownOuter.getPosition();
		
		this.iframe.setStyles({
			position: "absolute", 
			top: pos.top + "px",
			left: pos.left + "px",
			width: pos.width + "px",
			height: pos.height + "px"
		});
		this.iframe.style.visibility="visible";
		
	},
	
	close: function() {
		if(this.dropDownOuter) {
			this.dropDown = null;
			this.dropDownOuter.remove();
			this.dropDownOuter = null;
			this.iframe.style.visibility="hidden";
		}
		this.setCurrent(null);
	},
	
	selectCurrent: function() {
		if(this.current) {
			this.inputNode.value = this.suggestions[this.current.getText()];
		}
	},
	
	itemMouseOver: function(event) {
		var target = event.target || event.srcElement;
		this.setCurrent(target);
	},
	
	blur: function(event) {
		this.inputNode.hasFocus = false;
		this.close.delay(100,this);
	},
	
	focus: function(event) {
		this.inputNode.hasFocus = true;
	},
	
	keydown: function(event) {
		this.handleKey(event);
		this.handledKeyEvent = true;
	},
	
	keyup: function(event) {
		this.handleKey(event);
		this.handledKeyEvent = false;
		if(this.inputNode.value == this.query) {
			return;
		}
		this.query = this.inputNode.value;
		$clear(this.requestTimer);
		this.requestTimer = this.makeRequest.delay(250,this);
		this.paint();
	},
	
	handleKey: function(event) {
		switch(event.keyCode) {
			case Keyboard.KEY_RETURN:
				if(!this.handledKeyEvent && this.current) this.stopEvent(event);
			case Keyboard.KEY_TAB:
				if(!this.handledKeyEvent) {
					this.selectCurrent();
				}
			case Keyboard.KEY_ESC:
				if(!this.handledKeyEvent) this.close();
				return;
			case Keyboard.KEY_UP:
				if(!this.handledKeyEvent) this.handleUpArrow();
				return;
			case Keyboard.KEY_DOWN:
				if(!this.handledKeyEvent) this.handleDownArrow();
				return;
		}
	},
	
	handleUpArrow: function() {
		if(this.current) {
			this.setCurrent(this.current.getPrevious());
		}
		if(!this.current && this.dropDown) {
			this.setCurrent(this.dropDown.getLast());
		}
	},
	
	handleDownArrow: function() {
		if(this.current) {
			this.setCurrent(this.current.getNext());
		}
		if(!this.current && this.dropDown) {
			this.setCurrent(this.dropDown.getFirst());
		}
	},
	
	click: function(event) {
		this.paint();
	},
	
	makeRequest: function() {
		this.ajaxRequest = new Ajax(this.url + this.query, {
			method: "get",
		    onComplete: this.handleResponse.bind(this)
		});
		this.ajaxRequest.request();
	},
	
	setCurrent: function(node) {
		if(node && (!node.hasClass || !node.hasClass("autosuggest-row"))) {
			this.setCurrent(node.parentNode);
			return;
		}
		if(this.current && this.current.toggleClass) {
			this.current.toggleClass("selected");			
		}
		this.current = node;
		if(this.current && this.current.toggleClass) {
			this.current.toggleClass("selected");			
		}
		return true;
	},
	
	handleResponse: function(responseText, responseXML) {
		if(responseText) {
			this.suggestions = Json.evaluate(responseText);
		}
		if(this.inputNode.hasFocus) {
			this.paint();
		}
	},
	
	stopEvent: function(event) {
		if (event.preventDefault) {
			event.preventDefault();
			event.stopPropagation();
		} else {
			event.returnValue = false;
			event.cancelBubble = true;
		}
	}
	
});


/*
An expandable box, requires mootools and NextagUtils
Author: astromberg
*/

var ExpandableBox = new Class({
	initialize: function(container, itemArray, options)
	{
		this.options(options);
		this.mItemArray = itemArray;
		this.mContainer = $(container);
		this.mContainer.isExBox = true;
		this.mContainer.exBox = this;
		
		this.createLink();
		for(i=0;i<this.mLink.length;i++)
			if(this.mLink[i])
				this.mLink[i].addEvent('click',this.clickAction.bind(this),false);
		
		this.wait(20);
		this.isExpanded = false;
		this.setContainerOverflow();
		this.fixCHeight = true;
		this.mExpandedHeight = (this.mContainer.clientHeight == 0) ? this.mContainer.clientHeight : this.mContainer.scrollHeight;
		if(this.opt.overrideEHeight)
			this.mExpandedHeight = this.opt.overrideEHeight;
		for(i=this.opt.numShow;i<this.mItemArray.length;i++) {
			if($(this.mItemArray[i]))
				$(this.mItemArray[i]).setStyle('display','none');
		}
		this.mCompressedHeight = (this.mContainer.clientHeight == 0) ? this.mContainer.clientHeight : this.mContainer.scrollHeight;
		if(this.opt.overrideCHeight)
			this.mCompressedHeight = this.opt.overrideCHeight;
	},
	
	options: function(options)
	{
	
		this.opt = {
			actionText: ["More","Fewer"],
			useActionText: false,
			numShow: 1,
			onExpand: Class.empty,
			onContract: Class.empty,
			overrideCHeight: false,
			overideEHeight: false,
			slideSpeed: 300
		};
		Object.extend(this.opt, options || {});
	},
		
	createLink: function()
	{
		this.mLink = new Array();
		if(this.opt.optLink != null)
		{
			for(i=0;i<this.opt.optLink.length;i++)
				this.mLink[i] = $(this.opt.optLink[i]);
		}
		else
		{
			this.mMoreBox = new Element('div');
			this.mMoreBox.addClass('fleft');
			this.mLink[0] = new Element('a');
			this.mLink[0].href = "javascript:void(0)";
			this.mLink[0].appendChild( document.createTextNode( this.opt.actionText[0] ) );
			this.mMoreBox.appendChild(this.mLink[0]);
			this.mMoreBox.injectAfter(this.mContainer);
		}
	},
	
	setContainerOverflow: function(){},
	
	clickAction: function(e)
	{
		if(this.fixCHeight && !this.isExpanded)
		{
			if(this.mCompressedHeight != this.mContainer.clientHeight || this.mCompressedHeight != this.mContainer.scrollHeight)
			{
				this.mCompressedHeight = (this.mContainer.clientHeight != 0) ? this.mContainer.clientHeight : this.mContainer.scrollHeight - 35;
				this.mContainer.setStyle('height',this.mCompressedHeight);
			}
			this.fixCHeight = false;
		}
		this.isExpanded = !this.isExpanded;
		if(this.opt.useActionText)
			this.switchLinkText();
		if(this.isExpanded && this.opt.onExpand)
			this.opt.onExpand(this.mContainer.id);
		if(!this.isExpanded && this.opt.onContract)
			this.opt.onContract(this.mContainer.id);
		
		this.transitionHeight();
		
		if(e != null)
			return NextagUtils.stopEvent(e);
	},
	
	setViewableItems: function()
	{
		for(i=this.opt.numShow;i<this.mItemArray.length;i++)
			$(this.mItemArray[i]).setStyle('display',(this.isExpanded) ? "block" : "none");
	},
	
	switchLinkText: function()
	{
		for(i=0;i<this.mLink.length;i++)
			if(this.mLink[i])
				this.mLink[i].firstChild.nodeValue = (this.isExpanded) ? this.opt.actionText[1] : this.opt.actionText[0];
	},
	
	transitionHeight: function()
	{
		//this.mContainer.setStyle('height',(this.isExpanded) ? this.mExpandedHeight + "px" : this.mCompressedHeight + "px");
		this.setViewableItems();
		//this.setParentBoxes();
	},
	
	setParentBoxes: function()
	{
		obj = this.mContainer.parentNode;
		if(obj && obj.isExBox)
		{
			difference = this.mExpandedHeight - this.mCompressedHeight;
			newHeight = (this.isExpanded) ? obj.getStyle('height').toInt()+(this.mExpandedHeight-this.mCompressedHeight) : obj.getStyle('height').toInt() - difference;
			setCompressedHeight = false;
			for(i=0;i<obj.exBox.opt.numShow;i++)
				if(obj.exBox.mItemArray[i] == this.mContainer.id)
					setCompressedHeight = true;

			if(setCompressedHeight)
				obj.exBox.mCompressedHeight = (this.isExpanded) ? obj.exBox.mCompressedHeight + difference : obj.exBox.mCompressedHeight - difference;
			obj.exBox.mExpandedHeight = (this.isExpanded) ? obj.exBox.mExpandedHeight + difference : obj.exBox.mExpandedHeight - difference;
			obj.setStyle('height',newHeight + "px");
		}
		while(obj = obj.parentNode)
		{
			if(obj && obj.isExBox)
			{
				difference = this.mExpandedHeight - this.mCompressedHeight;
				newHeight = (this.isExpanded) ? obj.getStyle('height').toInt()+(this.mExpandedHeight-this.mCompressedHeight) : obj.getStyle('height').toInt() - difference;
				setCompressedHeight = false;
				for(i=0;i<obj.exBox.opt.numShow;i++)
					if(obj.exBox.mItemArray[i] == this.mContainer.id)
						setCompressedHeight = true;
	
				if(setCompressedHeight)
					obj.exBox.mCompressedHeight = (this.isExpanded) ? obj.exBox.mCompressedHeight + difference : obj.exBox.mCompressedHeight - difference;
				obj.exBox.mExpandedHeight = (this.isExpanded) ? obj.exBox.mExpandedHeight + difference : obj.exBox.mExpandedHeight - difference;
				obj.setStyle('height',newHeight + "px");
			}
		}
	},
	
	wait: function(ms)
	{
		date = new Date();
		curDate = null;

		do { curDate = new Date(); }
		while(curDate-date < ms);
	}
});

var SlidingExpandableBox = ExpandableBox.extend(
{
	setContainerOverflow: function()
	{
		this.mContainer.setStyle('overflow','hidden');
	},
	
	transitionHeight: function()
	{
		if(this.isExpanded && this.fixEHeight != null && this.fixEHeight != false)
		{
			this.setViewableItems();
			this.mContainer.setStyle("height",null);
			console.log("Resetting expanded height this round");
			console.log("Old Expanded Height = " + this.mExpandedHeight);
			this.mExpandedHeight = (this.mContainer.clientHeight == 0) ? this.mContainer.clientHeight : this.mContainer.scrollHeight;
			console.log("New Expanded Height = " + this.mExpandedHeight);
			this.mFixEHeight = false;
		}
		else
		{
			range = (this.isExpanded) ? [this.mCompressedHeight,this.mExpandedHeight] : [this.mExpandedHeight,this.mCompressedHeight];
			this.mContainer.effects({'duration':this.opt.slideSpeed,'onComplete':this.setViewableItems.bind(this)}).custom({'height':range});
		}
		//this.setViewableItems();
		this.setParentBoxes();
	},
	
	setViewableItems: function()
	{
		for(i=this.opt.numShow;i<this.mItemArray.length;i++)
			$(this.mItemArray[i]).setStyle('display',(this.isExpanded) ? "block" : "none");
	}
});

var ScrollingExpandableBox = ExpandableBox.extend(
{
	setContainerOverflow: function()
	{
		this.mContainer.setStyle('overflow','auto');
	},
	
	transitionHeight: function()
	{
		this.setViewableItems();
	}
});

/*
Switcher
Takes an array of controller items which control the display of the display items
Relies on mootools and NextagUtils
Author astromberg
*/

var Switcher = new Class({
	initialize: function(displayItems,controlItems,container,options)
	{
		this.options(options);
		
		this.mDisplayItems = displayItems;
		this.mControlItems = controlItems;
		this.mContainer = container;
		this.mDisplayItemHeights = new Array();
		
		for(i=0;i<this.mDisplayItems.length;i++)
			$(this.mDisplayItems[i]).setStyle('display','none');
		
		/*for(i=0;i<this.mDisplayItems.length;i++)
		{
			$(this.mDisplayItems[i]).setStyle('display','block');
			this.mDisplayItemHeights[i] = $(this.mDisplayItems[i]).clientHeight;
			$(this.mDisplayItems[i]).setStyle('display','none');
		}*/
		
		for(i=0;i<this.mControlItems.length;i++)
		{
			$(this.mControlItems[i]).addEvent('click',this.setDisplayItem.bind(this),false);
		}
		this.currentVisible = this.opt.initItemNum;
		this.transitionIn(this.currentVisible);
	},
	
	options: function(options)
	{
		this.opt = {
			initItemNum:1,
			onTransitionIn:Class.empty,
			onTransitionOut:Class.empty
		};
		Object.extend(this.opt, options || {});
	},
	
	setDisplayItem: function(e)
	{
		var targ;
		if (!e) var e = window.event;
		if (e.target) targ = e.target;
		else if (e.srcElement) targ = e.srcElement;
		if (targ.nodeType == 3) // defeat Safari bug
			targ = targ.parentNode;
		
		for(i=0;i<this.mControlItems.length;i++)
			if($(this.mControlItems[i]) == targ)
				this.switchItems(i,this.currentVisible);
		if(e != null)
			return NextagUtils.stopEvent(e);
	},
	
	switchItems: function(newNum,oldNum)
	{
		this.transitionOut(oldNum);
		this.currentVisible = newNum;
		this.transitionIn(newNum);
	},
	
	transitionIn: function(arrayNum)
	{
		$(this.mDisplayItems[this.currentVisible]).setStyle('display','block');
		if(this.opt.onTransitionIn)
			this.opt.onTransitionIn(this.mControlItems[this.currentVisible]);
	},
	
	transitionOut: function(arrayNum)
	{
		$(this.mDisplayItems[this.currentVisible]).setStyle('display','none');
		if(this.opt.onTransitionOut)
			this.opt.onTransitionOut(this.mControlItems[this.currentVisible]);
	}
});

<!-- 
// helper - calendar pair listener
var CalendarParentSlaveChangeListener = (function(){
	function Listener(cal1, cal2){
		var fromCal = cal1;
		var toCal = cal2;
		
		this.dispatchDateChange = function (cal){
			if (cal==null || fromCal == null || toCal == null)
				return;
			if (cal!=fromCal && cal!=toCal)
				return;
			
			var c_date = cal.getDate();
			if ( cal == fromCal ) {
				toCal.setNewDate(new Date(c_date));
			} else if ( cal == toCal ) {
				fromCal.setNewDate(new Date(c_date));
			}
		}
	};

	return Listener;
})();

var travelMenuForm = new Element('div');
travelMenuForm.setProperty('id','travelMenuForm');

var closeElement = new Element('a');
closeElement.setProperty('id','closeTravelMenu');
closeElement.setProperty('class','closePopup');
closeElement.addEvent('click',function(){return;});
closeElement.appendText("close: x");
travelMenuForm.adopt(closeElement);
	

var checkInDateContainer = new Element('div');
checkInDateContainer.setProperty('id','checkInContainer');
checkInDateContainer.appendText("Check-in:");
checkInDateContainer.setProperty('class',"dateContainer");
travelMenuForm.adopt(checkInDateContainer);


var checkOutDateContainer = new Element('div');
checkOutDateContainer.setProperty('id','checkOutContainer');
checkOutDateContainer.appendText("Check-out:");
checkOutDateContainer.setProperty('class',"dateContainer");
travelMenuForm.adopt(checkOutDateContainer);


var checkInBackgroundDiv = new Element('div');
checkInBackgroundDiv.setProperty('class','hotelDate-container');
checkInDateContainer.adopt(checkInBackgroundDiv);
var dateElement1 = new Element('input');
dateElement1.setProperties({ "id":"hotelDate3", "type":"text", "value":"", "size":"11", 'class':'hotelDate' });
dateElement1.setAttribute("name","hotelDate3")
checkInBackgroundDiv.adopt(dateElement1);


var checkOutBackgroundDiv = new Element('div');
checkOutBackgroundDiv.setProperty('class','hotelDate-container');
checkOutDateContainer.adopt(checkOutBackgroundDiv);
var dateElement2 = new Element('input');
dateElement2.setProperties({ "id":"hotelDate4", "type":"text", "value":"", "size":"11", 'class':'hotelDate' });
dateElement2.setAttribute("name","hotelDate4");
checkOutBackgroundDiv.adopt(dateElement2);


var roomElement = new Element('div');
roomElement.setProperty('id','roomsContainer');
roomElement.appendText('Rooms:');
travelMenuForm.adopt(roomElement);

var selectRoomsElement = new Element('select');
selectRoomsElement.setProperties({ "id":"numRoomsSlave"});
selectRoomsElement.setAttribute("name","numRoooms");
for(var numRooms = 1; numRooms <=9; numRooms++) {
	var option = new Element('option');
	option.setProperty('value',numRooms);
	option.appendText(numRooms);
	selectRoomsElement.adopt(option);
}
selectRoomsElement.addEvent('change',function() { 
		document.getElementById('numRooms').value = document.getElementById('numRoomsSlave').value; 
		document.getElementById('adult').value = document.getElementById('numRoomsSlave').value; 
});
travelMenuForm.adopt(selectRoomsElement);

travelMenuForm.adopt(new Element('br'));

var submitElement = new Element('input');
submitElement.setProperties({ "type":"button", "value":"Check Rates", "class":"small-red-button" });
submitElement.setStyles({"margin-top":"5px"});
submitElement.addEvent('click',function(){ 
				var cityInputs = document.getElementsByName('city');
				for( var i = 0; cityInputs != null && i < cityInputs.length; i++ ){
					cityInputs[i].value = "";
				}
				document.getElementById('hotelSearch').submit();
			});
travelMenuForm.adopt(submitElement);

function populateTravelMenu(eventName, id, grpId, pnum) {

	//travelMenuForm.remove();

	var triggerId = id.split("_");

	var contentElementId = "htlDivContent_" + triggerId[1];
	var contentElement = document.getElementById(contentElementId);
	
	document.getElementById('suggested_cities').value =  document.getElementById('htlLocation_' + triggerId[1]).getAttribute('title');
	document.getElementById('hotelPtitle').value = document.getElementById('htlPtitle_' + triggerId[1]).getAttribute('title');
	document.getElementById('hotelName').value = document.getElementById('htlName_' + triggerId[1]).getAttribute('title');
	document.getElementById('suggested_cities').value = document.getElementById('htlSuggested_' + triggerId[1]).getAttribute('title');
	travelMenuForm.injectInside(contentElement);
}

//-->

